/* afni_note.h */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/fcntl.h>
#include <time.h>

/* Defines */

#define MAX_NOTE_LEN 1018	/* maximum command line note for afni_notes 
				   = 1024 - 5 (NOTE) - 1 (\n) */
#define MAXLIN 999
#define MAXSTR 256              /* in /vnmr/psg/acqparms.h */

/***************************** Notes *******************************/

typedef struct NOTE {

  int  notes_exist ;		 /* flag for existence of notes    */

  char datetime[MAXLIN] ;	 /* date and time of note creation */
  char  comment[MAXLIN] ;	 /* comment field                  */

  char afni_note[MAX_NOTE_LEN] ; /* comment field                  */

} NOTE;

/* Prototypes */

NOTE *set_scanner_type(char *scanner_type) ;
int make_afni_note(NOTE *note) ;
char *date_and_time(void) ;
