/*@Start***********************************************************/
/* GEMSBG Include File
 * Copyright (C) 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995 GE Medical Systems
 *
 *    Include File Name:  imagedb.h   
 *    Developer:          David J. Johnson
 *
 * $Source: /apps/cvs/diff/d2a/imagedb.h,v $
 * $Revision: 1.1.1.1 $  $Date: 2004/02/19 16:07:16 $
 */

/*@Synopsis Include file for Image Database Access
*/     

/*@End*********************************************************/

/* only do this once in any given compilation.*/
#ifndef  IMAGEDB_H_INCL
#define  IMAGEDB_H_INCL

#ifndef lint
/*
static char imagedb_h_sccsid[] = "@(#)imagedb.h 1.8 26 Jul 1996 08:56:04 Copyr 1988 GEMSBG";
*/
#endif

#define NO_SUITE_FIELDS 8
#define NO_EXAM_FIELDS 65
#define NO_SERIES_FIELDS 86
#define NO_CTIMAGE_FIELDS 210
#define NO_MRIMAGE_FIELDS 214
#define NO_PROTOCOL_FIELDS 208
#define NO_PATCNTL_FIELDS 2
#define NO_IDBCONTROL_FIELDS 10
#define NO_MODEL_FIELDS 98
#define NO_EXAMUID_FIELDS 1
#define NO_SERIESUID_FIELDS 1
#define NO_CTIMAGEUID_FIELDS 1
#define NO_MRIMAGEUID_FIELDS 1
 
#define RASPOINT float
#define REFCHANTYPE short int
#define IMATRIXTYPE short int
#define DIMXYTYPE float
#define PIXSIZETYPE float
#define BLOCK char
#define ATOMIC long
 
#ifndef dbshared_h_INCL
/*
  this was lifted from dbshared.h to remove the need to
  cm import DBShared for these few definitions
*/
struct VARTYP {
      unsigned long   length;         /* length of the data */
      char *          data;           /* pointer to the data */
};
typedef struct VARTYP VARTYPE;
typedef unsigned char RECKEYLEN;
#endif
typedef struct {
        BLOCK                 su_id [4];          /*Suite ID*/
        short int             su_uniq;            /*Make Unique Flag*/
        char                  su_diskid;          /*Disk ID*/
        char                  prodid [13];        /*Product ID*/
        BLOCK                 su_verscre [2];     /*Genesis Version of Record*/
        BLOCK                 su_verscur [2];     /*Genesis Version of Record*/
        unsigned long         su_checksum;        /*Suite Record Checksum*/
        BLOCK                 su_padding [85];    /*Spare Space*/
}  SUITEDATATYPE ;
 
typedef struct {
        BLOCK                 ex_suid [4];        /*Suite ID for this Exam*/
        short int             ex_uniq;            /*The Make-Unique Flag*/
        char                  ex_diskid;          /*Disk ID for this Exam*/
        unsigned short int    ex_no;              /*Exam Number*/
        char                  hospname [33];      /*Hospital Name*/
        short int             detect;             /*Detector Type*/
        int                   numcells;           /*Number of cells in det*/
        float                 zerocell;           /*Cell number at theta*/
        float                 cellspace;          /*Cell spacing*/
        float                 srctodet;           /*Distance from source to detector*/
        float                 srctoiso;           /*Distance from source to iso*/
        short int             tubetyp;            /*Tube type*/
        short int             dastyp;             /*DAS type*/
        short int             num_dcnk;           /*Number of Decon Kernals*/
        short int             dcn_len;            /*Number of elements in a Decon Kernal*/
        short int             dcn_density;        /*Decon Kernal density*/
        short int             dcn_stepsize;       /*Decon Kernal stepsize*/
        short int             dcn_shiftcnt;       /*Decon Kernal Shift Count*/
        int                   magstrength;        /*Magnet strength (in gauss)*/
        char                  patid [13];         /*Patient ID for this Exam*/
        char                  patname [25];       /*Patient Name*/
        short int             patage;             /*Patient Age (years, months or days)*/
        short int             patian;             /*Patient Age Notation*/
        short int             patsex;             /*Patient Sex*/
        int                   patweight;          /*Patient Weight*/
        short int             trauma;             /*Trauma Flag*/
        char                  hist [61];          /*Patient History*/
        char                  reqnum [13];        /*Requisition Number*/
        int                   ex_datetime;        /*Exam date/time stamp*/
        char                  refphy [33];        /*Referring Physician*/
        char                  diagrad [33];       /*Diagnostician/Radiologist*/
        char                  op [4];             /*Operator*/
        char                  ex_desc [23];       /*Exam Description*/
        char                  ex_typ [3];         /*Exam Type*/
        short int             ex_format;          /*Exam Format*/
        double                firstaxtime;        /*Start time(secs) of first axial in exam*/
#ifdef linux
        char                  rmb_dummy1[4];
#endif
        char                  ex_sysid [9];       /*Creator Suite and Host*/
        int                   ex_lastmod;         /*Date/Time of Last Change*/
        short int             protocolflag;       /*Non-Zero indicates Protocol Exam*/
        char                  ex_alloc_key [13];  /*Process that allocated this record*/
        ATOMIC                ex_delta_cnt;       /*Indicates number of updates to header*/
        BLOCK                 ex_verscre [2];     /*Genesis Version - Created*/
        BLOCK                 ex_verscur [2];     /*Genesis Version - Now*/
        unsigned long         ex_checksum;        /*Exam Record Checksum*/
        ATOMIC                ex_complete;        /*Exam Complete Flag*/
        ATOMIC                ex_seriesct;        /*Last Series Number Used*/
        ATOMIC                ex_numarch;         /*Number of Series Archived*/
        ATOMIC                ex_numseries;       /*Number of Series Existing*/
        VARTYPE               ex_series;          /*Series Keys for this Exam*/
        ATOMIC                ex_numunser;        /*Number of Unstored Series*/
        VARTYPE               ex_unseries;        /*Unstored Series Keys for this Exam*/
        ATOMIC                ex_toarchcnt;       /*Number of Unarchived Series*/
        VARTYPE               ex_toarchive;       /*Unarchived Series Keys for this Exam*/
        ATOMIC                ex_prospcnt;        /*Number of Prospective/Scout Series*/
        VARTYPE               ex_prosp;           /*Prospective/Scout Series Keys for this Exam*/
        ATOMIC                ex_modelnum;        /*Last Model Number used*/
        ATOMIC                ex_modelcnt;        /*Number of ThreeD Models*/
        VARTYPE               ex_models;          /*ThreeD Model Keys for Exam*/
        short int             ex_stat;            /*Patient Status*/
        BLOCK                 uniq_sys_id [16];   /*Unique System ID*/
        BLOCK                 service_id [16];    /*Unique Service ID*/
        BLOCK                 mobile_loc [4];     /*Mobile Location Number*/
        BLOCK                 study_uid [32];     /*Study Entity Unique ID*/
        short int             study_status;       /*indicates if study has complete info(DICOM/genesis)*/
        BLOCK                 ex_padding [516];   /*Spare Space*/
#ifdef linux
        char                  rmb_dummy2[4];
#endif

}  EXAMDATATYPE ;
 
typedef struct {
        BLOCK                 se_suid [4];        /*Suite ID for this Series*/
        short int             se_uniq;            /*The Make-Unique Flag*/
        char                  se_diskid;          /*Disk ID for this Series*/
        unsigned short int    se_exno;            /*Exam Number*/
        short int             se_no;              /*Series Number*/
        int                   se_datetime;        /*Allocation Series Data/Time stamp*/
        int                   se_actual_dt;       /*Actual Series Data/Time stamp*/
        char                  se_desc [30];       /*Series Description*/
        char                  pr_sysid [9];       /*Primary Receiver Suite and Host*/
        char                  pansysid [9];       /*Archiver Suite and Host*/
        short int             se_typ;             /*Series Type*/
        short int             se_source;          /*Series from which prescribed*/
        short int             se_plane;           /*Most-like Plane (for L/S)*/
        short int             scan_type;          /*Scout or Axial (for CT)*/
        int                   position;           /*Patient Position*/
        int                   entry;              /*Patient Entry*/
        char                  anref [3];          /*Anatomical reference*/
        float                 lmhor;              /*Horizontal Landmark*/
        char                  prtcl [25];         /*Scan Protocol Name*/
        short int             se_contrast;        /*Non-zero if > 0 image used contrast(L/S)*/
        char                  start_ras;          /*RAS letter for first scan location (L/S)*/
        float                 start_loc;          /*First scan location (L/S)*/
        char                  end_ras;            /*RAS letter for last scan location (L/S)*/
        float                 end_loc;            /*Last scan location (L/S)*/
        short int             se_pseq;            /*Last Pulse Sequence Used (L/S)*/
        short int             se_sortorder;       /*Image Sort Order (L/S)*/
        int                   se_lndmrkcnt;       /*Landmark Counter*/
        short int             se_nacq;            /*Number of Acquisitions*/
        short int             xbasest;            /*Starting number for baselines*/
        short int             xbaseend;           /*Ending number for baselines*/
        short int             xenhst;             /*Starting number for enhanced scans*/
        short int             xenhend;            /*Ending number for enhanced scans*/
        int                   se_lastmod;         /*Date/Time of Last Change*/
        char                  se_alloc_key [13];  /*Process that allocated this record*/
        ATOMIC                se_delta_cnt;       /*Indicates number of updates to header*/
        BLOCK                 se_verscre [2];     /*Genesis Version - Created*/
        BLOCK                 se_verscur [2];     /*Genesis Version - Now*/
        float                 se_pds_a;           /*PixelData size - as stored*/
        float                 se_pds_c;           /*PixelData size - Compressed*/
        float                 se_pds_u;           /*PixelData size - UnCompressed*/
        unsigned long         se_checksum;        /*Series Record checksum*/
        ATOMIC                se_complete;        /*Series Complete Flag*/
        ATOMIC                se_numarch;         /*Number of Images Archived*/
        ATOMIC                se_imagect;         /*Last Image Number Used*/
        ATOMIC                se_numimages;       /*Number of Images Existing*/
        VARTYPE               se_images;          /*Image Keys for this Series*/
        ATOMIC                se_numunimg;        /*Number of Unstored Images*/
        VARTYPE               se_unimages;        /*Unstored Image Keys for this Series*/
        ATOMIC                se_toarchcnt;       /*Number of Unarchived Images*/
        VARTYPE               se_toarchive;       /*Unarchived Image Keys for this Series*/
        float                 echo1_alpha;        /*Echo 1 Alpha Value*/
        float                 echo1_beta;         /*Echo 1 Beta Value*/
        unsigned short int    echo1_window;       /*Echo 1 Window Value*/
        short int             echo1_level;        /*Echo 1 Level Value*/
        float                 echo2_alpha;        /*Echo 2 Alpha Value*/
        float                 echo2_beta;         /*Echo 2 Beta Value*/
        unsigned short int    echo2_window;       /*Echo 2 Window Value*/
        short int             echo2_level;        /*Echo 2 Level Value*/
        float                 echo3_alpha;        /*Echo 3 Alpha Value*/
        float                 echo3_beta;         /*Echo 3 Beta Value*/
        unsigned short int    echo3_window;       /*Echo 3 Window Value*/
        short int             echo3_level;        /*Echo 3 Level Value*/
        float                 echo4_alpha;        /*Echo 4 Alpha Value*/
        float                 echo4_beta;         /*Echo 4 Beta Value*/
        unsigned short int    echo4_window;       /*Echo 4 Window Value*/
        short int             echo4_level;        /*Echo 4 Level Value*/
        float                 echo5_alpha;        /*Echo 5 Alpha Value*/
        float                 echo5_beta;         /*Echo 5 Beta Value*/
        unsigned short int    echo5_window;       /*Echo 5 Window Value*/
        short int             echo5_level;        /*Echo 5 Level Value*/
        float                 echo6_alpha;        /*Echo 6 Alpha Value*/
        float                 echo6_beta;         /*Echo 6 Beta Value*/
        unsigned short int    echo6_window;       /*Echo 6 Window Value*/
        short int             echo6_level;        /*Echo 6 Level Value*/
        float                 echo7_alpha;        /*Echo 7 Alpha Value*/
        float                 echo7_beta;         /*Echo 7 Beta Value*/
        unsigned short int    echo7_window;       /*Echo 7 Window Value*/
        short int             echo7_level;        /*Echo 7 Level Value*/
        float                 echo8_alpha;        /*Echo 8 Alpha Value*/
        float                 echo8_beta;         /*Echo 8 Beta Value*/
        unsigned short int    echo8_window;       /*Echo 8 Window Value*/
        short int             echo8_level;        /*Echo 8 Level Value*/
        BLOCK                 series_uid [32];    /*Series Entity Unique ID*/
        BLOCK                 landmark_uid [32];  /*Landmark Unique ID*/
        BLOCK                 equipmnt_uid [32];  /*Equipment Unique ID*/
        BLOCK                 se_padding [588];   /*Spare Space*/
}  SERIESDATATYPE ;
 
typedef struct {
        BLOCK                 mo_suid [4];        /*Suite id for this model*/
        short int             mo_uniq;            /*The Make-Unique Flag*/
        char                  mo_diskid;          /*Disk ID for this Model*/
        unsigned short int    mo_exno;            /*Exam number for this model*/
        short int             mo_no;              /*Model Number*/
        ATOMIC                mo_complete;        /*Model Complete Flag*/
        char                  mo_desc [29];       /*Model Description*/
        char                  mo_patid [13];      /*Patient ID (dup of Exam data)*/
        char                  mo_patname [25];    /*Patient Name (dup of Exam data)*/
        int                   mo_datetime;        /*Model Save Date/Time*/
        float                 mo_gantilt;         /*Gantry Tilt (degrees)*/
        int                   mo_position;        /*Patient Position*/
        int                   mo_entry;           /*Patient Entry*/
        PIXSIZETYPE           mo_pixsize_X;       /*Image pixel size - X*/
        PIXSIZETYPE           mo_pixsize_Y;       /*Image pixel size - Y*/
        BLOCK                 mo_firstkey [12];   /*DbKey of first image in set*/
        int                   TRx_start_0;        /*Start value for Threshold Rx 0*/
        int                   TRx_end_0;          /*End value for Threshold Rx 0*/
        int                   TRx_start_1;        /*Start value for Threshold Rx 1*/
        int                   TRx_end_1;          /*End value for Threshold Rx 1*/
        int                   TRx_start_2;        /*Start value for Threshold Rx 2*/
        int                   TRx_end_2;          /*End value for Threshold Rx 2*/
        short int             VRx_cursor_0;       /*Cursor Type for VOI Rx 0*/
        short int             VRx_width_0;        /*Width for VOI Rx 0*/
        short int             VRx_height_0;       /*Height for VOI Rx 0*/
        short int             VRx_ctrX_0;         /*X Center for VOI Rx 0*/
        short int             VRx_ctrY_0;         /*Y Center for VOI Rx 0*/
        int                   VRx_istart_0;       /*Starting Image for VOI Rx 0*/
        int                   VRx_iend_0;         /*Ending Image for VOI Rx 0*/
        short int             VRx_cursor_1;       /*Cursor Type for VOI Rx 1*/
        short int             VRx_width_1;        /*Width for VOI Rx 1*/
        short int             VRx_height_1;       /*Height for VOI Rx 1*/
        short int             VRx_ctrX_1;         /*X Center for VOI Rx 1*/
        short int             VRx_ctrY_1;         /*Y Center for VOI Rx 1*/
        int                   VRx_istart_1;       /*Starting Image for VOI Rx 1*/
        int                   VRx_iend_1;         /*Ending Image for VOI Rx 1*/
        short int             VRx_cursor_2;       /*Cursor Type for VOI Rx 2*/
        short int             VRx_width_2;        /*Width for VOI Rx 2*/
        short int             VRx_height_2;       /*Height for VOI Rx 2*/
        short int             VRx_ctrX_2;         /*X Center for VOI Rx 2*/
        short int             VRx_ctrY_2;         /*Y Center for VOI Rx 2*/
        int                   VRx_istart_2;       /*Starting Image for VOI Rx 2*/
        int                   VRx_iend_2;         /*Ending Image for VOI Rx 2*/
        short int             RRx_cursor_0;       /*Cursor Type for RROI Rx 0*/
        short int             RRx_width_0;        /*Width for RROI Rx 0*/
        short int             RRx_height_0;       /*Height for RROI Rx 0*/
        short int             RRx_ctrX_0;         /*X Center for RROI Rx 0*/
        short int             RRx_ctrY_0;         /*Y Center for RROI Rx 0*/
        int                   RRx_istart_0;       /*Starting Image for RROI Rx 0*/
        int                   RRx_iend_0;         /*Ending Image for RROI Rx 0*/
        short int             RRx_cursor_1;       /*Cursor Type for RROI Rx 1*/
        short int             RRx_width_1;        /*Width for RROI Rx 1*/
        short int             RRx_height_1;       /*Height for RROI Rx 1*/
        short int             RRx_ctrX_1;         /*X Center for RROI Rx 1*/
        short int             RRx_ctrY_1;         /*Y Center for RROI Rx 1*/
        int                   RRx_istart_1;       /*Starting Image for RROI Rx 1*/
        int                   RRx_iend_1;         /*Ending Image for RROI Rx 1*/
        short int             disartic;           /*Disarticulation (>0 is Yes)*/
        int                   prop_mode;          /*Property Mode*/
        float                 aspect_ratio;       /*Aspect Ratio*/
        unsigned short int    node_mask;          /*Node Type Mask*/
        unsigned short int    grad_mask;          /*Gradient Mask*/
        unsigned short int    density_mask;       /*Density Mask*/
        unsigned short int    process_mask;       /*Process Mask*/
        unsigned short int    child_mask;         /*Children Mask*/
        unsigned short int    space_mask;         /*Space Mask*/
        unsigned short int    reduction_00;       /*Reduction Table Entry 0*/
        unsigned short int    reduction_01;       /*Reduction Table Entry 1*/
        unsigned short int    reduction_02;       /*Reduction Table Entry 2*/
        unsigned short int    reduction_03;       /*Reduction Table Entry 3*/
        unsigned short int    reduction_04;       /*Reduction Table Entry 4*/
        unsigned short int    reduction_05;       /*Reduction Table Entry 5*/
        unsigned short int    reduction_06;       /*Reduction Table Entry 6*/
        unsigned short int    reduction_07;       /*Reduction Table Entry 7*/
        unsigned short int    reduction_08;       /*Reduction Table Entry 8*/
        unsigned short int    reduction_09;       /*Reduction Table Entry 9*/
        unsigned short int    reduction_10;       /*Reduction Table Entry 10*/
        unsigned short int    reduction_11;       /*Reduction Table Entry 11*/
        unsigned short int    reduction_12;       /*Reduction Table Entry 12*/
        unsigned short int    reduction_13;       /*Reduction Table Entry 13*/
        unsigned short int    reduction_14;       /*Reduction Table Entry 14*/
        unsigned short int    reduction_15;       /*Reduction Table Entry 15*/
        int                   img_res_mode;       /*Image Resolution Mode*/
        short int             genmode;            /*Model Generation Mode*/
        BLOCK                 rpdid_shape [14];   /*Shape Raw Partition ID*/
        int                   sizeof_shape;       /*Shape Octree Size*/
        BLOCK                 rpdid_grad [14];    /*Gradient Raw Partition ID*/
        int                   sizeof_grad;        /*Gradien Octree Size*/
        BLOCK                 rpdid_dens [14];    /*Density Raw Partition ID*/
        int                   sizeof_dens;        /*Density Octree Size*/
        char                  mo_alloc_key [13];  /*Process that allocated this record*/
        BLOCK                 mo_verscre [2];     /*Genesis Version - Created*/
        BLOCK                 mo_verscur [2];     /*Genesis Version - Now*/
        int                   mo_actual_dt;       /*Actual Series Data/Time stamp*/
        int                   mo_lastmod;         /*Date/Time of Last Change*/
        ATOMIC                image_count;        /*Number of Image Keys in set*/
        VARTYPE               image_list;         /*Image Keys used in set*/
        BLOCK                 mo_padding [629];   /*Spare Space*/
}  MODELDATATYPE ;
 
typedef struct {
        BLOCK                 im_suid [4];        /*Suite id for this image*/
        short int             im_uniq;            /*The Make-Unique Flag*/
        char                  im_diskid;          /*Disk ID for this Image*/
        unsigned short int    im_exno;            /*Exam number for this image*/
        short int             im_seno;            /*Series Number for this image*/
        short int             im_no;              /*Image Number*/
        int                   im_datetime;        /*Allocation Image date/time stamp*/
        int                   im_actual_dt;       /*Actual Image date/time stamp*/
        float                 sctime;             /*Duration of scan*/
        float                 slthick;            /*Slice Thickness (mm)*/
        IMATRIXTYPE           imatrix_X;          /*Image matrix size - X*/
        IMATRIXTYPE           imatrix_Y;          /*Image matrix size - Y*/
        float                 dfov;               /*Display field of view - X (mm)*/
        float                 dfov_rect;          /*Display field of view - Y (if different)*/
        DIMXYTYPE             dim_X;              /*Image dimension - X*/
        DIMXYTYPE             dim_Y;              /*Image dimension - Y*/
        PIXSIZETYPE           pixsize_X;          /*Image pixel size - X*/
        PIXSIZETYPE           pixsize_Y;          /*Image pixel size - Y*/
        BLOCK                 pdid [14];          /*Pixel Data ID*/
        char                  contrastIV [17];    /*IV Contrast Agent*/
        char                  contrastOral [17];  /*Oral Contrast Agent*/
        short int             contmode;           /*Image Contrast Mode*/
        short int             serrx;              /*Series from which prescribed*/
        short int             imgrx;              /*Image from which prescribed*/
        short int             screenformat;       /*Screen Format(8/16 bit)*/
        short int             plane;              /*Plane Type*/
        float                 scanspacing;        /*Spacing between scans (mm?)*/
        short int             im_compress;        /*Image compression type for allocation*/
        short int             im_scouttype;       /*Scout Type (AP or lateral)*/
        char                  loc_ras;            /*RAS letter of image location*/
        float                 loc;                /*Image location*/
        RASPOINT              ctr_R;              /*Center R coord of plane image*/
        RASPOINT              ctr_A;              /*Center A coord of plane image*/
        RASPOINT              ctr_S;              /*Center S coord of plane image*/
        RASPOINT              norm_R;             /*Normal R coord*/
        RASPOINT              norm_A;             /*Normal A coord*/
        RASPOINT              norm_S;             /*Normal S coord*/
        RASPOINT              tlhc_R;             /*R Coord of Top Left Hand Corner*/
        RASPOINT              tlhc_A;             /*A Coord of Top Left Hand Corner*/
        RASPOINT              tlhc_S;             /*S Coord of Top Left Hand Corner*/
        RASPOINT              trhc_R;             /*R Coord of Top Right Hand Corner*/
        RASPOINT              trhc_A;             /*A Coord of Top Right Hand Corner*/
        RASPOINT              trhc_S;             /*S Coord of Top Right Hand Corner*/
        RASPOINT              brhc_R;             /*R Coord of Bottom Right Hand Corner*/
        RASPOINT              brhc_A;             /*A Coord of Bottom Right Hand Corner*/
        RASPOINT              brhc_S;             /*S Coord of Bottom Right Hand Corner*/
        char                  forimgrev [4];      /*Foreign Image Revision*/
        float                 sctstr;             /*Table Start Location*/
        float                 sctend;             /*Table End Location*/
        float                 tblspd;             /*Table Speed (mm/sec)*/
        float                 tblht;              /*Table Height*/
        float                 midstime;           /*Mid Scan Time*/
        short int             midsflag;           /*MidScan flag - does midstime apply for L/S*/
        int                   kvolt;              /*KVolt generator setting*/
        int                   mamp;               /*MAmp generator setting*/
        float                 gantilt;            /*Gantry Tilt (degrees)*/
        int                   azimuth;            /*Degrees of Azimuth*/
        float                 ganvel;             /*Gantry Velocity*/
        int                   ganfilt;            /*Gantry Filter Position*/
        float                 trigon;             /*Trigger on Position*/
        float                 degrot;             /*Degrees of rotation*/
        float                 xrayon;             /*X-Ray On Position*/
        float                 xrayoff;            /*X-Ray Off Position*/
        int                   numtrig;            /*Number of Triggers*/
        unsigned short int    inviews;            /*Total input views*/
        float                 view1ang;           /*Angle of first view*/
        float                 trigfreq;           /*Trigger frequency*/
        int                   trigsrc;            /*DAS trigger source*/
        int                   fpagain;            /*DAS fpa gain*/
        int                   scanopmode;         /*Scan Type*/
        int                   outsrc;             /*DAS output source*/
        int                   adin;               /*DAS ad input*/
        int                   calmode;            /*DAS cal mode*/
        int                   calfreq;            /*DAS cal frequency*/
        int                   regxm;              /*DAS reg xm*/
        int                   autozero;           /*DAS auto zero*/
        short int             sfovtyp;            /*Axial Type*/
        short int             phantsize;          /*Calibration phantom size*/
        short int             phanttyp;           /*Calibration phantom type*/
        short int             filttyp;            /*Calibration filter type*/
        short int             reconalg;           /*Recon Algorithm*/
        short int             perisflag;          /*Perstaltic flag*/
        short int             iboneflag;          /*IterBone flag*/
        short int             statflag;           /*Stat Recon flag*/
        short int             computetyp;         /*Compute Type*/
        short int             segnum;             /*Segment Number*/
        short int             segstotal;          /*Total Number of Segments Requested*/
        float                 isd;                /*Inter scan delay (secs)*/
        float                 sfovmm;             /*Scan field of view (mm)*/
        short int             scannum;            /*Scan Number*/
        short int             viewstrtchan;       /*Starting Channel of View*/
        short int             viewcompfctr;       /*View Compression Factor*/
        unsigned short int    outviews;           /*Total Output Views*/
        unsigned short int    overranges;         /*Number of Overranges*/
        short int             totrefchan;         /*Total Number of Ref Channels*/
        int                   scdatasize;         /*data size for scan data*/
        REFCHANTYPE           refchan1;           /*z or q channel*/
        REFCHANTYPE           refchan2;           /*Reference channel 1*/
        REFCHANTYPE           refchan3;           /*Reference channel 2*/
        REFCHANTYPE           refchan4;           /*Reference channel 3*/
        REFCHANTYPE           refchan5;           /*Reference channel 4*/
        REFCHANTYPE           refchan6;           /*Reference channel 5*/
        short int             postproc;           /*Recon post processing flag*/
        int                   xmpat;              /*DAS xm pattern*/
        short int             rottyp;             /*Prescribed rotation type*/
        short int             rawdataflag;        /*Save Raw Data Flag*/
        float                 ct_scalefact;       /*IBH Image scale factors*/
        short int             ct_water_num;       /*CT Water Number*/
        short int             ct_bone_num;        /*CT Bone Number*/
        float                 bbh_coef1;          /*BBH coefficient 1*/
        float                 bbh_coef2;          /*BBH coefficient 2*/
        float                 bbh_coef3;          /*BBH coefficient 3*/
        short int             bbh_numblend;       /*Num of BBH channels to blend*/
        int                   firstchan;          /*Starting channel*/
        int                   numchan;            /*Number of channels (1..512)*/
        int                   chaninc;            /*Increment between channels*/
        int                   firstview;          /*Starting view*/
        int                   numview;            /*Number of views*/
        int                   viewinc;            /*Increment between views*/
        int                   windowrange;        /*Window Range (0..4095)*/
        float                 scalemin;           /*Scaling value of the image data*/
        float                 scalemax;           /*Scaling value of the image data*/
        int                   datamod;            /*Amount of processing that will be performed*/
        char                  qcalfile [13];      /*Source of the qcal vectors*/
        char                  calmodfile [13];    /*Source of the cal vectors*/
        short int             wordsperview;       /*Number of words per view*/
        char                  rl_ras;             /*RAS letter for side of image*/
        char                  ap_ras;             /*RAS letter for anterior/posterior*/
        char                  sctstr_ras;         /*RAS letter for scout start loc*/
        char                  sctend_ras;         /*RAS letter for scout end loc*/
        char                  sct_anref [3];      /*Anatomical reference for scout*/
        short int             pps_scalwin;        /*PpScan window range for output Scaling*/
        short int             pps_qcalflag;       /*PpScan Qcal modification flag*/
        short int             pps_pcalflag;       /*PpScan Pcal modification flag*/
        short int             pps_thetafix;       /*PpScan Theta Fix (Angle Correction)*/
        short int             pps_bhflag;         /*PpScan Beam Hardening Flag*/
        short int             spot_size;          /*tube focal spot size*/
        short int             spot_pos;           /*tube focal spot position*/
        short int             recondataset;       /*Dependent on #views processed*/
        short int             ndetcellsfov;       /*Field of view in detector cells*/
        double                strtscantime;       /*Start time(secs) of this scan*/
        short int             gandir;             /*Gantry Rotation Direction*/
        short int             rotorspeed;         /*Tube Rotor Speed*/
        short int             trigmode;           /*TGGC Trigger Mode*/
        float                 sitilt;             /*Rx'd gantry tilt - not annotated*/
        float                 targcen_R;          /*R/L coordinate for target recon center*/
        float                 targcen_A;          /*A/P coordinate for target recon center*/
        short int             backprojflag;       /*Value of Back Projection button*/
        short int             fatqestflag;        /*Set if fatq estimates were used*/
        float                 zavg;               /*Z chan avg over views*/
        float                 leftrefavg;         /*avg of left ref chans over views*/
        float                 leftrefmax;         /*max left chan value over views*/
        float                 rightrefavg;        /*avg of right ref chans over views*/
        float                 rightrefmax;        /*max right chan value over views*/
        char                  im_alloc_key [13];  /**/
        int                   im_lastmod;         /*Date/Time of Last Change*/
        BLOCK                 im_verscre [2];     /*Genesis Version - Created*/
        BLOCK                 im_verscur [2];     /*Genesis Version - Now*/
        int                   im_pds_a;           /*PixelData size - as stored*/
        int                   im_pds_c;           /*PixelData size - Compressed*/
        int                   im_pds_u;           /*PixelData size - UnCompressed*/
        unsigned long         im_checksum;        /*AcqRecon record checksum*/
        ATOMIC                im_archived;        /*Image Archive Flag*/
        ATOMIC                im_complete;        /*Image Complete Flag*/
        short int             biop_pos;           /*Biopsy Position*/
        float                 biop_tloc;          /*Biopsy T Location*/
        float                 biop_refloc;        /*Biopsy Ref Location*/
        short int             ref_chan;           /*Reference Channel Used*/
        float                 bp_coef;            /*Back Projector Coefficient*/
        short int             psc;                /*Primary Speed Correction Used*/
        short int             overrng_corr;       /*Overrange Correction Used*/
        float                 dyn_z_alpha;        /*Dynamic Z Alpha Value*/
        char                  ref_img;            /*Reference Image Field*/
        char                  sum_img;            /*Summary Image Field*/
        unsigned short int    img_window;         /*Window Value*/
        short int             img_level;          /*Level Value*/
        int                   slop_int_1;         /*Integer Slop Field 1*/
        int                   slop_int_2;         /*Integer Slop Field 2*/
        int                   slop_int_3;         /*Integer Slop Field 3*/
        int                   slop_int_4;         /*Integer Slop Field 4*/
        int                   slop_int_5;         /*Integer Slop Field 5*/
        float                 slop_float_1;       /*Float Slop Field 1*/
        float                 slop_float_2;       /*Float Slop Field 2*/
        float                 slop_float_3;       /*Float Slop Field 3*/
        float                 slop_float_4;       /*Float Slop Field 4*/
        float                 slop_float_5;       /*Float Slop Field 5*/
        char                  slop_str_1 [16];    /*String Slop Field 1*/
        char                  slop_str_2 [16];    /*String Slop Field 2*/
        float                 deltastart;         /*Delta Start Time*/
        int                   maxOverrange;       /*Max Overranges In A View*/
        float                 avgOverrange;       /*Avg Overranges All Views*/
        short int             afterglow;          /*Corrected Afterglow Terms*/
        unsigned short int    z_blocked;          /*No Views Z Channel Blocked*/
        unsigned short int    ref1_blocked;       /*No Views Ref1 Channel Blocked*/
        unsigned short int    ref2_blocked;       /*No Views Ref2 Channel Blocked*/
        unsigned short int    ref3_blocked;       /*No Views Ref3 Channel Blocked*/
        unsigned short int    ref4_blocked;       /*No Views Ref4 Channel Blocked*/
        unsigned short int    ref5_blocked;       /*No Views Ref5 Channel Blocked*/
        short int             integrity;          /*GE Image Integrity*/
        char                  pitchRatio [8];     /*Scan Pitch Ration*/
        BLOCK                 image_uid [32];     /*Image Unique ID*/
        BLOCK                 sop_uid [32];       /*Service Obj Class Unique ID*/
        float                 xraydelay;          /*Start Scan To Xray On Delay*/
        float                 xrayduration;       /*Duration Of Xray On*/
        int                   vma_mamp;           /*Effective Time based mA*/
        int                   vma_clip;           /*minimum mA allowed for scan*/
        int                   vma_mod;            /*percent modulation for scan*/
        short int             vma_phase;          /*Phase of mA waveform*/
        short int             vma_flag;           /*Smart scan ON/OFF flag*/
        BLOCK                 ct_padding [207];   /*Spare Space*/
}  CTIMAGEDATATYPE ;
 
typedef struct {
        BLOCK                 im_suid [4];        /*Suite id for this image*/
        short int             im_uniq;            /*The Make-Unique Flag*/
        char                  im_diskid;          /*Disk ID for this Image*/
        unsigned short int    im_exno;            /*Exam number for this image*/
        short int             im_seno;            /*Series Number for this image*/
        short int             im_no;              /*Image Number*/
        int                   im_datetime;        /*Allocation Image date/time stamp*/
        int                   im_actual_dt;       /*Actual Image date/time stamp*/
        float                 sctime;             /*Duration of scan*/
        float                 slthick;            /*Slice Thickness (mm)*/
        IMATRIXTYPE           imatrix_X;          /*Image matrix size - X*/
        IMATRIXTYPE           imatrix_Y;          /*Image matrix size - Y*/
        float                 dfov;               /*Display field of view - X (mm)*/
        float                 dfov_rect;          /*Display field of view - Y (if different)*/
        DIMXYTYPE             dim_X;              /*Image dimension - X*/
        DIMXYTYPE             dim_Y;              /*Image dimension - Y*/
        PIXSIZETYPE           pixsize_X;          /*Image pixel size - X*/
        PIXSIZETYPE           pixsize_Y;          /*Image pixel size - Y*/
        BLOCK                 pdid [14];          /*Pixel Data ID*/
        char                  contrastIV [17];    /*IV Contrast Agent*/
        char                  contrastOral [17];  /*Oral Contrast Agent*/
        short int             contmode;           /*Image Contrast Mode*/
        short int             serrx;              /*Series from which prescribed*/
        short int             imgrx;              /*Image from which prescribed*/
        short int             screenformat;       /*Screen Format(8/16 bit)*/
        short int             plane;              /*Plane Type*/
        float                 scanspacing;        /*Spacing between scans (mm?)*/
        short int             im_compress;        /*Image compression type for allocation*/
        short int             im_scouttype;       /*Scout Type (AP or lateral)*/
        char                  loc_ras;            /*RAS letter of image location*/
        float                 loc;                /*Image location*/
        RASPOINT              ctr_R;              /*Center R coord of plane image*/
        RASPOINT              ctr_A;              /*Center A coord of plane image*/
        RASPOINT              ctr_S;              /*Center S coord of plane image*/
        RASPOINT              norm_R;             /*Normal R coord*/
        RASPOINT              norm_A;             /*Normal A coord*/
        RASPOINT              norm_S;             /*Normal S coord*/
        RASPOINT              tlhc_R;             /*R Coord of Top Left Hand Corner*/
        RASPOINT              tlhc_A;             /*A Coord of Top Left Hand Corner*/
        RASPOINT              tlhc_S;             /*S Coord of Top Left Hand Corner*/
        RASPOINT              trhc_R;             /*R Coord of Top Right Hand Corner*/
        RASPOINT              trhc_A;             /*A Coord of Top Right Hand Corner*/
        RASPOINT              trhc_S;             /*S Coord of Top Right Hand Corner*/
        RASPOINT              brhc_R;             /*R Coord of Bottom Right Hand Corner*/
        RASPOINT              brhc_A;             /*A Coord of Bottom Right Hand Corner*/
        RASPOINT              brhc_S;             /*S Coord of Bottom Right Hand Corner*/
        char                  forimgrev [4];      /*Foreign Image Revision*/
        int                   tr;                 /*Pulse repetition time(usec)*/
        int                   ti;                 /*Pulse inversion time(usec)*/
        int                   te;                 /*Pulse echo time(usec)*/
        int                   te2;                /*Second echo echo (usec)*/
        short int             numecho;            /*Number of echoes*/
        short int             echonum;            /*Echo Number*/
        float                 tbldlta;            /*Table Delta*/
        float                 nex;                /*Number of Excitations*/
        short int             contig;             /*Continuous Slices Flag*/
        short int             hrtrate;            /*Cardiac Heart Rate (bpm)*/
        int                   tdel;               /*Delay time after trigger (msec)*/
        float                 saravg;             /*Average SAR*/
        float                 sarpeak;            /*Peak SAR*/
        short int             monsar;             /*Monitor SAR flag*/
        short int             trgwindow;          /*Trigger window (% of R-R interval)*/
        float                 reptime;            /*Cardiac repetition time*/
        short int             imgpcyc;            /*Images per cardiac cycle*/
        short int             xmtgain;            /*Actual Transmit Gain (.1 db)*/
        short int             rcvgain1;           /*Actual Receive Gain Analog (.1 db)*/
        short int             rcvgain2;           /*Actual Receive Gain Digital (.1 db)*/
        short int             mr_flip;            /*Flip Angle for GRASS scans (deg.)*/
        int                   mindat;             /*Minimum Delay after Trigger (uSec)*/
        short int             cphase;             /*Total Cardiac Phase prescribed*/
        short int             swappf;             /*Swap Phase/Frequency Axis*/
        short int             pauseint;           /*Pause Interval (slices)*/
        float                 pausetime;          /*Pause Time*/
        int                   obplane;            /*Oblique Plane*/
        int                   slocfov;            /*Slice Offsets on Freq axis*/
        int                   xmtfreq;            /*Center Frequency (0.1 Hz)*/
        int                   autoxmtfreq;        /*Auto Center Frequency (0.1 Hz)*/
        short int             autoxmtgain;        /*Auto Transmit Gain (0.1 dB)*/
        short int             prescan_r1;         /*PreScan R1 - Analog*/
        short int             prescan_r2;         /*PreScan R2 - Digital*/
        int                   user_bitmap;        /*Bitmap defining user CVs*/
        short int             cenfreq;            /*Center Frequency Method*/
        short int             imode;              /*Imaging Mode*/
        int                   iopt;               /*Imaging Options*/
        short int             pseq;               /*Pulse Sequence*/
        short int             pseqmode;           /*Pulse Sequence Mode*/
        char                  psdname [33];       /*Pulse Sequence Name*/
        int                   psd_datetime;       /*PSD Creation Date and Time*/
        char                  psd_iname [13];     /*PSD name from inside PSD*/
        short int             ctyp;               /*Coil Type*/
        char                  cname [17];         /*Coil Name*/
        short int             surfctyp;           /*Surface Coil Type*/
        short int             surfcext;           /*Extremity Coil Flag*/
        int                   rawrunnum;          /*RawData Run Number*/
        unsigned long         cal_fldstr;         /*Calibrated Field Strength (x10 uGauss)*/
        short int             supp_tech;          /*SAT fat/water/none*/
        float                 vbw;                /*Variable Bandwidth (Hz)*/
        short int             slquant;            /*Number of slices in this scan group*/
        short int             gpre;               /*Graphically prescribed*/
        int                   intr_del;           /*Interimage/interloc delay (uSec)*/
        float                 user0;              /*User Variable 0*/
        float                 user1;              /*User Variable 1*/
        float                 user2;              /*User Variable 2*/
        float                 user3;              /*User Variable 3*/
        float                 user4;              /*User Variable 4*/
        float                 user5;              /*User Variable 5*/
        float                 user6;              /*User Variable 6*/
        float                 user7;              /*User Variable 7*/
        float                 user8;              /*User Variable 8*/
        float                 user9;              /*User Variable 9*/
        float                 user10;             /*User Variable 10*/
        float                 user11;             /*User Variable 11*/
        float                 user12;             /*User Variable 12*/
        float                 user13;             /*User Variable 13*/
        float                 user14;             /*User Variable 14*/
        float                 user15;             /*User Variable 15*/
        float                 user16;             /*User Variable 16*/
        float                 user17;             /*User Variable 17*/
        float                 user18;             /*User Variable 18*/
        float                 user19;             /*User Variable 19*/
        float                 user20;             /*User Variable 20*/
        float                 user21;             /*User Variable 21*/
        float                 user22;             /*User Variable 22*/
        float                 user23;             /*Projection Angle*/
        float                 user24;             /*Concat Sat Type Flag*/
        char                  im_alloc_key [13];  /**/
        int                   im_lastmod;         /*Date/Time of Last Change*/
        BLOCK                 im_verscre [2];     /*Genesis Version - Created*/
        BLOCK                 im_verscur [2];     /*Genesis Version - Now*/
        int                   im_pds_a;           /*PixelData size - as stored*/
        int                   im_pds_c;           /*PixelData size - Compressed*/
        int                   im_pds_u;           /*PixelData size - UnCompressed*/
        unsigned long         im_checksum;        /*AcqRecon record checksum*/
        ATOMIC                im_archived;        /*Image Archive Flag*/
        ATOMIC                im_complete;        /*Image Complete Flag*/
        short int             satbits;            /*Bitmap of SAT selections*/
        short int             scic;               /*Surface Coil Intensity Correction Flag*/
        short int             satxloc1;           /*R-side SAT pulse loc rel to lndmrk*/
        short int             satxloc2;           /*L-side SAT pulse loc rel to lndmrk*/
        short int             satyloc1;           /*A-side SAT pulse loc rel to lndmrk*/
        short int             satyloc2;           /*P-side SAT pulse loc rel to lndmrk*/
        short int             satzloc1;           /*S-side SAT pulse loc rel to lndmrk*/
        short int             satzloc2;           /*I-side SAT pulse loc rel to lndmrk*/
        short int             satxthick;          /*Thickness of X-axis SAT pulse*/
        short int             satythick;          /*Thickness of Y-axis SAT pulse*/
        short int             satzthick;          /*Thickness of Z-axis SAT pulse*/
        short int             flax;               /*Phase contrast flow axis*/
        short int             venc;               /*Phase contrast velocity encoding*/
        short int             thk_disclmr;        /*Slice Thickness*/
        short int             ps_flag;            /*Auto/Manual Prescan flag*/
        short int             ps_status;          /*Bitmap of changed values*/
        short int             image_type;         /*Magnitude, Phase, Imaginary, or Real*/
        short int             vas_collapse;       /*Collapse Image*/
        float                 user23n;            /*User Variable 23*/
        float                 user24n;            /*User Variable 24*/
        short int             proj_alg;           /*Projection Algorithm*/
        char                  proj_name [13];     /*Projection Algorithm Name*/
        float                 x_axis_rot;         /*X Axis Rotation*/
        float                 y_axis_rot;         /*Y Axis Rotation*/
        float                 z_axis_rot;         /*Z Axis Rotation*/
        int                   thresh_min1;        /*Lower Range of Pixels 1*/
        int                   thresh_max1;        /*Upper Range of Pixels 1*/
        int                   thresh_min2;        /*Lower Range of Pixels 2*/
        int                   thresh_max2;        /*Upper Range of Pixels 2*/
        short int             echo_trn_len;       /*Echo Train Length for Fast Spin Echo*/
        short int             frac_echo;          /*Fractional Echo - Effective TE Flag*/
        short int             prep_pulse;         /*Preporatory Pulse Option*/
        short int             cphasenum;          /*Cardiac Phase Number*/
        short int             var_echo;           /*Variable Echo Flag*/
        char                  ref_img;            /*Reference Image Field*/
        char                  sum_img;            /*Summary Image Field*/
        unsigned short int    img_window;         /*Window Value*/
        short int             img_level;          /*Level Value*/
        int                   slop_int_1;         /*Number of 3D Slabs*/
        int                   slop_int_2;         /*Slice Locs Per 3D Slab*/
        int                   slop_int_3;         /*# of Slice Locs on Each Slab Which Overlap Neighbors*/
        int                   slop_int_4;         /*Image Filtering 0.5/0.2T*/
        int                   slop_int_5;         /*Integer Slop Field 5*/
        float                 slop_float_1;       /*Float Slop Field 1*/
        float                 slop_float_2;       /*Float Slop Field 2*/
        float                 slop_float_3;       /*Float Slop Field 3*/
        float                 slop_float_4;       /*Float Slop Field 4*/
        float                 slop_float_5;       /*Float Slop Field 5*/
        char                  slop_str_1 [16];    /*String Slop Field 1*/
        char                  slop_str_2 [16];    /*String Slop Field 2*/
        short int             scanactno;          /*Scan Acquisition Number*/
        short int             vasflags;           /*Magnitude Weighting Flag*/
        float                 vencscale;          /*Scale Weighted Venc*/
        short int             integrity;          /*GE Image Integrity*/
        int                   fphase;             /*Number Of Phases*/
        short int             freq_dir;           /*Frequency Direction*/
        short int             vas_mode;           /*Vascular Mode*/
        BLOCK                 image_uid [32];     /*Image Unique ID*/
        BLOCK                 sop_uid [32];       /*Service Obj Class Unique ID*/
        short int             dont_use_1;         /*This field is not used*/
        short int             dont_use_2;         /*This field is not used*/
        short int             dont_use_3;         /*This field is not used*/
        short int             pscopts;            /*bitmap of prescan options*/
        short int             asoffsetx;          /*gradient offset in X-direction*/
        short int             asoffsety;          /*gradient offset in Y-direction*/
        short int             asoffsetz;          /*gradient offset in Z-direction*/
        short int             unoriginal;         /*identifies image as original or unoriginal*/
        short int             interleaves;        /*number of EPI shots*/
        short int             effechospace;       /*effective echo spacing for EPI*/
        short int             viewsperseg;        /*views per segment*/
        short int             rbpm;               /*respiratory rate, breaths per min*/
        short int             rtpoint;            /*respiratory trigger point as percent of max.*/
        short int             rcvrtype;           /*type of receiver used*/
        float                 dbdt;               /*peak rate of change of gradient field, tesla/sec*/
        float                 dbdtper;            /*limit in units of percent of theoretical curve*/
        float                 estdbdtper;         /*PSD estimated limit in units of percent*/
        float                 estdbdtts;          /*PSD estimated limit in Teslas/sec*/
        float                 saravghead;         /*Avg head SAR*/
        float                 neg_scanspacing;    /*Negative scan spacing for overlap slices*/ 
        int                   offsetfreq;         /*Offset Frequency - Mag.Transfer*/
        unsigned long         user_usage_tag;     /*Defines how following user CVs are to be filled in*/
                                                  /*Default value = 0x00000000*/
                                                  /*GE range = 0x00000001 - 0x7fffffff*/
                                                  /*Research = 0x80000000 - 0xffffffff*/
        unsigned long         user_fill_mapMSW;   /*Define what process fills in the user CVs, ifcc or TIR*/
        unsigned long         user_fill_mapLSW;   /*Define what process fills in the user CVs, ifcc or TIR*/


        float                 user25;             /*User Variable 25*/
        float                 user26;             /*User Variable 26*/
        float                 user27;             /*User Variable 27*/
        float                 user28;             /*User Variable 28*/
        float                 user29;             /*User Variable 29*/
        float                 user30;             /*User Variable 30*/
        float                 user31;             /*User Variable 31*/
        float                 user32;             /*User Variable 32*/
        float                 user33;             /*User Variable 33*/
        float                 user34;             /*User Variable 34*/
        float                 user35;             /*User Variable 35*/
        float                 user36;             /*User Variable 36*/
        float                 user37;             /*User Variable 37*/
        float                 user38;             /*User Variable 38*/
        float                 user39;             /*User Variable 39*/
        float                 user40;             /*User Variable 40*/
        float                 user41;             /*User Variable 41*/
        float                 user42;             /*User Variable 42*/
        float                 user43;             /*User Variable 43*/
        float                 user44;             /*User Variable 44*/
        float                 user45;             /*User Variable 45*/
        float                 user46;             /*User Variable 46*/
        float                 user47;             /*User Variable 47*/
        float                 user48;             /*User Variable 48*/
        int                   slop_int_6;         /*Integer Slop Field 6*/
        int                   slop_int_7;         /*Integer Slop Field 7*/
        int                   slop_int_8;         /*Integer Slop Field 8*/
        int                   slop_int_9;         /*Integer Slop Field 9*/

        BLOCK                 mr_padding [32];    /*Spare Space*/

}  MRIMAGEDATATYPE ;
 
typedef struct {
        BLOCK                 im_suid [4];        /*Suite id for this image*/
        short int             im_uniq;            /*The Make-Unique Flag*/
        char                  im_diskid;          /*Disk ID for this Image*/
        unsigned short int    im_exno;            /*Exam number for this image*/
        short int             im_seno;            /*Series Number for this image*/
        short int             im_no;              /*Image Number*/
        int                   im_datetime;        /*Allocation Image date/time stamp*/
        int                   im_actual_dt;       /*Actual Image date/time stamp*/
        float                 sctime;             /*Duration of scan*/
        float                 slthick;            /*Slice Thickness (mm)*/
        IMATRIXTYPE           imatrix_X;          /*Image matrix size - X*/
        IMATRIXTYPE           imatrix_Y;          /*Image matrix size - Y*/
        float                 dfov;               /*Display field of view - X (mm)*/
        float                 dfov_rect;          /*Display field of view - Y (if different)*/
        DIMXYTYPE             dim_X;              /*Image dimension - X*/
        DIMXYTYPE             dim_Y;              /*Image dimension - Y*/
        PIXSIZETYPE           pixsize_X;          /*Image pixel size - X*/
        PIXSIZETYPE           pixsize_Y;          /*Image pixel size - Y*/
        BLOCK                 pdid [14];          /*Pixel Data ID*/
        char                  contrastIV [17];    /*IV Contrast Agent*/
        char                  contrastOral [17];  /*Oral Contrast Agent*/
        short int             contmode;           /*Image Contrast Mode*/
        short int             serrx;              /*Series from which prescribed*/
        short int             imgrx;              /*Image from which prescribed*/
        short int             screenformat;       /*Screen Format(8/16 bit)*/
        short int             plane;              /*Plane Type*/
        float                 scanspacing;        /*Spacing between scans (mm?)*/
        short int             im_compress;        /*Image compression type for allocation*/
        short int             im_scouttype;       /*Scout Type (AP or lateral)*/
        float                 sctstr;             /*Table Start Location*/
        float                 sctend;             /*Table End Location*/
        float                 tblspd;             /*Table Speed (mm/sec)*/
        float                 tblht;              /*Table Height*/
        float                 midstime;           /*Mid Scan Time*/
        short int             midsflag;           /*MidScan flag - does midstime apply for L/S*/
        int                   kvolt;              /*KVolt generator setting*/
        int                   mamp;               /*MAmp generator setting*/
        float                 gantilt;            /*Gantry Tilt (degrees)*/
        int                   azimuth;            /*Degrees of Azimuth*/
        float                 ganvel;             /*Gantry Velocity*/
        int                   ganfilt;            /*Gantry Filter Position*/
        float                 trigon;             /*Trigger on Position*/
        float                 degrot;             /*Degrees of rotation*/
        float                 xrayon;             /*X-Ray On Position*/
        float                 xrayoff;            /*X-Ray Off Position*/
        int                   numtrig;            /*Number of Triggers*/
        unsigned short int    inviews;            /*Total input views*/
        float                 view1ang;           /*Angle of first view*/
        float                 trigfreq;           /*Trigger frequency*/
        int                   trigsrc;            /*DAS trigger source*/
        int                   fpagain;            /*DAS fpa gain*/
        int                   scanopmode;         /*Scan Type*/
        int                   outsrc;             /*DAS output source*/
        int                   adin;               /*DAS ad input*/
        int                   calmode;            /*DAS cal mode*/
        int                   calfreq;            /*DAS cal frequency*/
        int                   regxm;              /*DAS reg xm*/
        int                   autozero;           /*DAS auto zero*/
        short int             sfovtyp;            /*Axial Type*/
        short int             phantsize;          /*Calibration phantom size*/
        short int             phanttyp;           /*Calibration phantom type*/
        short int             filttyp;            /*Calibration filter type*/
        short int             reconalg;           /*Recon Algorithm*/
        short int             perisflag;          /*Perstaltic flag*/
        short int             iboneflag;          /*IterBone flag*/
        short int             statflag;           /*Stat Recon flag*/
        short int             computetyp;         /*Compute Type*/
        short int             segnum;             /*Segment Number*/
        short int             segstotal;          /*Total Number of Segments Requested*/
        float                 isd;                /*Inter scan delay (secs)*/
        float                 sfovmm;             /*Scan field of view (mm)*/
        short int             scannum;            /*Scan Number*/
        short int             viewstrtchan;       /*Starting Channel of View*/
        short int             viewcompfctr;       /*View Compression Factor*/
        unsigned short int    outviews;           /*Total Output Views*/
        unsigned short int    overranges;         /*Number of Overranges*/
        short int             totrefchan;         /*Total Number of Ref Channels*/
        int                   scdatasize;         /*data size for scan data*/
        REFCHANTYPE           refchan1;           /*z or q channel*/
        REFCHANTYPE           refchan2;           /*Reference channel 1*/
        REFCHANTYPE           refchan3;           /*Reference channel 2*/
        REFCHANTYPE           refchan4;           /*Reference channel 3*/
        REFCHANTYPE           refchan5;           /*Reference channel 4*/
        REFCHANTYPE           refchan6;           /*Reference channel 5*/
        short int             postproc;           /*Recon post processing flag*/
        int                   xmpat;              /*DAS xm pattern*/
        short int             rottyp;             /*Prescribed rotation type*/
        short int             rawdataflag;        /*Save Raw Data Flag*/
        float                 ct_scalefact;       /*IBH Image scale factors*/
        short int             ct_water_num;       /*CT Water Number*/
        short int             ct_bone_num;        /*CT Bone Number*/
        float                 bbh_coef1;          /*BBH coefficient 1*/
        float                 bbh_coef2;          /*BBH coefficient 2*/
        float                 bbh_coef3;          /*BBH coefficient 3*/
        short int             bbh_numblend;       /*Num of BBH channels to blend*/
        int                   firstchan;          /*Starting channel*/
        int                   numchan;            /*Number of channels (1..512)*/
        int                   chaninc;            /*Increment between channels*/
        int                   firstview;          /*Starting view*/
        int                   numview;            /*Number of views*/
        int                   viewinc;            /*Increment between views*/
        int                   windowrange;        /*Window Range (0..4095)*/
        float                 scalemin;           /*Scaling value of the image data*/
        float                 scalemax;           /*Scaling value of the image data*/
        int                   datamod;            /*Amount of processing that will be performed*/
        char                  qcalfile [13];      /*Source of the qcal vectors*/
        char                  calmodfile [13];    /*Source of the cal vectors*/
        short int             wordsperview;       /*Number of words per view*/
        char                  rl_ras;             /*RAS letter for side of image*/
        char                  ap_ras;             /*RAS letter for anterior/posterior*/
        char                  sctstr_ras;         /*RAS letter for scout start loc*/
        char                  sctend_ras;         /*RAS letter for scout end loc*/
        char                  sct_anref [3];      /*Anatomical reference for scout*/
        short int             pps_scalwin;        /*PpScan window range for output Scaling*/
        short int             pps_qcalflag;       /*PpScan Qcal modification flag*/
        short int             pps_pcalflag;       /*PpScan Pcal modification flag*/
        short int             pps_thetafix;       /*PpScan Theta Fix (Angle Correction)*/
        short int             pps_bhflag;         /*PpScan Beam Hardening Flag*/
        short int             spot_size;          /*tube focal spot size*/
        short int             spot_pos;           /*tube focal spot position*/
        short int             recondataset;       /*Dependent on #views processed*/
        short int             ndetcellsfov;       /*Field of view in detector cells*/
        double                strtscantime;       /*Start time(secs) of this scan*/
        short int             gandir;             /*Gantry Rotation Direction*/
        short int             rotorspeed;         /*Tube Rotor Speed*/
        short int             trigmode;           /*TGGC Trigger Mode*/
        float                 sitilt;             /*Rx'd gantry tilt - not annotated*/
        float                 targcen_R;          /*R/L coordinate for target recon center*/
        float                 targcen_A;          /*A/P coordinate for target recon center*/
        short int             backprojflag;       /*Value of Back Projection button*/
        short int             fatqestflag;        /*Set if fatq estimates were used*/
        float                 zavg;               /*Z chan avg over views*/
        float                 leftrefavg;         /*avg of left ref chans over views*/
        float                 leftrefmax;         /*max left chan value over views*/
        float                 rightrefavg;        /*avg of right ref chans over views*/
        float                 rightrefmax;        /*max right chan value over views*/
        short int             numscan;            /*Number of scans*/
        short int             collectdata;        /*Collect Data Flag*/
        float                 isetd;              /*InterSet Delay*/
        float                 prepd;              /*Prep Delay*/
        int                   pbtimout;           /*Push Button Timeout*/
        short int             graphicflag;        /*Graphic RX flag*/
        short int             autoscanflag;       /*AutoScan flag*/
        unsigned short int    startview;          /*View number within a scanfile to start*/
        unsigned short int    numviews;           /*Total number of views to be processed*/
        short int             rtsflag;            /*real-time statistics flag*/
        int                   kvcounts;           /*kv scan counts*/
        int                   kvprecounts;        /*kv prescan counts*/
        int                   macounts;           /*ma scan counts*/
        int                   maprecounts;        /*ma prescan counts*/
        char                  im_alloc_key [13];  /**/
        int                   im_lastmod;         /*Date/Time of Last Change*/
        BLOCK                 im_verscre [2];     /*Genesis Version - Created*/
        BLOCK                 im_verscur [2];     /*Genesis Version - Now*/
        int                   im_pds_a;           /*PixelData size - as stored*/
        int                   im_pds_c;           /*PixelData size - Compressed*/
        int                   im_pds_u;           /*PixelData size - UnCompressed*/
        unsigned long         im_checksum;        /*AcqRecon record checksum*/
        ATOMIC                im_archived;        /*Image Archive Flag*/
        float                 axial_start;        /*Axial Start Location*/
        float                 axial_end;          /*Axial End Location*/
        short int             biop_pos;           /*Biopsy Position*/
        float                 biop_tloc;          /*Biopsy T Location*/
        float                 biop_refloc;        /*Biopsy Ref Location*/
        BLOCK                 pr_padding [22];    /*Spare Space*/
        short int             ref_chan;           /*Reference Channel Used*/
        float                 bp_coef;            /*Back Projector Coefficient*/
        short int             psc;                /*Primary Speed Correction Used*/
        short int             overrng_corr;       /*Overrange Correction Used*/
        float                 dyn_z_alpha;        /*Dynamic Z Alpha Value*/
        char                  ref_img;            /*Reference Image Field*/
        char                  sum_img;            /*Summary Image Field*/
        unsigned short int    img_window;         /*Window Value*/
        short int             img_level;          /*Level Value*/
        int                   slop_int_1;         /*number of 3D slabs*/
        int                   slop_int_2;         /*slice locs per 3D slab*/
        int                   slop_int_3;         /*# of slice locations on each end of slabs which overlap its neighbors*/
        int                   slop_int_4;         /*Integer Slop Field 4*/
        int                   slop_int_5;         /*Integer Slop Field 5*/
        float                 slop_float_1;       /*Float Slop Field 1*/
        float                 slop_float_2;       /*Float Slop Field 2*/
        float                 slop_float_3;       /*Float Slop Field 3*/
        float                 slop_float_4;       /*Float Slop Field 4*/
        float                 slop_float_5;       /*Float Slop Field 5*/
        char                  slop_str_1 [16];    /*String Slop Field 1*/
        char                  slop_str_2 [16];    /*String Slop Field 2*/
        float                 deltastart;         /*Delta Start Time*/
        int                   maxOverrange;       /*Max Overranges In A View*/
        float                 avgOverrange;       /*Avg Overranges All Views*/
        short int             afterglow;          /*Corrected Afterglow Terms*/
        unsigned short int    z_blocked;          /*No Views Z Channel Blocked*/
        unsigned short int    ref1_blocked;       /*No Views Ref1 Channel Blocked*/
        unsigned short int    ref2_blocked;       /*No Views Ref2 Channel Blocked*/
        unsigned short int    ref3_blocked;       /*No Views Ref3 Channel Blocked*/
        unsigned short int    ref4_blocked;       /*No Views Ref4 Channel Blocked*/
        unsigned short int    ref5_blocked;       /*No Views Ref5 Channel Blocked*/
        short int             integrity;          /*GE Image Integrity*/
        char                  pitchRatio [8];     /*Scan Pitch Ration*/
        BLOCK                 image_uid [32];     /*Image Unique ID*/
        BLOCK                 sop_uid [32];       /*Service Obj Class Unique ID*/
        float                 xraydelay;          /*Start Scan To Xray On Delay*/
        float                 xrayduration;       /*Duration Of Xray On*/
        int                   vma_mamp;           /*Effective Time based mA*/
        int                   vma_clip;           /*minimum mA allowed for scan*/
        int                   vma_mod;            /*percent modulation for scan*/
        short int             vma_phase;          /*Phase of mA waveform*/
        short int             vma_flag;           /*Smart scan ON/OFF flag*/
        BLOCK                 ct_padding [207];   /*Spare Space*/
}  PROTOCOLDATATYPE ;
 
typedef struct {
        ATOMIC                su_cnt;             /*ListField count for su_list*/
        VARTYPE               su_list;            /*ListField for Suite Allocation*/
        ATOMIC                ex_cnt;             /*ListField count for ex_list*/
        VARTYPE               ex_list;            /*ListField for Exam Allocation*/
        ATOMIC                se_cnt;             /*ListField count for se_list*/
        VARTYPE               se_list;            /*ListField for Series Allocation*/
        ATOMIC                im_cnt;             /*ListField count for im_list*/
        VARTYPE               im_list;            /*ListField for Image Allocation*/
        ATOMIC                pd_cnt;             /*ListField count for pd_list*/
        VARTYPE               pd_list;            /*ListField for PixelData Allocation*/
}  IDBCONTROLDATATYPE ;
 
typedef struct {
        BLOCK                 exam_key [8];       /*The Exam Key*/
}  EXAMUIDDATATYPE ;
 
typedef struct {
        BLOCK                 series_key [10];    /*The Series Key*/
}  SERIESUIDDATATYPE ;
 
typedef struct {
        BLOCK                 ctimage_key [12];   /*The CT Image Key*/
}  CTIMAGEUIDDATATYPE ;
 
typedef struct {
        BLOCK                 mrimage_key [12];   /*The MR Image Key*/
}  MRIMAGEUIDDATATYPE ;
 
/* 03/18/91 KCH - New for Inter-Rev Compatibility */
/* Bumped up the revision from 07 to 08 for MRIge42249 joshi@mr 97fw45.1 */

#define GENESIS_DATABASE_REVISION	"08"

/* This is now defined in idb_globals.h 
typedef id DBKEY;		
the Image Database Key as an Object*/

#define MG_NO 		"mg_no"

#define NEXT 1
#define PRIOR -1
#define FSFI 10
#define FSLI 20
#define LSFI 30
#define LSLI 40

typedef struct {
		unsigned short int numOfRecKeys;
		RECKEYLEN	   recKeyLen;
		char		   key[6];
		} PCKeyBuffer;

#define FILLED		1
#define NOTFILLED	0

#define CTIMAGEKEYS	1
#define MRIMAGEKEYS	2
#define PROTOCOLKEYS	3

#define numslabs slop_int_1
#define locsperslab slop_int_2
#define overlaps slop_int_3

/* Added by Ramanath P for DWEPI */
#define dfax slop_int_5
#define bvalue slop_int_6

#define BECOME_OK	0
#define BECOME_DONE	1
#define BECOME_ERROR	-1

#define BECOME_RETURN(_X) \
	(theRKLen == _X) ? BECOME_DONE : BECOME_OK

/* This is now defined in idb_globals.h 
#define FA_OPEN(_fd,_cnt) \
			_fd = [FieldsDesc new: _cnt]
#define FA_ADD(_fd,_str,_name,_NAME) \
			[_fd addByteField: _NAME offset: OFFSET(_name,_str)]
#define FA_CLOSE(_fd,_str) \
	   		[_fd sealWithLength: sizeof(_str)]
*/

#define SUITEKEYTYPE	4
#define EXAMKEYTYPE	3
#define SERIESKEYTYPE	2
#define IMAGEKEYTYPE	1

#define DB_LOG_ERRORS		1
#define DB_DONT_LOG_ERRORS	0

/*   Definitions for Patient Control Information   */

#define EXAMRECBLANK       0 	/* EX_RECBLANK field value if record is blank*/
				/* or not completely filled in               */

#define EXAMRECNOTBLANK    1 	/* EX_RECBLANK value if record is filled in */
				/* and can now appear on an exam list   */

/* * * Definition of the Housekeeping Fields for Suite Records * * */

typedef struct {
	char		su_id[4];
	char		prodid[13];
	unsigned long	su_checksum;
} SUITESUPPTYPE;
#define NO_SUITESUPP_FIELDS 3

/* * * Definition of the Housekeeping Fields for Exam Records * * */

typedef struct {
	char		ex_typ[3];
	ATOMIC		complete;
	unsigned short int ex_no;
	char		hospname[33];
	char		patname[25];
	int		ex_datetime;
	char		patid[13];
	char		ex_sysid[9];
	ATOMIC		num_unarchived;
	ATOMIC 		series_count;
	ATOMIC		num_series;
	VARTYPE		series_list;
	ATOMIC		num_unseries;
	VARTYPE		unseries_list;
	VARTYPE		ex_prosp;
	VARTYPE		ex_toarchive;
	unsigned long	ex_checksum;
} EXAMSUPPTYPE;
#define NO_EXAMSUPP_FIELDS 17

/* * * Definition of the Housekeeping Fields for Series Records * * */

typedef struct {
	short int	se_no;
	short int	se_typ;
	short int	se_source;
	short int	se_plane;
	short int	se_pseq;
	char		start_ras;
	float		start_loc;
	char		end_ras;
	float		end_loc;
	short int	se_sortorder;
	short int	scan_type;
	ATOMIC		num_unarchived;
	ATOMIC		complete;
	ATOMIC		image_count;
	ATOMIC		num_images;
	VARTYPE		image_list;
	ATOMIC		num_unimages;
	VARTYPE		unimage_list;
	VARTYPE		se_toarchive;
	unsigned long	se_checksum;
} SERIESSUPPTYPE;
#define NO_SERIESSUPP_FIELDS 20

/* * * Definition of the Housekeeping Fields for Image Records * * */

typedef struct {
	ATOMIC		archived;
	ATOMIC		complete;
	unsigned long	im_checksum;
} IMAGESUPPTYPE;
#define NO_IMAGESUPP_FIELDS 3

/* * * Constants to support locking/unlocking and in-use counts * * */
#define SINGLEIMAGE 	1
#define SINGLESERIES	2
#define SINGLEEXAM	4
#define SINGLESUITE	8
#define SINGLEMODEL	16
#define ALLIMAGE	32
#define ALLSERIES	64
#define ALLEXAM		128
#define ALLSUITE	256

#define IM_LOCK		0
#define IM_UNLOCK	1
#define IM_RETAIN	2
#define IM_DROP		3
#define IM_ENQUEUE	4
#define IM_DEQUEUE	5
#define IM_TSTATUS	6
#define IM_PSTATUS	7

#define IMAGE_OBJ	0
#define SEQ_OBJ		1

#define IDB_LOCK_VALUE	60
#define PERM PERMINUSE	/*from dbshared.h*/
#define TEMP TEMPINUSE	/*from dbshared.h*/

typedef struct {
    /*Input parameters*/
	char	filename[13];
	int	aHeight;
	int	aWidth;
	int	aDepth;
	int	acompType;

    /*Output parameters*/
	unsigned short	examHdrsUsed;
	unsigned short	examHdrsFree;
	unsigned short	seriesHdrsUsed;
	unsigned short	seriesHdrsFree;
	unsigned short	imageHdrsUsed;
	unsigned short	imageHdrsFree;
	int		rawSlotsAvail;
	unsigned long	dynamicStorageAvail;
} IdbSizeInfo;
/*@Start***********************************************************/
/* GEMSBG Include File
 * Copyright (C) 1989 The General Electric Company
 *
 *	Include File Name:  idb_common   
 *	Developer:  David J. Johnson
 *
 * $Source: /apps/cvs/diff/d2a/imagedb.h,v $
 * $Revision: 1.1.1.1 $  $Date: 2004/02/19 16:07:16 $
 */

/*@Synopsis Common includes and defines shared by Applic and IDBM
*/     

/*@Description
     
*/

/*@End*********************************************************/

/* only do this once in any given compilation.*/
#ifndef  idb_common_INCL
#define  idb_common_INCL

struct PATCNTLDATATYPENamer {
        unsigned short int    pc_normexct;        /*Normal Exam Count*/
        unsigned short int    pc_diagexct;        /*Diagnostic Exam Count*/
};
typedef struct PATCNTLDATATYPENamer PATCNTLDATATYPE;
 
/******************Declarations to support Image Database Keys****************

An important note:  The Suite ID (as defined below) should not be assumed
to contain ascii characters nor should it be assumed to be a null-terminated
string.  It is a four byte array.

While it once was indeed a "standard" char[4] (i.e. 3 printable characters
with a null terminator), this interpretation has changed.  So, please
make no assumptions about this unpretentious 4-byte array.

Also, the seemingly simple magic number has also been re-interpreted.
The magic number is now divided into three parts:

	Suite Magic Number  (bits 14 - 10)
	Exam Magic Number   (bits  9 -  5)
	Series Magic Number (bits  4 -  0)
Bit 15 (the sign bit) is left alone.

The structure DbKeyInternal (defined below) shows what's really going on.
For details of the mapping of both DbKey and DbKeyInternal into
actual database keys, see the object ImageAgent (in project ImageDb)

*****************************************************************************/

#define DB_SUITEMAGIC_MASK 0x7c00
#define DB_EXAMMAGIC_MASK  0x7fe0
#define MAX_SUITEMAGIC 31
#define MAX_EXAMMAGIC  31
#define MAX_SERIESMAGIC 31


#define SUITE_ID_LENGTH 4
typedef unsigned short int dbkey_exam_type;
typedef short int dbkey_magic_type;
typedef short int dbkey_series_type;
typedef short int dbkey_image_type;

/*the Image Database Key as a Structure*/
struct DbKeyNamer {
   char su_id[SUITE_ID_LENGTH];
   dbkey_magic_type      mg_no;
   dbkey_exam_type       ex_no;
   dbkey_series_type     se_no;
   dbkey_image_type      im_no;
};
typedef struct DbKeyNamer DbKey;

struct DbKeyInternalNamer {
   char su_id[SUITE_ID_LENGTH + 1]; /*4 characters plus a null*/
				    /*This will get compressed to 24 bits*/
   char disk_id;
   unsigned char suite_magic;
   unsigned char exam_magic;
   unsigned char series_magic;
   dbkey_exam_type	ex_no;
   dbkey_series_type	se_no;
   dbkey_image_type	im_no;
};
typedef struct DbKeyInternalNamer DbKeyInternal;

/* File names used by the Image Database */

#define SUITEFILE	"suite"
#define EXAMFILE	"exam"
#define SERIESFILE	"series"
#define CTSERIESFILE	"series"
#define MRSERIESFILE	"series"
#define CTSCOUTFILE	"ctimage"
#define CTIMAGEFILE	"ctimage"
#define MRIMAGEFILE	"mrimage"
#define PROTOCOLFILE	"protocol"
#define PATCNTLFILE	"patcntl"
#define IDBCONTROLFILE	"idbcontrol"

#define EXAMUIDFILE	"examuid"
#define SERIESUIDFILE	"seriesuid"
#define MRIMAGEUIDFILE	"mrimageuid"
#define CTIMAGEUIDFILE	"ctimageuid"

/* Key lengths used by the Image Database */
#define SUITEKEYLEN	6
#define EXAMKEYLEN	8
#define SERIESKEYLEN	10
#define IMAGEKEYLEN	12
#define PATCNTLKEYLEN	6
#define IDBCONTROLKEYLEN 12

#define UIDLENGTH	32
#define EXAMUIDKEYLEN	UIDLENGTH
#define SERIESUIDKEYLEN	UIDLENGTH
#define MRIMAGEUIDKEYLEN	UIDLENGTH
#define CTIMAGEUIDKEYLEN	UIDLENGTH

/* Some specific values that can be in image DbKeys */
#define NULLEXAM	0
#define NULLSERIES	0
#define NULLIMAGE	0
#define MINNORMEXAM	1
#define MAXNORMEXAM	50000
#define MINDIAGEXAM	50001
#define MAXDIAGEXAM	63500
#define EXAMERROR 	65535
#define NORMALEXAM	0
#define DIAGEXAM	1
#define MAXIMAGENUM	999
#define MAXSERIESNUM	999

#define SUITEKEYTYPE	4
#define EXAMKEYTYPE	3
#define SERIESKEYTYPE	2
#define IMAGEKEYTYPE	1

#define DB_LOG_ERRORS		1
#define DB_DONT_LOG_ERRORS	0

#define PCR001		"pcr001"  /* record key for the one record in file */

/* Allocation Structures and Checksum Macros */

struct AllocStructNamer {
	char		suite[4];		/*** Suite Checksum Fields  ***/
	char		disk_id;
	char		prodid[13];		/*** end 		    ***/

	unsigned short int	exam;		/*** Exam Checksum Fields   ***/
	int		exam_timestamp;
	char		ex_type[3];
	char		patient_name[25];
	char		patient_id[13];		/*** end 		    ***/

	short int	series;			/*** Series Checksum Fields ***/
	int		series_timestamp;
	char		sysid[9];	/*** end		    ***/

	short int	image;			/*** Image Checksum Fields  ***/
	int		image_timestamp;	/*** end		    ***/

	short int	series_type;		/*** Other needed fields    ***/
	short int	source_series;
	char		hospital[33];	
	char		pan_sysid[9];
	short int	image_alloc_cnt;
	short int	suite_magic;
	short int	exam_magic;
	short int	series_magic;
	int		pixelHeight;
	int		pixelWidth;
	int		pixelDepth;
	int		pixelCompType;		/*** end		    ***/
};
typedef struct AllocStructNamer AllocStruct;

#define ARRAYOFFSET(X,Y) (((unsigned long)Y.X) - ((unsigned long)&Y))
#define OFFSET(X,Y) (((unsigned long)&Y.X) - ((unsigned long)&Y))

#define CSUM_SULEN(x) (short)(OFFSET(exam,(x)) - ARRAYOFFSET(suite,(x)))
#define CSUM_EXSTART(x) CSUM_SULEN(x)
#define CSUM_EXLEN(x) (short)(OFFSET(series,(x)) - OFFSET(exam,(x)))
#define CSUM_SESTART(x) CSUM_EXSTART(x) + CSUM_EXLEN(x)
#define CSUM_SELEN(x) (short)(OFFSET(image,(x)) - OFFSET(series,(x)))
#define CSUM_IMSTART(x) CSUM_SESTART(x) + CSUM_SELEN(x)
#define CSUM_IMLEN(x) (short)(OFFSET(series_type,(x)) - OFFSET(image,(x)))

#define SUITE_CHECKSUM(x) idb_checksum((unsigned char *)&(x), CSUM_SULEN(x))
#define EXAM_CHECKSUM(x) idb_checksum((unsigned char *)&(x) + CSUM_EXSTART(x),\
					CSUM_EXLEN(x))
#define SERIES_CHECKSUM(x) idb_checksum((unsigned char *)&(x) \
					       + CSUM_SESTART(x), CSUM_SELEN(x))
#define IMAGE_CHECKSUM(x) idb_checksum((unsigned char *)&(x) + CSUM_IMSTART(x),\
					CSUM_IMLEN(x))

/* This was pulled from net_uid_create.c (NetUID) because
   it was not include-file available. */
#define GEMS_UID_HEADER "1.2.840.113619.2.1."
#define UID_LEN 64
#define DB_UID_LEN 32


#endif /* idb_common_INCL */

#endif /*IMAGEDB_H_INCL*/
