/* diff.h

   Diffusion gradient structures for ses.e

*/

/* Manual */

#define man0  {0,0,0}		/* b0 pattern */
#define man1  {1,0,0}		/* positive x pattern */
#define man2  {0,1,0}		/* positive y pattern */
#define man3  {0,0,1}		/* positive z pattern */

static int manpat[][3] = {man0,man1,man2,man3};

/* Basser method */

#define bg0  { 0, 0, 0}		/* b0 pattern */
#define bg1  { 1, 0,-1}		/* pos x, neg z pattern */
#define bg2  {-1, 0, 1}		/* neg x, pos z pattern */
#define bg3  { 0, 1, 1}		/* positive y,z pattern */
#define bg4  { 0, 1,-1}		/* pos y, neg z pattern */
#define bg5  { 1, 1, 0}		/* positive x,y pattern */
#define bg6  {-1, 1, 0}		/* neg x, pos y pattern */

/*static int bgpat[][3] = {bg0,bg1,bg2,bg3,bg4,bg5,bg6};*/
static int bgpat[][3] = {bg1,bg2,bg3,bg4,bg5,bg6};

/* Basser dual basis */

#define basser_dual_1  {{ 1, 0, 1}, { 0,-1, 0}, { 1, 0, 1}} 
#define basser_dual_2  {{ 1, 0,-1}, { 0,-1, 0}, {-1, 0, 1}} 
#define basser_dual_3  {{-1, 0, 0}, { 0, 1, 1}, { 0, 1, 1}} 
#define basser_dual_4  {{-1, 0, 0}, { 0, 1,-1}, { 0,-1, 1}} 
#define basser_dual_5  {{ 1, 1, 0}, { 1, 1, 0}, { 0, 0,-1}} 
#define basser_dual_6  {{ 1,-1, 0}, {-1, 1, 0}, { 0, 0,-1}} 

static float basser_dual[][3][3]={basser_dual_1,
				  basser_dual_2,
				  basser_dual_3,
				  basser_dual_4,
				  basser_dual_5,
				  basser_dual_6} ;

/* Stepping */

#ifndef PI
# define PI     3.14159265358979323846
#endif

#ifndef TWOPI
# define TWOPI  6.28318530717958647692 
#endif

#define SQRT2  1.41421356237310    /* sqrt(2) - useful for gradients */
#define GDMAX  1.0		   /* maximum diffusion gradient scale 
				      factor [0-1] for stepping calc */
#define GDMAXI (GDMAX/SQRT2)	   /* Interleaved maximum gradient scale 
				      factor for stepping calc.
				      Accounts for problems with rotating 
				      grads */
#define MAXNBVALS 128		   /* Maximum number of b-values */

