      case METH_SHD_GRA:{	/* Generalized Relative Anisotropy index (SHD way) */

	DTI_prc_state   *prc = dif->dti->prc ;
	SHD_calc_state *calc = dif->shd->calc ;

	int    k ;
	float  a00,esum=0.0 ;

	/* Check to make sure shd initialized. If not, do so. */

	if( !dif->sta->shd_initialized ) init_shd( dif );

	if(debug) PRINT_ZV(zs,calc->nlm,"DIFF_aniso_meth: GRA");

	/* Move input complex input into dif->shd->calc->Alm[L][M] */

	zvtoAlm( calc->Alm, zs, calc->Lmax );

	/* Compute energy */

	alm2egy( calc->egyL, calc->Alm, calc->Lmax );

	/* compute isotropic coefficient */

	a00 = sqrt(calc->egyL[0]) ;

	/* compute anisotropic coefficient (start at L=1) */
	for( k=1; k<calc->nl ; k++ ) if(EVEN(k)) esum += calc->egyL[k];

	/* GRA */
	val[0] = sqrt(esum)/a00 ;
	  
	if(debug) printf("DIFF_aniso_meth: METH_SHD_GRA val[0] = %f\n",val[0]);

      }

      break ;

      case METH_SHD_GFA:{	/* Generalized Fractional Anisotropy index (SHD way) */

	/*#define GFA_NORM (sqrt(1.5))*/
#define GFA_NORM (sqrt(3.0))	/* AHB? */

	DTI_prc_state   *prc = dif->dti->prc ;
	SHD_calc_state *calc = dif->shd->calc ;

	int    k ;
	float  asum=0.0,esum=0.0 ;

	/* Check to make sure shd initialized.  If not, do so. */

	if( !dif->sta->shd_initialized ) init_shd( dif );

	if(debug) PRINT_ZV(zs,calc->nlm,"DIFF_aniso_meth: GFA");

	/* Move input complex input into dif->shd->calc->Alm[L][M] */

	zvtoAlm( calc->Alm, zs, calc->Lmax );

	/* Compute energy */

	alm2egy( calc->egyL, calc->Alm, calc->Lmax );

	for( k=0; k<calc->nl ; k++ ) {
	  if(EVEN(k)    )    asum += calc->egyL[k]; /* L=0,2,4,... */
	  if(EVEN(k) && k>0) esum += calc->egyL[k]; /* L=  2,4,... */
	}

	/* GFA */

	val[0] = GFA_NORM * sqrt(esum)/sqrt(asum) ;
	  
	if(debug) printf("DIFF_aniso_meth: METH_SHD_GFA val[0] = %f\n",val[0]);

      }

      break ;
