/**<tstsph>**************************************************

  Title: TeST SPHarm routines

*/
#include "spharm.h"

#define TSTLEG 1		/* test Legendre polynomials */
#define TSTSPH 1		/* test Spherical Harmonics */


#define FACTORIAL(n)             \
  do{ int ii ;                   \
      for( ii=n ; ii > 0 ; ii-- ) ii*=; } while(1)

main()
{

  if(TSTSPH) {			/* Test Spherical Harmonics */

    int n;
    n = 10;
    printf("factorial %i = %i\n",n,FACTORIAL(n)); 

    printf("TSTLEG: done !\n");

  }

  if(TSTLEG) {			/* Test Legendre */

    int i,j;
    float *x,*y;
    int l,m,n;

    n = 10;
    x = (float *) calloc((unsigned)n,sizeof(float));
    y = (float *) calloc((unsigned)n,sizeof(float));

    fprintf(stderr,"\nLegendre: Enter l > ");
    scanf("%i", &l);
    fprintf(stderr,"\nLegendre: Enter m > ");
    scanf("%i", &m);

    /* y = (float **) calloc((unsigned)(l+1),sizeof(float *));
       for(i=0; i<=l; i++) y[i] = (float *) calloc((unsigned)n,sizeof(float)); */
    printf("Calling Legendre with l=%i and x =\n",l);
    for(i=0; i< n; i++) {
      x[i] = (float)i/(float)n;
      printf("x[%i] = %lf\n",i,x[i]);
    }

    Legendre(y,l,m,x,n);

    printf("Back from Legendre with output y =\n");
    for(i=0; i< n; i++) {
      printf("y[%i] = %lf\n",i,y[i]);
    }

    printf("TSTLEG: done !\n");
  }

}
