/* gsl_utils.h */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <gsl/gsl_errno.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_vector.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_eigen.h>
#include <gsl/gsl_sf.h>

/************************** vector routines *******************************/

gsl_vector *dv2gsl( gsl_vector *gvec, double *x, int nn ) ;
    double *gsl2dv( double *x, gsl_vector *gvec, int nn ) ;

/************************** matrix routines *******************************/

gsl_matrix *dm2gsl( gsl_matrix *gmat, double **x, int nr, int nc ) ;
   double **gsl2dm( double **x, gsl_matrix *gmat, int nr, int nc ) ;

/******** 28-Feb-2004 *************/

typedef struct GSL_eig {	/* for gsl eigensystem calcs */

  gsl_eigen_symmv_workspace *work ;
  gsl_matrix                *gmat ;
  gsl_matrix                *evec ;
  gsl_vector                *eval ;

} GSL_eig ;

GSL_eig *alloc_GSL_eig( GSL_eig *gsl_eig, int n ) ;
GSL_eig  *free_GSL_eig( GSL_eig *gsl_eig ) ;
GSL_eig  *init_GSL_eig( int n ) ;

double *dm_symeig( double **x, double **xevec, double *xeval, int n, 
		   GSL_eig *gsle) ;
