/**<behead.c>*******************************************************

     Title: BEHEAD P-file 

   Purpose: Copy header from pfile into separate file.

    Author: Lawrence R. Frank

   History: 08-May-01

     Notes: Print the contents of the subsequent file with "prhead"
*/
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#define RECON_FLAG		/* for the next header include */
#include "rdbm.h"

void create_fname(), create_update() ;
char outfile[80], pfile[80], baseroot[80], *outroot=NULL;
int frame_bytes;
void instructions(),send_help();
int need_help = 0;
int type;
void instructions(),send_help();
FILE *fin,*fout;

#define MINARGC  2
#define MAXARGC  3

main(int argc, char **argv)
{
  int open_files(char *);
  int write_header(char *);
  int parse_args();
  char hfile[80];

  if(!parse_args(argc, argv)) exit (0);

  strcpy(pfile, argv[1]);

  if(argc==MAXARGC)
    outroot = argv[MAXARGC-1];

  if(outroot==NULL)
    strncpy(baseroot, pfile, 6); 
  else
    strcpy(baseroot, outroot);

  sprintf(hfile,"%s.header",baseroot);

  if(!open_files(pfile)) exit (0);

  if(!write_header(hfile)) {
    printf("\aError writing file %s!\n",hfile);
    exit (1);
  } else {
    printf("Wrote file  %s\n",hfile);
    exit (0);
  }

}

int open_files(char *fname)
{
  RDB_HEADER_REC raw;
  char header[RDB_HEADER_SIZE_BYTES];

  if (!(fin=fopen(fname,"r"))) {
    printf("Can't open rawfile %s!\n",fname);
    return(0);
  }

  /* read raw hdr */

  if (fread(header, sizeof(char), RDB_HEADER_SIZE_BYTES, fin) 
      != RDB_HEADER_SIZE_BYTES)
    printf("header too short!\n");
  memcpy(&raw, header+RDB_HDR_OFF, RDB_HDR_SIZE);

  return(1);
}

int write_header(char *fname)
{
  RDB_HEADER_REC raw;
  char header[RDB_HEADER_SIZE_BYTES];

  if (!(fout=fopen(fname,"w"))) {
    printf("Can't open rawfile %s!\n",fname);
    return(0);
  }

  /* read raw hdr */

  if (fwrite(header, sizeof(char), RDB_HEADER_SIZE_BYTES, fout) 
      != RDB_HEADER_SIZE_BYTES)
    printf("header too short!\n");
  memcpy(&raw, header+RDB_HDR_OFF, RDB_HDR_SIZE);

  return(1);
}

int parse_args(int argc, char **argv)
{
  int i;
  int nopt = 0;

  /* parse arguments */

  for (i = 1; i < argc; i++) {	/* ------- Options ------- */

    if (!strncmp(argv[i], "-help", 5)) {        /* help */
      if (i >= argc) { instructions(); exit(0); }
      need_help = 1;
      nopt++;
    }

  } /* end of options */

  if (need_help){
    send_help();
    exit(0);
  }

  if (argc-nopt<MINARGC) {
    instructions();
    exit(0);
  }

  return(1);

}

void instructions()
{
    printf("\nUsage: behead pfile [options] \n\n"

	   "\t -name [P*]    Output filename root\n\n"
	   ) ;
}

void send_help()
{

  printf("\n BEHEAD\n\n"
	 " -- sorry, no help available yet -- \n"
	 "\t \n"
	 );

  return;
}
