/**<prhead.c>*******************************************************

     Title: PRHEAD P-file 

   Purpose: Copy header from pfile into separate file.

    Author: Lawrence R. Frank

   History: 08-May-01

*/
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#define RECON_FLAG		/* for the next header include */
#include "imagedb.h"
#include "rdbm.h"

void create_fname(), create_update() ;
char outfile[80], pfile[80], baseroot[80], *outroot=NULL;
int frame_bytes;
void instructions(),send_help();
int need_help = 0;
int type;
void instructions(),send_help();
FILE *fin,*fout;

void PrintPfileHeaderSummary( char *header, char *dimstr ) ;

#define MINARGC  2
#define MAXARGC  3
#define GAMMA 4257.0            /* proton gyromagnetic ratio in Hz/gauss */

main(int argc, char **argv)
{
  int open_files(char *);
  int print_header(char *);
  int parse_args();
  char hfile[80],froot[80];

  if(!parse_args(argc, argv)) exit (0);

  strcpy(froot, argv[1]);

  sprintf(hfile,"%s.header",froot);

  printf("\nPrinting data from file %s:\n\n",hfile);
  if(!print_header(hfile)) exit (0);
}

int parse_args(int argc, char **argv)
{
  int i;
  int nopt = 0;

  /* parse arguments */

  for (i = 1; i < argc; i++) {	/* ------- Options ------- */

    if (!strncmp(argv[i], "-help", 5)) {        /* help */
      if (i >= argc) { instructions(); exit(0); }
      need_help = 1;
      nopt++;
    }

  } /* end of options */

  if (need_help){
    send_help();
    exit(0);
  }

  if (argc-nopt<MINARGC) {
    instructions();
    exit(0);
  }

  return(1);

}

void instructions()
{
    printf("\nUsage: prhead pfile [options] \n\n"

	   "\t (none yet)\n\n"
	   ) ;
}

void send_help()
{

  printf("\n PRint HEADer\n\n"
	 " -- sorry, no help available yet -- \n"
	 "\t \n"
	 );

  return;
}
