/**<DIFF_fiber_meth.c>****************************************************

     Title: DIFFusion FIBER METHods

   Purpose: Routine to do actual work in the computation
            of the diffusion.

      Call: static void DIFF_fiber_meth( int method, 
					 float fs[] , complex cs[],
					 void *udp  , int nbrick, 
					 float *val , complex *cval);

   History: 03-Jul-20 conversion from DIFF_aniso_meth.c

**************************************************************************/
#include "../diffuse/diffuse.h"

void DIFF_fiber_meth( int     method , 
		      float   fs[] , 
		      complex zs[] , 
		      void    *udp , 
		      int     nbrick , 
		      float   *val ,
		      complex *cval )
{
   static int ncall ;
   struct DIF_state uda, *dif ;

   int debug = 0;
   char aroutine_name1[256];
   sprintf(aroutine_name1,"%s","DIFF_fiber_meth");

   dif = &uda;
   dif = (struct DIF_state *) udp ;

   /** is this a "notification"? **/

   if( fs == NULL && zs == NULL ){

      if( dif->img->ndif > 0 ){  /* the "start notification" */

         ncall = 0 ;		/* keep track of number of calls */

      } else {  /* the "end notification" */

	/* nothing to do here */

      }
      return ;
   }

   /** OK, actually do some work **/

   if(debug) printf("DIFF_fiber_meth: beginning ...\n");

   switch( method ){

      case METH_FTM_XXX:{		/* xxx */

	/* *val = xxx( fs , dif );  */
	printf("Hello from %s: METH_FTM_XXX\n",aroutine_name1); 
	
      }
      break ;

      case METH_FTM_YYY:{		/* yyy */

	/* *val = yyy( fs , dif );  */
	printf("Hello from %s: METH_FTM_YYY\n",aroutine_name1); 

      }
      break ;

      case METH_FTM_DTI:{		/* fiber tracking */

	/*diffusion_tensor( fs , dif );
	  tensor_eig( fs, val, dif->dti->eig ); */
	printf("Hello from %s: METH_FTM_DTI\n",aroutine_name1); 

      }
      break ;

      case METH_FTM_SHD:{		/* fiber tracking */

	/*diffusion_tensor( fs , dif );
	  tensor_eig( fs, val, dif->dti->eig ); */
	printf("Hello from %s: METH_FTM_SHD\n",aroutine_name1); 

      }
      break ;

      default:
        printf("DIFF_fiber_meth: Invalid method %i selected.\a\n",method);
	return ;

   }

   ncall++ ; return ;
}
