/*<alloc.h>***************************************************************/

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

#ifndef TYPEDEF_complex
#define TYPEDEF_complex
typedef struct { float r, i ; } complex ;
#endif

void fm_free( float **fm, int nrow, int ncol ) ;
void dm_free( double **dm, int nrow, int ncol ) ;
void im_free( int **im, int nrow, int ncol ) ;
void sm_free( short **sm, int nrow, int ncol ) ;

void _mm_free( char **mm, int nr, int nc ) ;
void _tt_free( char ***tt, int ns, int nr, int nc ) ;
void _tupleN_free( char ****xx, int ns, int nr, int nc, int ncomp ) ;

#define mm_free(mm,nr,nc)    _mm_free((char **)(mm),(nr),(nc)) 
#define tt_free(tt,ns,nr,nc) _tt_free((char ***)(tt),(ns),(nr),(nc))
#define tupleN_free(xx,ns,nr,nc,ncomp) _tupleN_free((char ****)xx,ns,nr,nc,ncomp) 
#define tuple3_free(xx,ns,nr,nc) _tupleN_free((char ****)xx,ns,nr,nc,(3)) 

char    **cm_alloc(int nr, int nc) ;

short   **sm_alloc( int nr, int nc );
short  ***st_alloc( int ns, int nr, int nc ) ;

float   **fm_alloc(int nr, int nc) ;
float  ***ft_alloc( int ns, int nr, int nc ) ;
float ****ftupleN_alloc( int ns, int nr, int nc, int ncomp ) ;

double   **dm_alloc(int nr, int nc) ;
double  ***dt_alloc( int ns, int nr, int nc ) ;
double ****dtupleN_alloc( int ns, int nr, int nc, int ncomp ) ;

#define ftuple3_alloc(ns,nr,nc) (ftupleN_alloc(ns,nr,nc,(3)))
#define dtuple3_alloc(ns,nr,nc) (dtupleN_alloc(ns,nr,nc,(3)))

#define cv_alloc(n) ((char    *) calloc( (n) ,  sizeof(char)   ))
#define sv_alloc(n) ((short   *) calloc( (n) ,  sizeof(short)  ))
#define iv_alloc(n) ((int     *) calloc( (n) ,  sizeof(int)    ))
#define fv_alloc(n) ((float   *) calloc( (n) ,  sizeof(float)  ))
#define dv_alloc(n) ((double  *) calloc( (n) ,  sizeof(double) ))
#define zv_alloc(n) ((complex *) calloc( (n) ,  sizeof(complex)))

