/**<init_mask_state.c>****************************************************

     Title: INITialize MASK STATE

   Purpose: Initialize mask structure

      Call: Mask_state *init_mask_state( THD_3dim_dataset *dset, 
			     int ivbot , int ivtop ,
			     float *maskbot , float *masktop )

**************************************************************************/
#include "utils.h"

Mask_state *init_mask_state( THD_3dim_dataset *dset, 
			     int ivbot , int ivtop ,
			     float *maskbot , float *masktop )
{
  Mask_state *ptr = NULL;
  int nvox = DSET_NVOX(dset);

  ptr = (Mask_state *) malloc (sizeof(Mask_state));

  ptr->nvox = nvox ;

  ptr->mask = (byte *) malloc (sizeof(byte) * nvox) ;
  if( ptr->mask == NULL ) {
    printf("init_mask_state:  Can't malloc workspace!\n");
    return NULL;
  }

  if(maskbot==NULL || masktop==NULL) {
    ptr->mask_bot =  666.0 ;
    ptr->mask_top = -666.0 ;
  } else {
    ptr->mask_bot = *maskbot ;
    ptr->mask_top = *masktop ;
  }

  ptr->ivbot = ivbot ;
  ptr->ivtop = ivtop ;

  ptr->mcount = 0  ;
  ptr->mean   = 0. ;
  ptr->std    = 0. ;

  return (ptr) ;
}

