/* header file for lrf_utils */

#include "afni.h"

#include "alloc.h"
#include "io.h"

#define LRF_BB_vert 0
#define LRF_BB_horiz 1

#ifndef PI
#define PI     3.14159265358979323846
#endif

/* Structures */

typedef struct Mask_state {

      /* Input */

      int nvox ;		/* number of voxels */
      int ivbot ;		/* first brik to use */
      int ivtop ;		/* last  brik to use */

      byte *mask ;		/* byte mask array *mask[nvox] */

      float mask_bot ;		/* range minimum */
      float mask_top ;		/* range maximum */

      /* Output */

      int   mcount ;		/* #voxel passing threshold */
      float mean ;		/* mean over chosen voxels */
      float std ;		/* standard deviation over chosen voxels */

} Mask_state ;

/* Routines */

void *mask( THD_3dim_dataset *input_dset, Mask_state *ms, int report ) ;

Mask_state *init_mask_state( THD_3dim_dataset *dset, 
			     int ivbot , int ivtop ,
			     float *maskbot , float *masktop ) ;

MRI_IMAGE *get_imarr_by_name( char *fname ) ;

    float *get_ts_by_name( char *fname ) ;

THD_3dim_dataset *
write_data_to_fim( PLUGIN_interface  *plint , 
		   int               nsbricks, /* # sub-bricks */
		   int               nsbsize,	/* sub-brick size */
		   THD_3dim_dataset  *old_dset ,
		   float             **fout ,  /* array of input floats */
		   char              *new_prefix , 
		   Boolean           OverWriteMode );

/* randgen.c */
void rand_initialize (long int seedval) ;
float rand_uniform (float a, float b) ;
float rand_normal (float mu, float var) ;
void rand_binormal (float mu, float var, float * n1, float * n2) ;
