/**<dmtrace.c>************************************************************

     Title: Double Matrix TRACE

   Purpose: Compute trace of double matrix

      Call: double dmtrace(x,nr,nc)
                 double **x;
                 int    nr,nc;

     Input: x[nr][nc] = input matrix
                   nr = number of rows in x
                   nc = number of cols in x

    Output: double trace(x)
*/
#include "vector.h"

double dmtrace( double **x, int nr, int nc )
{
  register double sum = 0.0;
  int      i,n = MIN(nr,nc);

  for (i=0; i<n; i ++) {
      sum += x[i][i];
  }
  return(sum);
}
