/**<dvsum>**************************************************

    Title: Double Vector SUM

  Purpose: Sums elements of vector x[0],...,x[n-1]
 
     Call: double dvsum( double *x, int n )

    Notes: Internal calculation is double precision,
           and the sum is returned in double precision.
*/
#include "vector.h"

double dvsum( double *x, int n )
{
        register double sum=0;

        if(n>0)
        {
                do {
                        sum += *x++ ;
                } while(--n > 0) ;
        }
        return(sum);
}
