#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

/*#include "mrilib.h"*/

#ifndef TYPEDEF_byte
#define TYPEDEF_byte
typedef unsigned char byte ;
#endif

#ifndef TYPEDEF_complex
#define TYPEDEF_complex
typedef struct { float r, i ; } complex ;
#endif

/* dead code */
#if 0
#define LOAD_MAT33_DIAG(A,a11,a22,a33) \
        LOAD_MAT33(A,a11,0.0,0.0,0.0,a22,0.0,0.0,0.0,a33) 

#define LOAD_MAT33(A,a11,a12,a13,a21,a22,a23,a31,a32,a33) \
 ( (A).mat[0][0] = (a11) , (A).mat[0][1] = (a12) ,      \
   (A).mat[0][2] = (a13) , (A).mat[1][0] = (a21) ,      \
   (A).mat[1][1] = (a22) , (A).mat[1][2] = (a23) ,      \
   (A).mat[2][0] = (a31) , (A).mat[2][1] = (a32) , (A).mat[2][2] = (a33) )
#endif

#define PRINT_IMAT33(str,A)                                  \
   fprintf(stderr,                                         \
          "%15.15s: [ %2d %2d %2d ]\n"            \
       "                 [ %2d %2d %2d ]\n"            \
       "                 [ %2d %2d %2d ]\n" ,          \
     str , (A).mat[0][0] , (A).mat[0][1] , (A).mat[0][2] , \
           (A).mat[1][0] , (A).mat[1][1] , (A).mat[1][2] , \
           (A).mat[2][0] , (A).mat[2][1] , (A).mat[2][2]  )

#define PRINT_MAT33(str,A)                                  \
   fprintf(stderr,                                         \
          "%15.15s: [ %13.6g %13.6g %13.6g ]\n"            \
       "                 [ %13.6g %13.6g %13.6g ]\n"            \
       "                 [ %13.6g %13.6g %13.6g ]\n" ,          \
     str , (A).mat[0][0] , (A).mat[0][1] , (A).mat[0][2] , \
           (A).mat[1][0] , (A).mat[1][1] , (A).mat[1][2] , \
           (A).mat[2][0] , (A).mat[2][1] , (A).mat[2][2]  )


/*! 3x3 matrix of floats. */

/* Zero out 3x3 matrix */
#define CLEAR_MAT33(A)    \
 ( (A).mat[0][0] = 0, (A).mat[1][0] = 0, (A).mat[2][0] = 0, \
   (A).mat[0][1] = 0, (A).mat[1][1] = 0, (A).mat[2][1] = 0, \
   (A).mat[0][2] = 0, (A).mat[1][2] = 0, (A).mat[2][2] = 0) ;

/* 3x3 Identity matrix */
#define IDENTITY_MAT33(A)    \
 ( (A).mat[0][0] = 1, (A).mat[1][0] = 0, (A).mat[2][0] = 0, \
   (A).mat[0][1] = 0, (A).mat[1][1] = 1, (A).mat[2][1] = 0, \
   (A).mat[0][2] = 0, (A).mat[1][2] = 0, (A).mat[2][2] = 1) ;

/* 3x3 Identity matrix */
#define IDENTITY_MAT33_OLD()    \
 ( tempA_mat33.mat[0][0] = 1, tempA_mat33.mat[1][0] = 0, tempA_mat33.mat[2][0] = 0, \
   tempA_mat33.mat[0][1] = 0, tempA_mat33.mat[1][1] = 1, tempA_mat33.mat[2][1] = 0, \
   tempA_mat33.mat[0][2] = 0, tempA_mat33.mat[1][2] = 0, tempA_mat33.mat[2][2] = 1, tempA_mat33) ;

#define SUB_MAT33(C,A,B)                           \
 ( (C).mat[0][0] = (A).mat[0][0] - (B).mat[0][0] , \
   (C).mat[1][0] = (A).mat[1][0] - (B).mat[1][0] , \
   (C).mat[2][0] = (A).mat[2][0] - (B).mat[2][0] , \
   (C).mat[0][1] = (A).mat[0][1] - (B).mat[0][1] , \
   (C).mat[1][1] = (A).mat[1][1] - (B).mat[1][1] , \
   (C).mat[2][1] = (A).mat[2][1] - (B).mat[2][1] , \
   (C).mat[0][2] = (A).mat[0][2] - (B).mat[0][2] , \
   (C).mat[1][2] = (A).mat[1][2] - (B).mat[1][2] , \
   (C).mat[2][2] = (A).mat[2][2] - (B).mat[2][2]   )

/* Copy B into A */
#define COPY_MAT33(A,B)    \
 ( (A).mat[0][0] = (B).mat[0][0] , \
   (A).mat[1][0] = (B).mat[1][0] , \
   (A).mat[2][0] = (B).mat[2][0] , \
   (A).mat[0][1] = (B).mat[0][1] , \
   (A).mat[1][1] = (B).mat[1][1] , \
   (A).mat[2][1] = (B).mat[2][1] , \
   (A).mat[0][2] = (B).mat[0][2] , \
   (A).mat[1][2] = (B).mat[1][2] , \
   (A).mat[2][2] = (B).mat[2][2] ) ;

/* Load standard 3x3 float matrix into THD_mat33 */
#define MAT2THD(A,B)    \
 ( (A).mat[0][0] = (B)[0][0] , \
   (A).mat[1][0] = (B)[1][0] , \
   (A).mat[2][0] = (B)[2][0] , \
   (A).mat[0][1] = (B)[0][1] , \
   (A).mat[1][1] = (B)[1][1] , \
   (A).mat[2][1] = (B)[2][1] , \
   (A).mat[0][2] = (B)[0][2] , \
   (A).mat[1][2] = (B)[1][2] , \
   (A).mat[2][2] = (B)[2][2] ) ;

/* Load THD_mat33 into standard 3x3 float matrix  */
#define THD2MAT(A,B)    \
 ( (A)[0][0] = (B).mat[0][0] , \
   (A)[1][0] = (B).mat[1][0] , \
   (A)[2][0] = (B).mat[2][0] , \
   (A)[0][1] = (B).mat[0][1] , \
   (A)[1][1] = (B).mat[1][1] , \
   (A)[2][1] = (B).mat[2][1] , \
   (A)[0][2] = (B).mat[0][2] , \
   (A)[1][2] = (B).mat[1][2] , \
   (A)[2][2] = (B).mat[2][2] ) ;

/* Load THD_mat33 into float vector[9] by columns */
#define THD2VEC(A,B)    \
 ( (A)[0] = (B).mat[0][0] , \
   (A)[1] = (B).mat[1][0] , \
   (A)[2] = (B).mat[2][0] , \
   (A)[3] = (B).mat[0][1] , \
   (A)[4] = (B).mat[1][1] , \
   (A)[5] = (B).mat[2][1] , \
   (A)[6] = (B).mat[0][2] , \
   (A)[7] = (B).mat[1][2] , \
   (A)[8] = (B).mat[2][2] ) ;

/* matrix trace */

#define TRACE_MAT33(A) ( (A).mat[0][0] + (A).mat[1][1] + (A).mat[2][2] )

/* Determinant of 3x3 matrix */
#define DET_MAT33(A) \
 (  (A).mat[0][0]*(A).mat[1][1]*(A).mat[2][2] \
  - (A).mat[0][0]*(A).mat[1][2]*(A).mat[2][1] \
  - (A).mat[1][0]*(A).mat[0][1]*(A).mat[2][2] \
  + (A).mat[1][0]*(A).mat[0][2]*(A).mat[2][1] \
  + (A).mat[2][0]*(A).mat[0][1]*(A).mat[1][2] \
  - (A).mat[2][0]*(A).mat[0][2]*(A).mat[1][1]   )

/* Accumulate matrices: A = A + B */
#define ACCUM_MAT33(A,B)    \
 ( (A).mat[0][0] += (B).mat[0][0] , \
   (A).mat[1][0] += (B).mat[1][0] , \
   (A).mat[2][0] += (B).mat[2][0] , \
   (A).mat[0][1] += (B).mat[0][1] , \
   (A).mat[1][1] += (B).mat[1][1] , \
   (A).mat[2][1] += (B).mat[2][1] , \
   (A).mat[0][2] += (B).mat[0][2] , \
   (A).mat[1][2] += (B).mat[1][2] , \
   (A).mat[2][2] += (B).mat[2][2] ) ;

/* Scale matrix: A *= b */
#define SCALE_MAT33(A,b)                 \
 ( (A).mat[0][0] *= (b), (A).mat[1][0] *= (b), (A).mat[2][0] *= (b), \
   (A).mat[0][1] *= (b), (A).mat[1][1] *= (b), (A).mat[2][1] *= (b), \
   (A).mat[0][2] *= (b), (A).mat[1][2] *= (b), (A).mat[2][2] *= (b)) ;

