/* vector.h */

/* AFNI header */

#include "afni.h"

#ifndef PI
#  define PI 3.141592653589793238462643
#endif

#ifndef TWOPI
#  define TWOPI 6.283185307179586476925286     /* 2 * PI */
#endif

#ifndef PI2
#  define PI2 1.57079632679490     /* PI/2 */
#endif

#ifndef MAX
#   define MAX(a,b) (((a)<(b)) ? (b) : (a))
#endif

#ifndef MIN
#   define MIN(a,b) (((a)>(b)) ? (b) : (a))
#endif

#define MABS(x)	    (((x)<0) ? -(x) : (x))
#define SIGN(f,g)   (((g)>0)?(f):(-(f)))

/* Float vector routines */

float *vrnd( float *x, int n, char *dist ) ;
float *vsin(float *z, float *x, int n) ;
float *vcos(float *z, float *x, int n) ;
float *vscal(float *z, float a, float *x, int n) ;
float *vmove(float *z,float *x,int N) ;
float *vrev( float *z , float *x , int N ) ;
float *vlinsp(float *x,float d1,float d2,int n) ;
float vmsq( float *x, int n ) ;
float vstd( float *x, int n ) ;
float vvar( float *x, int n ) ;
float vsum( float *x, int n ) ;
float vmean( float *x, int n ) ;
float vmnmx(float *x, int n, int *nmin, int *nmax) ;
void  vran(float *a, float *amin, int *lamin, float *amax, int *lamax, int n) ;

/* Double vector routines */

double dvmsq( double *x, int n ) ;
double dvsum( double *x, int n ) ;
double dvmean( double *x, int n ) ;
double dvvar( double *x, int n ) ;
double dvmnmx(double *x, int n, int *nmin, int *nmax) ;

/* Complex routines */

complex zscal(double d, complex z) ;
complex zcnjg(complex a) ;
complex zmuli(complex a) ;
complex zmul(complex a, complex b) ;
complex zadd(complex a, complex b) ;
complex zsub(complex a, complex b) ;
complex zclr(complex z) ;
complex zexp(complex z) ;
complex zcplx(double r, double i) ;

double zabs(complex z) ;

/* Complex vector routines */

complex *zvexp(complex *z, complex *x, int n) ;
complex  zvcor(complex *x, complex *y, int n) ;
