/**<vlinsp.c>************************************************************

     Title: Float Vector LINearly SPaced array

   Purpose: Create linearly spaced array of float numbers

      Call: float *vlinsp(float *x,float f1,float f2,int n)

     Input:  x = float x[n] 
            f1 = first point 
            f2 = last point
	     n = number of points

    Output: float *x = [f1,..,f2]

    Author: Lawrence R. Frank

   History: C version of a MATLAB routine
*/
#include "vector.h"

float *vlinsp(float *x,float f1,float f2,int n)
{
  register int    i;
  register float fn = n;

  for(i=0; i<n-1; i++) x[i] = f1 + i * (f2 - f1)/(fn - 1.);

  x[n-1] = f2;
  
  return(x);
}
