/**<vmove.c>****************************************************

     Title: Vector MOVE

   Purpose: Moves vector x[] into z[] quickly

      Call: float *vmove( float *z, float *x, int N)

     Input: x = vector to move
	    n = length(x)

    Output: z[i] = x[i] for i=0,...,n-1 if z<=x
                        for i=n-1,...,0 if z>x

    Returns pointer to z[] 
 
    History: Musicus, circa 1980
*/
#include "vector.h"

float *vmove(float *z,float *x,int N)
{
	float *zold = z;

	if(N>0)
	{
		if(z<=x)
		{
			do {
				*z++ = *x++ ;
			} while( --N > 0) ;
		}
		else
		{
			z += N ;
			x += N ;
			do {
				*--z = *--x ;
			} while( --N > 0) ;
		}
	}
	return(zold) ;
}
