/*       float *vrev(z,x,n)	Reverses vector: z[i]=x[n-1-i] for i=0,...,n-1
 *       float *z,*x ;		Returns pointer to z[]
 *       int n ;
 *
 * Works correctly if x[] and z[] vectors do not overlap at all, or if they
 * overlap completely
*/
float *vrev( float *z , float *x , int N )
{
	float *zold = z;
	register float *ze = z+N ;
	register float *xe = x+N ;
	register double temp1,temp2;

	if(N>0)
	{
		N = (N+1)>>1 ;
		do {
			temp1 = *x++ ;
			temp2 = *--xe ;
			*z++ = temp2 ;
			*--ze = temp1 ;
		} while( --N > 0) ;
	}
	return(zold) ;
}
