/**<vstd>**************************************************

    Title: Float integer Vector STD

  Purpose: Compute std of float vector.
 
     Call: float vstd( float int *x, int n )

*/
#include <math.h>
#include "vector.h"

float vstd( float *x, int n )
{
  float sum = 0.;
  float dn  = n - 1;
  float mean,std,tmp;

  mean = dvmean((double*)x,n);

  if(n>0)
    {
      do {
	tmp  = *x++ - mean ;
	sum += tmp*tmp;
      } while(--n > 0) ;
    }
  std = sqrt(sum/dn);
  
  return(std);
}
