/**<vsum>**************************************************

    Title: Float Vector SUM

  Purpose: Sums elements of vector x[0],...,x[n-1]
 
     Call: float vsum( float *x, int n )

    Notes: Internal calculation is float precision,
           and the sum is returned in float precision.
*/
#include "vector.h"

float vsum( float *x, int n )
{
        register float sum=0;

        if(n>0)
        {
                do {
                        sum += *x++ ;
                } while(--n > 0) ;
        }
        return(sum);
}
