/**<zabs.c>****************************************************

     Title: Complex ABSolute value

   Purpose: returns double prec magnitude 
            of complex argument 
            spec attn to avoid unnec overflow 

      Call: double zabs(complex a) 

*/
#include "vector.h"

double zabs(complex a) 
{                          
	register double absr, absi, ratio;

	if( (absr=fabs(a.r)) <= (absi=fabs(a.i)) && absi>0.0 ) {
		ratio = absr/absi;
		return(absi * sqrt(1 + ratio*ratio) ); 
	}
	else if (absr>0.0) {
		ratio = absi/absr;
		return(absr * sqrt(1 + ratio*ratio) );
	}
	else return((double)0.0);
}
