/**<zvexp.c>****************************************************

     Title: Complex Vector EXPonential

   Purpose: Computes the complex exponential of a complex vector

      Call: complex *zvexp(complex *z, complex *x, int n)

     Input: x = input vector
	    n = length(x)

    Output: z[i] = exp(x[i])

    Returns pointer to z[] array
*/
#include "vector.h"

complex *zvexp(complex *z, complex *x, int n)
{
  //double exp(),cos(),sin() ;
  float *zptr = (float*)z ;
  double rexp ;

  while(n-->0) {
    rexp = exp(x->r) ;
    *zptr++ = rexp*cos(x->i) ;
    *zptr++ = rexp*sin(x->i) ;
    x++ ;
  }
  return(z) ;
}
