/*=======================================================================
  Program:   Launch VTK window
  Language:  C++
  Date:      $Date: 2004/02/27 21:05:27 $
  Version:   $Revision: 1.4 $
  Author:    Cyrus Jam
=========================================================================*/

//
// Work in Progress 
//

#define VTK_RWI_MESSAGE \
{printf("\nActivating rendering window interactor ...\n" \
	"(Hit 'q' in window to exit)\n");fflush(stdout);}

#include "vtk_window.h"

/* Global so quit_cb can delete them... */
vtkPolyDataMapper      *dataMapper ;
vtkActor               *dataActor ;
vtkXOpenGLRenderWindow *renWin ;
vtkRenderer            *ren1 ;

/* Callbacks */
void quit_cb(Widget,XtPointer,XtPointer);

/* Widget setup */
Widget setup_widgets(Widget,vtkXOpenGLRenderWindow*);

void Launch_vtk_window( Widget shell, vtkPolyData *data, int nvert )
{

  //vtkXOpenGLRenderWindow *renWin = vtkXOpenGLRenderWindow::New();
  //vtkRenderer *ren1 = vtkRenderer::New();
  renWin = vtkXOpenGLRenderWindow::New();
  ren1 = vtkRenderer::New();

  Widget vtk_widg = setup_widgets(shell,renWin);
  
  /* X Window stuff end */

  fprintf( stderr, ":) Launch vtk window\n" );	
  
  //
  // In this example we terminate the pipeline with a mapper process object.
  // (Intermediate filters such as vtkShrinkPolyData could be inserted in
  // between the source and the mapper.)  We create an instance of
  // vtkPolyDataMapper to map the polygonal data into graphics primitives. We
  // connect the output of the cone souece to the input of this mapper.
  //
  //vtkPolyDataMapper *dataMapper = vtkPolyDataMapper::New();
  dataMapper = vtkPolyDataMapper::New();
  dataMapper->SetInput( data );

  //
  // Create an actor to represent the data. The actor orchestrates rendering
  // of the mapper's graphics primitives. An actor also refers to properties
  // via a vtkProperty instance, and includes an internal transformation
  // matrix. We set this actor's mapper to be dataMapper which we created
  // above.
  //
  //vtkActor *dataActor = vtkActor::New();
  dataActor = vtkActor::New();
  dataActor->SetMapper( dataMapper );

  //
  // Create the Renderer and assign actors to it. A renderer is like a
  // viewport. It is part or all of a window on the screen and it is
  // responsible for drawing the actors it has.  We also set the background
  // color here.
  //
  ren1->AddActor( dataActor );
  ren1->SetBackground( 0.1, 0.2, 0.4 );

  //
  // Finally we create the render window which will show up on the screen.
  // We put our renderer into the render window using AddRenderer. We also
  // set the size to be 300 pixels by 300.
  //

  renWin->AddRenderer( ren1 );
  renWin->SetSize( 300, 300 );

  // we typecast to an X specific interactor
  // Since we have decided to make this an X program
  vtkXRenderWindowInteractor *iren = vtkXRenderWindowInteractor::New();
  iren->SetRenderWindow(renWin);
  iren->SetWidget(vtk_widg);

  renWin->Render();
  iren->Initialize(XtWidgetToApplicationContext(vtk_widg)) ;

  //
  // Free up any objects we created. All instances in VTK are deleted by
  // using the Delete() method.
  //

  /*dataMapper->Delete();
    dataActor->Delete();
    ren1->Delete();
    renWin->Delete(); */
  
  fprintf( stderr, ":( exiting vtk window\n" );	

}

/* quit callback */
void quit_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
  XtUnmapWidget( (Widget)client_data ) ; 
}

Widget setup_widgets(Widget sh,vtkXOpenGLRenderWindow *rw)
{
  Widget button;
  Widget toplevel2;
  Widget form;
  Widget widg_ret ;

  /* X Window stuff begin */

  XtSetLanguageProc(NULL,NULL,NULL);

  // get the display connection and give it to the renderer

  rw->SetDisplayId(XtDisplay(sh));

  toplevel2 = XtVaCreateWidget("top2",
			       topLevelShellWidgetClass,sh,
                               XmNdepth, rw->GetDesiredDepth(),
                               XmNvisual, rw->GetDesiredVisual(),
                               XmNcolormap, rw->GetDesiredColormap(),
                               NULL);

  form     = XtVaCreateWidget("form",xmFormWidgetClass, toplevel2, NULL);
  widg_ret = XtVaCreateManagedWidget("vtk_widg",
				     xmPrimitiveWidgetClass, form, 
                                     XmNwidth, 300, XmNheight, 300,
                                     XmNleftAttachment, XmATTACH_FORM,
                                     XmNrightAttachment, XmATTACH_FORM,
                                     XmNtopAttachment, XmATTACH_FORM,
                                     NULL);
  button    = XtVaCreateManagedWidget("Exit",
				      xmPushButtonWidgetClass, form,
                                      XmNheight, 40,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, widg_ret,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNrightAttachment, XmATTACH_FORM,
                                      NULL);
  XtAddCallback(button,XmNactivateCallback,quit_cb,(XtPointer *)toplevel2);
  XtManageChild(form);
  XtRealizeWidget(toplevel2);
  XtMapWidget(toplevel2);

  return (widg_ret) ;
}
