/********************* vtkPlotting.h ***************************/

#ifndef VTK_include
#define VTK_include
#include "vtk_all.h"
#endif

//Handle old versions of VTK
#ifndef vtkFloatingPointType
#define vtkFloatingPointType vtkFloatingPointType
typedef float vtkFloatingPointType;
#endif

/* Generic includes */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/fcntl.h> 

#include <X11/Intrinsic.h>	/* for Boolean */

#ifndef YES
#define YES 1 
#endif
#ifndef NO
#define NO 0 
#endif
#ifndef MAYBE
#define MAYBE -1
#endif

/* Colors for vtk plotting (xyplot) */

#include "colordefs.h"
/*#include "ioutils.h"
  #include "vector.h"*/
#include "vtk_Utils.h"


vtkLookupTable *CreateStandardColorTable( vtkFloatingPointType *range ) ;
vtkLookupTable *CreateColorTable( int ncolors, 
				  vtkFloatingPointType *hue_range,
				  vtkFloatingPointType *sat_range,
				  vtkFloatingPointType *val_range,
				  vtkFloatingPointType *alf_range,
				  vtkFloatingPointType *range ) ;

void Draw_Cube( vtkRenderer *the_renderer, 
		vtkFloatingPointType *cube_bounds ) ;

void Draw_Sphere( vtkRenderer *the_renderer, 
		  vtkFloatingPointType radius, int theta_res, int phi_res ) ;

int xyplot( vtkFloatArray *Data, char *xtitle, char *ytitle, char *ptitle ) ;
void plot(float *tcoord, float *amp, int nn, 
	  char *xlabel, char *ylabel, char *title) ;

int ParametricPlot3D( vtkFloatArray *xyz, float *time, int numPts, 
		      char *xtitle, char *ytitle, char *ztitle, char *ptitle,
		      int DO_SPHERE );

