/******************* vtkUtils.h *********************/

#ifndef VTK_include
#define VTK_include
#include "vtk_all.h"
#endif

//Handle old versions of VTK
#ifndef vtkFloatingPointType
#define vtkFloatingPointType vtkFloatingPointType
typedef float vtkFloatingPointType;
#endif

/* Generic includes */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/fcntl.h> 

#include <X11/Intrinsic.h>	/* for Boolean */

#include "../utils/alloc.h"
#include "../vector/vector.h"

#ifndef YES
#define YES 1 
#endif
#ifndef NO
#define NO 0 
#endif
#ifndef MAYBE
#define MAYBE -1
#endif

/* Types needed in subsequent includes */

#ifndef TYPEDEF_byte
#define TYPEDEF_byte
typedef unsigned char byte ;
#endif

#ifndef TYPEDEF_complex
#define TYPEDEF_complex
typedef struct { float r, i ; } complex ;
#endif

#ifndef BIGVAL
#  define BIGVAL 1.e+10
#endif

vtkFloatArray *FloatArrayRange( vtkFloatArray *fa ) ;
vtkFloatArray *FloatArray_Sum( vtkFloatArray *meanfa , vtkFloatArray *fa ) ;
void Fill_PComplexArray( vtkFloatArray *fa , float fvalr, float fvali ) ;
void Fill_FloatArray( vtkFloatArray *fa, float fval, int maxcomp ) ;
void Clear_FloatArray( vtkFloatArray *fa ) ;
void Print_FloatArray( vtkFloatArray *fa , char *name, int pmode ) ;

vtkPolyData *VectorsToVTKPolyData(vtkFloatingPointType *pos, 
				  vtkFloatingPointType *val, int numPts,
				  vtkFloatingPointType *xrange, 
				  vtkFloatingPointType *yrange ) ;

#define PRINT_FV(v,n,label) \
do{ int i; \
    for(i=0; i<(n); i++) { \
        printf("%s[%i] = %13.6g\n",(label),i,(v)[i]); \
    }\
} while(0) 
