/*=======================================================================
  Program:   Launch VTK window
  Language:  C++
  Date:      $Date: 2004/03/03 02:48:57 $
  Version:   $Revision: 1.5 $
  Author:    Cyrus Jam
=========================================================================*/

//
// Work in Progress 
//

#define VTK_RWI_MESSAGE \
{printf("\nActivating rendering window interactor ...\n" \
	"(Hit 'q' in window to exit)\n");fflush(stdout);}

#include "vtk_window.h"
#include <vtkTransform.h>
#include <vtkTransformPolyDataFilter.h>
#include <Xm/Separator.h>

#include "ParametricSHD.h"
//#define EXPERIMENTAL

/* Global ... */
THD_3dim_dataset *func_dset;
static UIState state;
const vtkFloatingPointType UIState::STREAM_MAX_TIME = 1.e5;
const vtkFloatingPointType UIState::VIS_STEP_TIME = 0.1;



vtkXRenderWindowInteractor *iren,*irenv ;
vtkXOpenGLRenderWindow     *renWin,*renvWin ;
vtkRenderer                *ren1,*ren2,*renv ;
vtkCamera                  *camera = NULL;		
vtkPolyDataMapper          *dataMapper;

vtkPolyDataMapper          *vgridMapper = NULL;
vtkActor                   *dataActor;
vtkActor                   *vgridActor = NULL ;
//vtkActor                   *animationActor = NULL;
vtkActor                   *sphereActor = NULL;
vtkPolyDataMapper          *contour_mapper = NULL;
vtkActor                   *track_contour_actor = NULL;
vtkContourFilter           *track_contour = NULL;
vtkSmoothPolyDataFilter    *contour_smoother = NULL;
vtkThreshold               *track_thresher = NULL;
vtkActor                   *origin_sphere_actor = NULL;
vtkAxesActor               *axes_actor = NULL;
vtkOrientationMarkerWidget *orientation = NULL;
vtkParametricEllipsoid *ellipsoid = NULL;
vtkParametricFunctionSource *ellipSource = NULL;

/* slicer stuff */
vtkLookupTable *slicer_hue_lut;
vtkCylinderSource *slicer_cylinder;
vtkTransform *slicer_transform;
vtkTransformPolyDataFilter *slicer_tf_filter;
vtkPlane* slicer_planes[3];
vtkPlane* slicer_cplanes[3];
vtkPlane* slicer_cplanes2[3];
vtkExtractVOI* slicer_iVolumeFilters[3];
vtkExtractVOI* slicer_vVolumeFilters[3];
vtkCutter* slicer_iCutters[3];
vtkCutter* slicer_cmapCutters[3];
vtkCutter* slicer_cmapCutters2[3];
vtkCutter* slicer_vCutters[3];
vtkImageDataGeometryFilter *slicer_iPlanes[3];
vtkImagePlaneWidget *slicer_widgets[3];
vtkProperty *slicer_wProp;
vtkCellPicker *slicer_wPicker;
vtkPolyDataMapper* slicer_iMappers[3];
vtkPolyDataMapper* slicer_cmapMappers[3];
vtkPolyDataMapper* slicer_cmapMappers2[3];
vtkPolyDataMapper* slicer_vMappers[3];
vtkActor* slicer_imgActors[3];
vtkActor* slicer_cmapActors[3];
vtkActor* slicer_cmapActors2[3];
vtkActor* slicer_vecActors[3];
vtkGlyph3D* slicer_glyphs[3];
vtkOutlineFilter *slicer_outline;
vtkPolyDataMapper *slicer_outlineMapper;
vtkActor *slicer_outlineActor;
vtkLookupTable* slicer_vLut;

ParametricSHD *shape = NULL;
ParametricSHD *shapeO = NULL;
vtkParametricFunctionSource *shape_source;
vtkParametricFunctionSource *shapeO_source;
// diffusion and animation variables
int u = 0;
XtIntervalId timer_id;
float rel_site_md;

vtkPoints *points = NULL;
vtkVolume *volume = NULL;
vtkVolume *max_conc_volume = NULL;
vtkVolumeRayCastMapper *volume_mapper = NULL;
vtkVolumeProperty *volume_property = NULL;
vtkVolumeRayCastCompositeFunction *composite_func = NULL;
vtkColorTransferFunction *color_transfer_func = NULL;
vtkPiecewiseFunction *opacity_transfer_func = NULL;

vtkUnstructuredGrid *pointset[animation_frames];
vtkDataSetReader *myreader[animation_frames];
vtkStructuredPoints *lig_density_char[animation_frames];
vtkStructuredPoints *lig_density_double[animation_frames];
vtkStructuredPointsReader *diffusion_path_reader[animation_frames];
vtkPolyData *data = NULL;
vtkGlyph3D *verts = NULL;
vtkPNMWriter *pnm_image_writer = NULL;
vtkPNGWriter *png_image_writer = NULL;
vtkWindowToImageFilter *w2i = NULL;

vtkOutlineFilter           *outline = NULL;
vtkActor                   *outlineActor = NULL;
vtkThreshold               *thresher = NULL;
vtkThreshold               *streamThresher = NULL;
vtkThreshold               *iThresher = NULL;
vtkThreshold               *sliceThreshers[3] = {NULL, NULL, NULL};
vtkThreshold               *cmapThreshers[3] = {NULL, NULL, NULL};
vtkPointWidget             *pointWidget = NULL;
vtkLineWidget              *lineWidget = NULL;
vtkPlaneWidget             *planeWidget = NULL;
vtkActor                   *streamLineActor = NULL; 
vtkActor                   *streamTubeActor = NULL;
vtkActor                   *probeActor;
//vtkLODActor                **isoActor = NULL;
vtkLODActor                *isoActor = NULL;

/* Global vector data for different modes ... */ 
vtkStructuredPoints *vgrid ;
vtkStructuredPoints *igrid ;
vtkStructuredPoints *cgrid ;
vtkStructuredPoints *igrid_oriented ; // re-oriented to match vgrid

/* Processing switches */ 
Boolean DO_PROBES       = 0 ;	/* Probes */
Boolean DO_PLANES       = 0 ;	/* Planes */
Boolean DO_SLICER       = 0 ;	/* Slicer */
Boolean DO_ISOSURFACE   = 0 ;	/* Contour */
Boolean DO_STREAM       = 0 ;	/* Streamline */
Boolean DO_STUBE        = 0 ;	/* Streamtube */
Boolean DO_VORTICITY    = 0 ;	/* Vorticity calc for streamline */ 
Boolean DO_RIBBON       = 0 ;	/* Ribbon filter */
Boolean DO_LINE_WIDGET  = 0;	/* Line widget   */ 
Boolean DO_PLANE_WIDGET = 0;	/* Plane widget   */ 
Boolean DO_POINT_WIDGET = 0; 


Boolean axial_vectors = false;
Boolean sagittal_vectors = false;
Boolean coronal_vectors = false;
Boolean show_outline = true;
Boolean show_axes = true;

bool colormap[3] = {false, false, false};
Widget colormap_button[3] = {NULL, NULL, NULL};
static bool voxel_signal_on = false;
static bool voxel_odf_on = false;
static bool voxel_shd_on = false;
static bool voxel_dt2_on = false;
Widget button_exit, button_signal, button_odf, button_shd, button_dt2;

/* Widget setup */
void updateWidgets();
Widget setup_widgets(Widget,vtkXOpenGLRenderWindow*);
Widget setup_vector_widgets(Widget,vtkXOpenGLRenderWindow*);
Widget save_image_button;
Widget vfield_button;
Widget stream_button;
Widget isoSurface_button;
  
static MCW_arrowval *fai_thresh_av ;

static float flims[2] ;

vtkActor* imgActors[3] = {NULL, NULL, NULL};
vtkActor* cmapActors[3] = {NULL, NULL, NULL};
vtkActor* cmapActors2[3] = {NULL, NULL, NULL};
vtkImageActor* imageActors[3] = {NULL, NULL, NULL};
vtkActor* vecActors[3] = {NULL, NULL, NULL};

Widget dst_shell = NULL;   // DST control panel
Widget streamline_shell = NULL; // streamline tracking control panel
Widget isoSurface_shell = NULL; // contour control panel

Widget dst_seeds_pb;
Widget dst_tract_pb;
Widget dst_ftTarget_pb;
Widget help_row;
Widget integTime_row;
Widget dt4_seeds_pb;
Widget dt4_dset_pb;
Widget dt4_help_row;
               // for deleting vtk pipeline objects in DST
stack<vtkActor*> dstTubeActor_stack;
stack<vtkPolyDataMapper*> dstTubeMapper_stack;
stack<vtkPolyDataReader*> dstReader_stack;
stack<vtkTubeFilter*> dstTubeFilter_stack;

vtkLookupTable *dst_lut = NULL;
vtkScalarBarActor *dst_colorbar = NULL;
                   // diffsion simulation tracking function prototypes
void diffsimFT_cb( Widget w, XtPointer client_data, XtPointer call_data );
void recompute_diffsimFT( Widget w, XtPointer client_data, XtPointer 
  call_data );
void axial_view_cb(Widget w, XtPointer client_data, XtPointer call_data);

static THD_3dim_dataset *seeds_dset = NULL;  // seeds dataset
static char seeds_dset_prefix[THD_MAX_NAME]; // seeds dataset prefix
static struct dirent **dp;            // will point to current directory
static char *tract_dset_name;  // tract dataset file name
static THD_3dim_dataset *ftTarget_dset = NULL;  // fiber target dataset
static THD_3dim_dataset *dt4_dset = NULL; // 4th-order DT dataset

static int ndsl = 0;
static PLUGIN_dataset_link *dsl = NULL;
static Three_D_View *im3d;                 // afni controller
static THD_3dim_dataset *dwi_dset;    // dwi dataset
static THD_3dim_dataset *shd_dset;    // shd dataset
static vtkPolyData *vGrid;

static int ijkvox; // current voxel index from cross-hair location
void voxel_signal_CB( Widget w, XtPointer client_data, XtPointer call_data );
void voxel_odf_CB( Widget w, XtPointer client_data, XtPointer call_data );
void voxel_shd_CB( Widget w, XtPointer client_data, XtPointer call_data );
void voxel_dt2_CB( Widget w, XtPointer client_data, XtPointer call_data );
void view_voxel_signal( void );
void view_voxel_odf( void );
void view_voxel_shd( void );
void view_voxel_dt2( void );

static THD_3dim_dataset *b0_isovox_dset = NULL; //resampled b0 dataset 
static THD_3dim_dataset *dti_isovox_dset = NULL; // resampled dti dataset
static DIF_state *current_dif_state = NULL; // for tensor file and voxel visual

void DST_choose_CB( Widget w, XtPointer client_data, XtPointer call_data );
void DST_compute_CB( Widget w, XtPointer client_data, XtPointer call_data );
void DST_help_CB( Widget w, XtPointer client_data, XtPointer call_data );
void DST_view_cb( Widget w, XtPointer client_data, XtPointer call_data );
void DST_clear_cb( Widget w, XtPointer client_data, XtPointer call_data );
void DST_dataset_CB( Widget w, XtPointer fd, MCW_choose_cbs *cbs );
void DST_tract_dset_CB( Widget w, XtPointer fd, MCW_choose_cbs *cbs );
void DST_fa_CB(Widget w, XtPointer client_data, XtPointer call_data);
void DST_distRatio_CB(Widget w, XtPointer client_data, XtPointer call_data);
void DST_curv_CB(Widget w, XtPointer client_data, XtPointer call_data);
void DST_coher_CB(Widget w, XtPointer client_data, XtPointer call_data);
void DST_integTime_CB(Widget w, XtPointer client_data, XtPointer call_data);
void DST_stats_CB(Widget w, XtPointer client_data, XtPointer call_data);
int **DST_maskXYZ( int *nnzero, THD_3dim_dataset *seeds_dset, int nvox );
float *DST_b0_image( int b0_type, THD_3dim_dataset *dwi_dset, int novx );
void DST_b0_changed_CB( Widget w, XtPointer client_data, XtPointer call_data );
void DST_tubeToggle_CB( Widget w, XtPointer client_data, XtPointer call_data );
void DST_tubeRadius_changed_CB( Widget w, XtPointer client_data, XtPointer 
  call_data );
void DST_colorbarToggle_CB( Widget w, XtPointer client_data, XtPointer 
  call_data );
void DST_isotropicVoxelToggle_CB( Widget w, XtPointer client_data, XtPointer 
  call_data );
void DST_voxelSize_changed_CB( Widget w, XtPointer client_data, XtPointer 
  call_data );
void DST_resample_CB( Widget w, XtPointer client_data, XtPointer call_data );
int **DST_resampledMaskXYZ( int *nnzero, THD_3dim_dataset *seeds_dset, 
  int nvox);
void DST_controlPanel_CB( Widget w, XtPointer client_data, XtPointer 
  call_data );
void streamline_controlPanel_CB( Widget w, XtPointer client_data, 
  XtPointer call_data );
void isoSurface_controlPanel_CB( Widget w, XtPointer client_data, 
  XtPointer call_data );
void DST_dt4_gfa_CB(Widget w, XtPointer client_data, XtPointer call_data);
void DST_dt4_distRatio_CB(Widget w, XtPointer client_data, XtPointer 
  call_data);
void DST_dt4_transAngle_CB(Widget w, XtPointer client_data, XtPointer 
  call_data);
void DST_dt4_integTime_CB(Widget w, XtPointer client_data, XtPointer 
  call_data);
void DST_dt4_compute_CB( Widget w, XtPointer client_data, XtPointer 
  call_data );
               // choose files for DST
void DST_load_dsl( Widget w, THD_3dim_dataset *mset, int numSubBricks, 
  int float_ok, int complex_ok );
static int DST_select_vtk( const struct dirent *dir );
void DST_load_vtk( Widget w );

static MCW_action_item DST_actor[1] = {
  {"Help", DST_help_CB, NULL, "Display help", "Display help", 0 }
};
static MCW_action_item DST_actor_stats[1] = {
  {"Stats", DST_stats_CB, NULL, "Display tract stats", "Display tract stats", 0}
};

static THD_3dim_dataset *anat_dset;    // anatomical dataset
static float anat_dset_range[2];     // scalar range for anatomical dataset
void isoSurface_value_changed_CB( Widget w, XtPointer client_data, XtPointer 
  call_data );
void isoSurface_opacity_changed_CB( Widget w, XtPointer client_data, XtPointer 
  call_data );

/** Callbacks ************************************************************/

void recompute_slicer(Widget w, XtPointer client_data, XtPointer call_data);

/* Plane source */

class vtkPSCallback : public vtkCommand
{
public:
  static vtkPSCallback *New() 
    { return new vtkPSCallback; }
  virtual void Execute(vtkObject *caller, unsigned long, void*)
    {
      vtkPlaneSource *planeSource = reinterpret_cast<vtkPlaneSource*>(caller);
      //planeSource->GetPolyData(this->PolyData);
      this->Actor->VisibilityOn();
    }
  vtkPSCallback():PolyData(0),Actor(0) {}
  vtkPolyData *PolyData;
  vtkActor *Actor;
};

/* Line widget */

class vtkLWCallback : public vtkCommand
{
public:
  static vtkLWCallback *New() 
    { return new vtkLWCallback; }
  virtual void Execute(vtkObject *caller, unsigned long, void*)
    {
      vtkLineWidget *lineWidget = reinterpret_cast<vtkLineWidget*>(caller);
      lineWidget->GetPolyData(this->PolyData);
      this->Actor->VisibilityOn();
    }
  vtkLWCallback():PolyData(0),Actor(0) {}
  vtkPolyData *PolyData;
  vtkActor *Actor;
};

/* Plane widget */

class vtkPWCallback : public vtkCommand
{
public:
  static vtkPWCallback *New() 
    { return new vtkPWCallback; }
  virtual void Execute(vtkObject *caller, unsigned long, void*)
    {
      vtkPlaneWidget *planeWidg = reinterpret_cast<vtkPlaneWidget*>(caller);
      planeWidg->GetPolyData(this->PolyData);
      this->Actor->VisibilityOn();
    }
  vtkPWCallback():PolyData(0),Actor(0) {}
  vtkPolyData *PolyData;
  vtkActor *Actor;
};

class vtkPtWCallback : public vtkCommand
{
public:
  static vtkPtWCallback *New()
  { return new vtkPtWCallback; }
  virtual void Execute(vtkObject * caller, unsigned long, void*)
  {
    vtkPointWidget* pointWidg = reinterpret_cast<vtkPointWidget*>(caller);
    pointWidg->GetPolyData(this->PolyData);
    this->Actor->VisibilityOn();
  }
  vtkPtWCallback():PolyData(0), Actor(0) {}
  vtkPolyData* PolyData;
  vtkActor* Actor;
};

// Callback for the interaction with the Plane----------------------------------

class vtkPlaneCallback : public vtkCallbackCommand
{
public:
  int res;

  vtkPolyData *planeData;
  vtkPlane *realPlane;
  vtkPlaneWidget *pW;
  static vtkPlaneCallback *New() 
    { return new vtkPlaneCallback; }
    virtual void Execute(vtkObject *caller, unsigned long eventId, void* callData)
    {
       pW = reinterpret_cast<vtkPlaneWidget*>(caller);
	   switch(eventId) {
	   case vtkCommand::StartInteractionEvent:
	      this->StartInteraction();
	      break;
	   case vtkCommand::InteractionEvent:
	      this->UpdatePlane();
	      break;
	   case vtkCommand::EndInteractionEvent:
	      this->EndInteraction();
	      break;
	     default:
	      cout<< "callData: " << callData << endl
			  << "eventID: "  << eventId  << endl;
	      printf("?\n");
	   }

    }
	// When interaction starts, the integrator is set to the fastest one.
	virtual void StartInteraction () {
	   res = pW->GetResolution();
	   pW->SetResolution(2);
	}

	// When interaction ends, the integrator is set to the original one.
	virtual void EndInteraction () {
	   pW->SetResolution(state.probeResolution);
	   pW->UpdatePlacement();
	   pW->GetPolyData(planeData);
	   pW->GetPlane(realPlane);
	   vtkFloatingPointType n[3]; 
	   realPlane->GetNormal(n); 
	   realPlane->SetNormal(-n[0],-n[1],-n[2]);
	}

	// The polygonal data of the vtkLineWidget is used to
	// define wich startingpoints to use for generating streamlines.
	virtual void UpdatePlane () {
	  pW->GetPolyData(planeData);
	  pW->GetPlane(realPlane);
	  vtkFloatingPointType n[3]; 
	  realPlane->GetNormal(n); 
	  realPlane->SetNormal(-n[0],-n[1],-n[2]);
	  //if(thresher!=NULL) thresher->ThresholdByUpper(fai_thresh_av->fval);
	}
};

class vtkPointCallback : public vtkCallbackCommand
{
public:
  int res;

  vtkPolyData *pointData;
  vtkPointWidget *pW;
  static vtkPointCallback *New() 
    { return new vtkPointCallback; }
    virtual void Execute(vtkObject *caller, unsigned long eventId, void* callData)
    {
       pW = reinterpret_cast<vtkPointWidget*>(caller);
	   switch(eventId) {
	   case vtkCommand::StartInteractionEvent:
	      this->StartInteraction();
	      break;
	   case vtkCommand::InteractionEvent:
	      this->UpdatePlane();
	      break;
	   case vtkCommand::EndInteractionEvent:
	      this->EndInteraction();
	      break;
	     default:
	      cout<< "callData: " << callData << endl
			  << "eventID: "  << eventId  << endl;
	      printf("?\n");
	   }

    }
	virtual void StartInteraction () {
	}

	virtual void EndInteraction () {
	   pW->GetPolyData(pointData);
	}

	virtual void UpdatePlane () {
	  pW->GetPolyData(pointData);
	}
};


/** end callbacks ************************************************************/
void updateAnimation(void *client_data, XtIntervalId *id) {
  u += 1;
  u = u%animation_frames;

  verts->SetInput(pointset[u]);
  printf("using frame %d\n", u);
  verts->Modified();

  timer_id = XtAppAddTimeOut(PLUTO_Xt_appcontext, 1000, updateAnimation, NULL);

  renvWin->Render();
  w2i->SetInput(renvWin);
  w2i->Update();
  w2i->Modified();
  pnm_image_writer->SetInput(w2i->GetOutput());
  char filename[256];
  sprintf(filename, "frame-%d.pnm", u);
  pnm_image_writer->SetFileName(filename);
  pnm_image_writer->Write();
}

void DisplayAnimation(void) {
  char myfilename[256];
  char dummy[256];
    
  for (int i = 0; i < animation_frames; i++) {
    pointset[i] = vtkUnstructuredGrid::New();
    sprintf(myfilename, "viz_data/molecule.molecule_positions.%d.vtk", i*diffusion_steps/animation_frames);
    myreader[i] = vtkDataSetReader::New();
    myreader[i]->SetFileName(myfilename);
    myreader[i]->Update();
    pointset[i] = myreader[i]->GetUnstructuredGridOutput();
    printf("read %d points\n", pointset[i]->GetNumberOfPoints());
  }
  vtkSphereSource *sphere = vtkSphereSource::New();
  data = vtkPolyData::New();
  verts = vtkGlyph3D::New();
  vtkPolyDataMapper *sphereMapper = vtkPolyDataMapper::New();
  if (sphereActor == NULL) {
    sphereActor = vtkActor::New();
  }
  vtkRenderer *ren1= vtkRenderer::New();
  vtkRenderWindow *renWin = vtkRenderWindow::New();

  sphere->SetRadius(0.5 );
  sphere->SetPhiResolution( 8 );
  sphere->SetThetaResolution( 8 );

  verts->SetSource(sphere->GetOutput());
  verts->SetInput(pointset[0]);

  sphereMapper->SetInput( verts->GetOutput() );

  sphereActor->SetMapper( sphereMapper );
  sphereActor->GetProperty()->SetOpacity(0.5);
  sphereActor->GetProperty()->SetColor(0,1,0);

  renv->AddActor(sphereActor) ;
  renv->ResetCamera() ;
  renvWin->Render();  

  updateAnimation(NULL,NULL);
}

void update_diffusion(void) {
  vtkFloatingPointType range[2];

  if (state.trackType == UIState::CONTOUR) {
    if (lig_density_double[state.frame - 1]) {
      track_contour->SetInput(lig_density_double[state.frame - 1]);
      lig_density_double[state.frame - 1]->GetScalarRange(range);
      cout << "Data range: " << range[0] << ":" << range[1] << endl;
      track_contour->Modified();
      printf("using frame %d\n", state.frame - 1);
    }
  }
  else if (state.trackType == UIState::CLOUD) {
    if (lig_density_char[state.frame - 1]) {
      volume_mapper->SetInput(lig_density_char[state.frame - 1]);
      lig_density_char[state.frame - 1]->GetScalarRange(range);
      cout << "Data range: " << range[0] << ":" << range[1] << endl;
      volume_mapper->Modified();
      printf("using frame %d\n", state.frame - 1);
    }
  }

  renvWin->Render();
}

int display_diffusion(void) {
  char myfilename[256];
  char dummy[256];
  vtkFloatingPointType density_range[2];
  double d;
  int dims[3];
  float max_density;
  vtkStructuredPoints *tmp;

  // remove all old data, if there is any...
  if (origin_sphere_actor) {
    origin_sphere_actor->Delete();
  }
  if (opacity_transfer_func) {
    opacity_transfer_func->Delete();
  }
  if (color_transfer_func) {
    color_transfer_func->Delete();
  }
  if (volume_property) {
    volume_property->Delete();
  }
  if (composite_func) {
    composite_func->Delete();
  }
  if (volume_mapper) {
    volume_mapper->Delete();
  }
  if (max_conc_volume) {
    max_conc_volume->Delete();
  }
  if (track_contour) {
    track_contour->Delete();
  }
  if (contour_smoother) {
    contour_smoother->Delete();
  }
  if (contour_mapper) {
    contour_mapper->Delete();
  }
  if(track_contour_actor) {
    track_contour_actor->Delete();
  }
//   if (w2i) {
//     w2i->Delete();
//   }
//   if (png_image_writer) {
//     png_image_writer->Delete();
//   }
  if (pnm_image_writer) {
    pnm_image_writer->Delete();
  }

  for (int i = 0; i < animation_frames; i++) {
    if (diffusion_path_reader[i]) {
      diffusion_path_reader[i]->Delete();
    }
    if (lig_density_char[i]) {
      lig_density_char[i]->Delete();
    }
    if (lig_density_double[i]) {
      lig_density_double[i]->Delete();
    }
  }
    
  for (int i = 0; i < animation_frames; i++) {
    sprintf(myfilename, "viz_data/molecule.ligand_distribution.%d.vtk", i*diffusion_steps/animation_frames);
    diffusion_path_reader[i] = vtkStructuredPointsReader::New();
    diffusion_path_reader[i]->SetFileName(myfilename);
    diffusion_path_reader[i]->Update();
    tmp = diffusion_path_reader[i]->GetOutput();
    if (!tmp) {
      state.loaded = false;
      XtSetSensitive(state.left_animation_frame, false);
      XtSetSensitive(state.right_animation_frame, false);
      return 0;
    }
    lig_density_char[i] = vtkStructuredPoints::New();
    lig_density_char[i]->SetDimensions(tmp->GetDimensions());
    lig_density_char[i]->SetSpacing(tmp->GetSpacing());
    lig_density_char[i]->SetOrigin(tmp->GetOrigin());
    lig_density_char[i]->SetNumberOfScalarComponents(1);
    lig_density_char[i]->SetScalarTypeToUnsignedChar();
    lig_density_char[i]->Update();
    lig_density_double[i] = vtkStructuredPoints::New();
    lig_density_double[i]->SetScalarType(VTK_DOUBLE);
    lig_density_double[i]->SetDimensions(tmp->GetDimensions());
    lig_density_double[i]->SetSpacing(tmp->GetSpacing());
    lig_density_double[i]->SetOrigin(tmp->GetOrigin());
    lig_density_double[i]->SetNumberOfScalarComponents(1);
    lig_density_double[i]->Update();

    tmp->GetScalarRange(density_range);
    max_density = density_range[1];

    lig_density_double[i]->GetDimensions(dims);

    // since we'll be using a pointer outside the normal vtk pipeline,
    // we need to make sure that the arrays are allocated first
    lig_density_double[i]->AllocateScalars();

    // set pointers to data
    int *tmp_i = (int *)tmp->GetScalarPointer();
    double *tmp_d = (double *)lig_density_double[i]->GetScalarPointer();

    // get increments for looping over data
    vtkIdType t_inc[3];
    vtkIdType d_inc[3];
    tmp->GetIncrements(t_inc);
    lig_density_double[i]->GetIncrements(d_inc);

    int kkt = 0, jjt = 0, kkd = 0, jjd = 0;
    for (int kk = 0; kk < dims[2]; 
	 kk++, kkt+=t_inc[2], kkd+=d_inc[2], jjt=0, jjd=0) {
      for (int jj = 0; jj < dims[1]; jj++, jjt+=t_inc[1], jjd+=d_inc[1]) {
        for (int ii = 0; ii < dims[0]; ii++) {
	  // scale to a range that will work for both cloud and
	  // contour models
	  d = tmp_i[ii+jjt+kkt];
	  tmp_d[ii+jjd+kkd] = 255.0*d/max_density;
	}
      }
    }

    lig_density_char[i]->CopyAndCastFrom(lig_density_double[i], 
					 lig_density_double[i]->GetExtent());
  }

  vtkDataSetReader *max_conc_reader = vtkDataSetReader::New();
  max_conc_reader->SetFileName("viz_data/molecule.ligand_distribution.0.vtk");
  max_conc_reader->Update();
  vtkStructuredPoints *max_lig_density_char;
  tmp = max_conc_reader->GetStructuredPointsOutput();
  if (!tmp) {
    state.loaded = false;
    XtSetSensitive(state.left_animation_frame, false);
    XtSetSensitive(state.right_animation_frame, false);
    return 0;
  }
  max_lig_density_char = vtkStructuredPoints::New();
  max_lig_density_char->SetDimensions(tmp->GetDimensions());
  max_lig_density_char->SetSpacing(tmp->GetSpacing());
  max_lig_density_char->SetOrigin(tmp->GetOrigin());
  max_lig_density_char->SetNumberOfScalarComponents(1);
  max_lig_density_char->SetScalarTypeToUnsignedChar();

  for (int i = 0; i < animation_frames; i++) {
    sprintf(myfilename, "viz_data/molecule.ligand_distribution.%d.vtk", i*diffusion_steps/animation_frames);

    max_conc_reader->SetFileName(myfilename);
    max_conc_reader->Update();
    max_conc_reader->GetStructuredPointsOutput()->GetPointData()->GetArray("ligand count")
      ->GetRange(density_range);
    max_density = density_range[1];

    tmp = max_conc_reader->GetStructuredPointsOutput();
    int *tmp_i = (int *)tmp->GetScalarPointer();
    unsigned char *tmp_c = (unsigned char *)max_lig_density_char->GetScalarPointer();

    // get increments for looping over data
    vtkIdType t_inc[3];
    vtkIdType c_inc[3];
    max_lig_density_char->GetIncrements(t_inc);
    tmp->GetIncrements(c_inc);

    int kkc = 0, jjc = 0, kkt = 0, jjt = 0;
    for (int kk = 0; kk < dims[2]; kk++, 
	   kkc+=c_inc[2], kkt+=t_inc[2], jjc=0, jjt=0) {
      for (int jj = 0; jj < dims[1]; jj++, jjc+=c_inc[1], jjt+=t_inc[1]) {
        for (int ii = 0; ii < dims[0]; ii++) {
	  d = tmp_i[ii+jjc+kkc];
	  if (d/max_density > 0.5) {
	    tmp_c[ii+jjt+kkt] = (unsigned char)(i);
	  }
	}
      }
    }
  }

  opacity_transfer_func = vtkPiecewiseFunction::New();
  opacity_transfer_func->AddPoint(0, 0.0);
  opacity_transfer_func->AddPoint(1, 0.01);
  opacity_transfer_func->AddPoint(20, 0.1);
  opacity_transfer_func->AddPoint(80, 0.2);
  opacity_transfer_func->AddPoint(255, 0.4);

  vtkVolumeRayCastCompositeFunction *other_cf =
    vtkVolumeRayCastCompositeFunction::New();
  composite_func = vtkVolumeRayCastCompositeFunction::New();
  color_transfer_func = vtkColorTransferFunction::New();
  color_transfer_func->AddRGBPoint(0, 1.0, 1.0, 1.0);
  color_transfer_func->AddRGBPoint(1, 1.0, 1.0, 0.5);
  color_transfer_func->AddRGBPoint(20, 1.0, 1.0, 0.0);
  color_transfer_func->AddRGBPoint(80, 1.0, 0.0, 0.0);
  color_transfer_func->AddRGBPoint(255, 1.0, 0.0, 1.0);

  volume_property = vtkVolumeProperty::New();
  volume_property->SetColor(color_transfer_func);
  volume_property->SetScalarOpacity(opacity_transfer_func);
  volume_property->ShadeOn();
  volume_property->SetInterpolationTypeToLinear();

  composite_func = vtkVolumeRayCastCompositeFunction::New();
  volume_mapper = vtkVolumeRayCastMapper::New();
  volume_mapper->SetVolumeRayCastFunction(composite_func);
  volume_mapper->SetInput(lig_density_char[0]);

  volume = vtkVolume::New();
  volume->SetMapper(volume_mapper);
  volume->SetProperty(volume_property);

  max_conc_volume = vtkVolume::New();
  vtkPiecewiseFunction *mc_otf = vtkPiecewiseFunction::New();
  mc_otf->AddPoint(0, 0.0);
  mc_otf->AddPoint(1, 0.3);
  mc_otf->AddPoint(255, 0.3);
  vtkColorTransferFunction *mc_ctf = vtkColorTransferFunction::New();
  mc_ctf->AddRGBPoint(0, 1.0, 0.0, 0.0);
  mc_ctf->AddRGBPoint(127, 0.0, 1.0, 0.0);
  mc_ctf->AddRGBPoint(255, 0.0, 0.0, 1.0);

  vtkVolumeProperty *mc_vp = vtkVolumeProperty::New();
  mc_vp->SetColor(mc_ctf);
  mc_vp->SetScalarOpacity(mc_otf);
  mc_vp->ShadeOn();
  mc_vp->SetInterpolationTypeToLinear();

  vtkVolumeRayCastMapper *mc_vm = vtkVolumeRayCastMapper::New();
  mc_vm->SetVolumeRayCastFunction(composite_func);
  mc_vm->SetInput(max_lig_density_char);

  max_conc_volume->SetMapper(mc_vm);
  max_conc_volume->SetProperty(mc_vp);

  // track contours
  track_contour = vtkContourFilter::New();
  track_contour->SetInput(lig_density_char[7]);
  track_contour->GenerateValues(3, 4.0, 128.0);

  contour_smoother = vtkSmoothPolyDataFilter::New();
  contour_smoother->SetNumberOfIterations(500);
  contour_smoother->SetRelaxationFactor(0.01);
  contour_smoother->SetFeatureAngle(150.0);
  contour_smoother->SetEdgeAngle(120.0);
  contour_smoother->SetInput(track_contour->GetOutput());

  contour_mapper = vtkPolyDataMapper::New();
  contour_mapper->SetInput(contour_smoother->GetOutput());
  contour_mapper->SetLookupTable(color_transfer_func);
  
  track_contour_actor = vtkActor::New();
  track_contour_actor->SetMapper(contour_mapper);
  track_contour_actor->GetProperty()->SetAmbient(0.8);
  track_contour_actor->GetProperty()->SetSpecular(0.2);
  track_contour_actor->GetProperty()->SetDiffuse(0.3);
  track_contour_actor->GetProperty()->SetOpacity(0.2);

  vtkSphereSource *origin_sphere = vtkSphereSource::New();
  origin_sphere->SetRadius(0.10);
  ifstream release_file("viz_data/release_site_location", ios::in);
  float release_x;
  float release_y;
  float release_z;
  release_file >> release_x >> release_y >> release_z;
  origin_sphere->SetCenter(release_x, release_y, release_z);
  vtkPolyDataMapper *origin_sphere_mapper = vtkPolyDataMapper::New();
  origin_sphere_mapper->SetInput(origin_sphere->GetOutput());
  origin_sphere_actor = vtkActor::New();
  origin_sphere_actor->SetMapper(origin_sphere_mapper);

  state.loaded = true;
  XtSetSensitive(state.left_animation_frame, true);
  XtSetSensitive(state.right_animation_frame, true);
  return 1;
}

  /*===<DisplayVectorField_old.c>==================================================

  Title: DISPLAY VECTOR FIELD
  Purpose: 

*/
void DisplayVectorField(void)
{
  char *program_name = "DisplayVectorField";
  Boolean FIX_ARROW_LENGTHS = 0;
  double Arrow_Scale_Factor = 1.0 ; // Why???
  vtkFloatingPointType range[2];

  int debug  = 1 ;
  int debug2 = 0 ;

  if(vgrid==NULL) {
    fprintf(stderr,"%s: vgrid is NULL!\n",program_name);
    return ;
  }

  if(debug2) {
    fprintf(stderr,"Inside %s\n",program_name);
    vgrid->Print(cout) ;
  }

  // determine scalar range

  vgrid->GetScalarRange(range);
  if(debug) fprintf(stderr,"%s: range = (%f,%f)\n",program_name,range[0],range[1]) ;

  /***************** Threshold data below fai threshold *****************/

  /***************** Construct arrows *****************/


  vtkGlyphSource2D *arrow = vtkGlyphSource2D::New();
  arrow->SetGlyphTypeToThickArrow();  
  arrow->SetScale(1.0);
  arrow->FilledOff();

  /* actual arrows = vtkGlyph3D */

  vtkGlyph3D *glyph = vtkGlyph3D::New();
  glyph->SetSource(arrow->GetOutput());

  /* scaling mystery */

  glyph->SetScaleModeToScaleByVector();
  glyph->SetScaleMode(VTK_SCALE_BY_VECTOR);
  if(FIX_ARROW_LENGTHS) {
    glyph->ClampingOn();
    Arrow_Scale_Factor *= 200. ; // this is 1/.005
  }
  printf("Arrow_Scale_Factor = %f\n",Arrow_Scale_Factor);
  glyph->SetScaleFactor(Arrow_Scale_Factor*10.0);
  glyph->SetColorModeToColorByScalar();	/* use reflectivity scalars for color */
  glyph->SetVectorModeToUseVector();
  glyph->SetInput(thresher->GetOutput());
  glyph->OrientOn();
  glyph->Modified() ;

  /* Done creating arrows, add them ... */
  vgridMapper->SetInput(glyph->GetOutput());

  /***************** end arrow construction *****************/

  /*** Colormap ***/ 

  range[0] = (vtkFloatingPointType) fai_thresh_av->fval;		// Careful you don't use range after this!
  vtkLookupTable *lut = CreateStandardColorTable( range ) ;

  vgridMapper->SetLookupTable(lut); /* Done creating lookup table, add it ... */

  /*** Outline data ***/ 

  if(outline==NULL) outline = vtkOutlineFilter::New();

  outline->SetInput(vgrid);
  vtkPolyDataMapper *outlineMapper = vtkPolyDataMapper::New();
  outlineMapper->SetInput(outline->GetOutput());
  vtkActor *outlineActor = vtkActor::New();
  outlineActor->SetMapper(outlineMapper);
  outlineActor->GetProperty()->SetColor(0,0,0);

  /* Done outlining, add it ... */

  renv->AddActor(outlineActor); 

  /*** end outline ***/ 

  /* actor, renderer ...*/ 
  vgridActor->SetMapper(vgridMapper) ;
  renv->AddActor(vgridActor) ;
  renv->ResetCamera() ;
  renvWin->Render();  
}

void Launch_vtk_vector_window(Widget shell, THD_3dim_dataset *dset)
{
  func_dset = dset;

  renvWin = vtkXOpenGLRenderWindow::New();
  renv = vtkRenderer::New();

  Widget vtk_vector_widg = setup_vector_widgets(shell,renvWin);
  
  /* X Window stuff end */

  fprintf( stderr, ":) Launch vtk vector window\n" );	

  axes_actor = vtkAxesActor::New();
  axes_actor->SetShaftTypeToCylinder();
  axes_actor->SetXAxisLabelText("x");
  axes_actor->SetYAxisLabelText("y");
  axes_actor->SetZAxisLabelText("z");
  axes_actor->SetTotalLength(1.5,1.5,1.5);
  vtkTextProperty *text_property_x = vtkTextProperty::New();
  vtkTextProperty *text_property_y = vtkTextProperty::New();
  vtkTextProperty *text_property_z = vtkTextProperty::New();
  text_property_x->ItalicOn();
  text_property_x->ShadowOn();
  text_property_x->SetFontFamilyToTimes();
  text_property_y->ShallowCopy(text_property_x);
  text_property_z->ShallowCopy(text_property_x);
  axes_actor->GetXAxisCaptionActor2D()->SetCaptionTextProperty(text_property_x);
  axes_actor->GetYAxisCaptionActor2D()->SetCaptionTextProperty(text_property_y);
  axes_actor->GetZAxisCaptionActor2D()->SetCaptionTextProperty(text_property_z);
  orientation = vtkOrientationMarkerWidget::New();
  orientation->SetOutlineColor(1.0, 0.5, 0.3);
  orientation->SetOrientationMarker(axes_actor);
  orientation->SetViewport(0.0, 0.0, 0.2, 0.2);

  vgridMapper = vtkPolyDataMapper::New(); // data mapper
  vgridActor = vtkActor::New();	// actor
  vgridActor->SetMapper(vgridMapper);

  png_image_writer = vtkPNGWriter::New();
  w2i = vtkWindowToImageFilter::New();
  w2i->SetMagnification(1);

  renv->SetBackground( 0.1, 0.2, 0.4 );	// renderer
  renvWin->AddRenderer( renv );	// render win 
  renvWin->SetSize( 300, 300 );

  // x win
  irenv = vtkXRenderWindowInteractor::New();
  irenv->SetRenderWindow(renvWin);
  irenv->SetWidget(vtk_vector_widg);
  vtkInteractorStyleSwitch *istyle = vtkInteractorStyleSwitch::New();
  irenv->SetInteractorStyle(istyle);
  istyle->SetCurrentStyleToTrackballCamera();

  orientation->SetInteractor(irenv);
  orientation->SetEnabled(1);
  orientation->InteractiveOff();

  /* Initiate a bunch of slicer stuff */
  vtkFloatingPointType vRange[2] = {0.0, 1.0};
  slicer_vLut = CreateStandardColorTable(vRange) ;
/*
  slicer_hue_lut = vtkLookupTable::New();
  slicer_hue_lut->SetTableRange(0.0,1.0);
  slicer_hue_lut->SetHueRange(0.0, 0.0);
  slicer_hue_lut->SetSaturationRange(0.0, 0.0);
  slicer_hue_lut->SetValueRange(0.0, 2.5);
  slicer_hue_lut->Build();
*/
  slicer_hue_lut = vtkLookupTable::New();
//  slicer_hue_lut->SetTableRange(0.0,1.0);
  slicer_hue_lut->SetHueRange(0.0, 0.0);
  slicer_hue_lut->SetSaturationRange(0.0, 0.0);
  slicer_hue_lut->SetValueRange(0.0, 1.0);
  slicer_hue_lut->Build();

  slicer_cylinder = vtkCylinderSource::New();
  slicer_cylinder->SetResolution(12);

  slicer_transform = vtkTransform::New();
  slicer_transform->RotateZ(90.0);

  slicer_tf_filter = vtkTransformPolyDataFilter::New();

  for (int i = 0; i < 3; ++i) {
    slicer_planes[i] = vtkPlane::New();
    slicer_cplanes[i] = vtkPlane::New();
    slicer_cplanes2[i] = vtkPlane::New();
    slicer_iVolumeFilters[i] = vtkExtractVOI::New();
    slicer_vVolumeFilters[i] = vtkExtractVOI::New();
    slicer_iCutters[i] = vtkCutter::New();
    slicer_cmapCutters[i] = vtkCutter::New();
    slicer_cmapCutters2[i] = vtkCutter::New();
    slicer_vCutters[i] = vtkCutter::New();
    slicer_glyphs[i] = vtkGlyph3D::New();
    slicer_iPlanes[i] = vtkImageDataGeometryFilter::New();
    slicer_iMappers[i] = vtkPolyDataMapper::New();
    slicer_cmapMappers[i] = vtkPolyDataMapper::New();
    slicer_cmapMappers2[i] = vtkPolyDataMapper::New();
    slicer_vMappers[i] = vtkPolyDataMapper::New();
    slicer_imgActors[i] = vtkActor::New();
    slicer_imgActors[i]->GetProperty()->SetDiffuse(0.0);
    slicer_imgActors[i]->GetProperty()->SetAmbient(1.0);
    slicer_imgActors[i]->GetProperty()->SetSpecular(0.0);
    slicer_imgActors[i]->GetProperty()->SetOpacity(0.7);
    slicer_cmapActors[i] = vtkActor::New();
    slicer_cmapActors2[i] = vtkActor::New();
    slicer_cmapActors[i]->GetProperty()->SetDiffuse(0.0);
    slicer_cmapActors[i]->GetProperty()->SetAmbient(1.0);
    slicer_cmapActors[i]->GetProperty()->SetSpecular(0.0);
    slicer_cmapActors[i]->GetProperty()->SetOpacity(1.0);
    slicer_cmapActors2[i]->GetProperty()->SetDiffuse(0.0);
    slicer_cmapActors2[i]->GetProperty()->SetAmbient(1.0);
    slicer_cmapActors2[i]->GetProperty()->SetSpecular(0.0);
    slicer_cmapActors2[i]->GetProperty()->SetOpacity(1.0);
    slicer_vecActors[i] = vtkActor::New();
  }

  slicer_outline = vtkOutlineFilter::New();
  slicer_outlineMapper = vtkPolyDataMapper::New();
  slicer_outlineActor = vtkActor::New();
  slicer_outlineActor->GetProperty()->SetColor(0,0,0);

#ifdef EXPERIMENTAL
  // get diffusion stuff started 
  display_diffusion();
#endif

  renv->ResetCamera() ;
  renvWin->Render();
  irenv->Initialize(XtWidgetToApplicationContext(vtk_vector_widg)) ;
  
  fprintf( stderr, ":( exiting vtk window\n" );	

}

// send crosshair location to vector window
void send_xhair_to_vtk_vector_window(float x, float y, float z) {
  state.xhair_x = x;
  state.xhair_y = y;
  state.xhair_z = z;
}

// send vector data to vector window

void Send_VData_to_vtk_vector_window( vtkStructuredPoints *data )
{
  char *program_name = "Send_VData_to_vtk_vector_window" ;
  int debug = 0 ;

  if(debug) {
    fprintf(stderr,"Inside %s\n",program_name);
    data->Print(cout) ;
  }

  vtkFloatArray *vector_data = vtkFloatArray::SafeDownCast(
    data->GetPointData()->GetVectors());
  vtkFloatArray *fai_data = vtkFloatArray::SafeDownCast(
    data->GetPointData()->GetScalars());
  vtkFloatingPointType vector_range[2];
  vtkFloatingPointType vector_max;

  vector_data->GetRange(vector_range);
  vector_max = vector_range[1];

  int idims[3];
  data->GetDimensions(idims);
  vtkUnsignedCharArray *ColorMap = vtkUnsignedCharArray::New();
  ColorMap->SetNumberOfComponents(4);
  ColorMap->SetNumberOfTuples(vector_data->GetNumberOfTuples());

  vtkFloatingPointType *vector_point_data;
  unsigned char *color_point_data = new unsigned char[4];
  color_point_data[3] = 255;

  for (int i = 0; i < vector_data->GetNumberOfTuples(); i++) {
    vector_point_data = vector_data->GetTuple(i);
    for (int j = 0; j < 3; j++) {
      color_point_data[j] = (unsigned char)abs(255.0*vector_point_data[j]/vector_max);
    }
    color_point_data[3] = (unsigned char)abs(255.0*fai_data->GetTuple(i)[0]);
    ColorMap->SetTupleValue(i, color_point_data);
  }

  vgrid = vtkStructuredPoints::New();
  vgrid->ShallowCopy(data) ;

  cgrid = vtkStructuredPoints::New();
  cgrid->SetDimensions(data->GetDimensions());
  cgrid->SetSpacing(data->GetSpacing());
  cgrid->SetOrigin(data->GetOrigin());
  cgrid->GetPointData()->SetScalars(ColorMap);
  vtkFloatingPointType c_range[2];
  cgrid->GetScalarRange(c_range);

  if(thresher==NULL) thresher = vtkThreshold::New();
  thresher->ThresholdByUpper(fai_thresh_av->fval);
  thresher->SetInput(vgrid);

  for (int i = 0; i < 3; ++i) {
    if(sliceThreshers[i] == NULL) sliceThreshers[i] = vtkThreshold::New();
    if(cmapThreshers[i] == NULL) cmapThreshers[i] = vtkThreshold::New();
    sliceThreshers[i]->ThresholdByUpper(fai_thresh_av->fval);
    cmapThreshers[i]->ThresholdByUpper(255.0*fai_thresh_av->fval-25.5);
    cmapThreshers[i]->SetComponentModeToUseSelected();
    cmapThreshers[i]->SetSelectedComponent(3);
  }

  int vdims[3];
  vgrid->GetDimensions(vdims);

//  state.maxProbeResolution = MAX(MAX(vdims[0], vdims[1]), vdims[2]);
//  state.probeResolution = (int)sqrt(state.maxProbeResolution);

  updateWidgets();
}

// send image data to vector window
void Send_IData_to_vtk_vector_window( vtkStructuredPoints *data, 
  THD_3dim_dataset *anat )
{
  char *program_name = "Send_IData_to_vtk_vector_window" ;
  int debug = 0 ;

  if(debug) {
    fprintf(stderr,"Inside %s\n",program_name);
    data->Print(cout) ;
  }
               // anatomical dataset
  anat_dset = anat;
  anat_dset_range[0] = anat_dset->stats->bstat[0].min;	       
  anat_dset_range[1] = anat_dset->stats->bstat[0].max;	       

  igrid = vtkStructuredPoints::New();
  igrid->ShallowCopy(data);

  int idims[3];
  igrid->GetDimensions(idims);

  for (int i = 0; i < 3; ++i)
  {
     state.maxSliceNum[i] = idims[i] - 1;
     state.sliceNum[i] = state.maxSliceNum[i]/2;
     sprintf(state.sliderText[i], "%d", state.sliceNum[i]);
  }

  vtkFloatingPointType range[2];
  igrid->GetScalarRange(range);
               // scale the scalar value in igrid
  float scale = anat_dset_range[1]/range[1];
  if( scale != 1.0 )
  {
    int numPts = igrid->GetNumberOfPoints();
    vtkFloatArray *idata = vtkFloatArray::SafeDownCast(
      igrid->GetPointData()->GetScalars());
    vtkFloatArray *idata_scaled = vtkFloatArray::New();
    idata_scaled->SetNumberOfTuples( DSET_NVOX( anat ) );

    float val;
    for( int i=0; i<numPts; i++ )
    {
      val = idata->GetComponent(i,0);
      val *= scale;
//    idata->SetComponent(i,0,val);
      idata_scaled->SetTuple(i,&val);
    }
    igrid->GetPointData()->SetScalars( idata_scaled );
    igrid->Update();
    idata_scaled->Delete();
               // update the range for igrid
    igrid->GetScalarRange( range );
  }
               // initialize slicer widgets
  slicer_wProp = vtkProperty::New();
  slicer_wPicker = vtkCellPicker::New();
  slicer_wPicker->SetTolerance( 0.005 );
  for( int i=0; i<3; ++i)
  {
    slicer_widgets[i] = vtkImagePlaneWidget::New();
    slicer_widgets[i]->SetInput( igrid );
    slicer_widgets[i]->DisplayTextOn();
    slicer_widgets[i]->RestrictPlaneToVolumeOn();
    slicer_widgets[i]->SetTexturePlaneProperty( slicer_wProp );
    slicer_widgets[i]->SetPicker( slicer_wPicker );
    slicer_widgets[i]->SetResliceInterpolateToLinear();
    slicer_widgets[i]->KeyPressActivationOn();
    slicer_widgets[i]->SetInteractor( irenv );
//    slicer_widgets[i]->GetPlaneProperty()->SetColor(1,0,0);
//    slicer_widgets[i]->SetLookupTable( slicer_hue_lut );
  }

  state.minContourLevel = range[0];
  state.maxContourLevel = range[1];
  if (range[0] != range[1])
  {
     state.contourDecimalPoints = (int)(-log10(range[1] - range[0])) + 2;
     if(state.contourDecimalPoints < 0)
     {
	state.contourIncrement = (int)(pow(10, -state.contourDecimalPoints));
	state.contourDecimalPoints = 0;
     }
  }

  if(iThresher==NULL) iThresher = vtkThreshold::New();
  iThresher->SetInput(igrid);

  updateWidgets();
  recompute_slicer(NULL,NULL,NULL);
  axial_view_cb(NULL,NULL,NULL);
}
               // send cross-hair location and datasets to vtk window
void Send_xhair_to_vtk_window( int voxel_ijk, THD_3dim_dataset *dwi,
  THD_3dim_dataset *shd, THD_3dim_dataset *dt2, DIF_state *difState,
  vtkPolyData *grid )
{
  ijkvox = voxel_ijk;
  dwi_dset = dwi;
  shd_dset = shd;
  func_dset = dt2;
  current_dif_state = difState;
  vGrid = grid;

  if( voxel_signal_on ) view_voxel_signal();
  if( voxel_odf_on ) view_voxel_odf();
  if( voxel_shd_on ) view_voxel_shd();
  if( voxel_dt2_on ) view_voxel_dt2();
}

void Launch_vtk_window(Widget shell)
{
  vtkAxesActor *signal_axes_actor;
  vtkOrientationMarkerWidget *signal_orientation;

  signal_axes_actor = vtkAxesActor::New();
  signal_axes_actor->SetShaftTypeToCylinder();
  signal_axes_actor->SetXAxisLabelText("x");
  signal_axes_actor->SetYAxisLabelText("y");
  signal_axes_actor->SetZAxisLabelText("z");
  vtkTextProperty *text_property_x = vtkTextProperty::New();
  vtkTextProperty *text_property_y = vtkTextProperty::New();
  vtkTextProperty *text_property_z = vtkTextProperty::New();
  text_property_x->ItalicOn();
  text_property_x->ShadowOn();
  text_property_x->SetFontFamilyToTimes();
  text_property_y->ShallowCopy(text_property_x);
  text_property_z->ShallowCopy(text_property_x);
  signal_axes_actor->GetXAxisCaptionActor2D()->SetCaptionTextProperty(text_property_x);
  signal_axes_actor->GetYAxisCaptionActor2D()->SetCaptionTextProperty(text_property_y);
  signal_axes_actor->GetZAxisCaptionActor2D()->SetCaptionTextProperty(text_property_z);
  signal_orientation = vtkOrientationMarkerWidget::New();
  signal_orientation->SetOutlineColor(1.0, 0.5, 0.3);
  signal_orientation->SetOrientationMarker(signal_axes_actor);
  signal_orientation->SetViewport(0.0, 0.0, 0.4, 0.4);

  renWin = vtkXOpenGLRenderWindow::New();
  ren1 = vtkRenderer::New();
  ren2 = vtkRenderer::New();
               // initialize
  voxel_signal_on = voxel_odf_on = voxel_shd_on = voxel_dt2_on = false;

  Widget vtk_widg = setup_widgets(shell,renWin);
  
  /* X Window stuff end */

  fprintf( stderr, ":) Launch vtk window\n" );	
  
  shape = ParametricSHD::New();
  shape_source = vtkParametricFunctionSource::New();

  shape->Setlmax(4);

  shape_source->SetParametricFunction(shape);

  shapeO = ParametricSHD::New();
  shapeO_source = vtkParametricFunctionSource::New();

  shapeO->Setlmax(4);

  shapeO_source->SetParametricFunction(shapeO);
               // for tensor ellipsoid
  ellipsoid = vtkParametricEllipsoid::New();
  ellipSource = vtkParametricFunctionSource::New();
  //
  // In this example we terminate the pipeline with a mapper process object.
  // (Intermediate filters such as vtkShrinkPolyData could be inserted in
  // between the source and the mapper.)  We create an instance of
  // vtkPolyDataMapper to map the polygonal data into graphics primitives. We
  // connect the output of the cone souece to the input of this mapper.
  //
  //vtkPolyDataMapper *dataMapper = vtkPolyDataMapper::New();
  dataMapper = vtkPolyDataMapper::New();
  //dataMapper->SetInput( data );

  //
  // Create an actor to represent the data. The actor orchestrates rendering
  // of the mapper's graphics primitives. An actor also refers to properties
  // via a vtkProperty instance, and includes an internal transformation
  // matrix. We set this actor's mapper to be dataMapper which we created
  // above.
  //
  //vtkActor *dataActor = vtkActor::New();
  dataActor = vtkActor::New();
  //dataActor->SetMapper( dataMapper );

  //
  // Create the Renderer and assign actors to it. A renderer is like a
  // viewport. It is part or all of a window on the screen and it is
  // responsible for drawing the actors it has.  We also set the background
  // color here.
  //

  camera = vtkCamera::New();
  camera->SetPosition(0.0,0.0,3.0);
  camera->SetFocalPoint(0.0,0.0,0.0);
  camera->SetViewAngle(25);

  ren1->AddActor( dataActor );
//  ren1->SetBackground( 0.1, 0.2, 0.4 );
  ren1->SetViewport(0.0, 0.0, 1.0, 1.0);
  ren1->SetActiveCamera(camera);

  //
  // Finally we create the render window which will show up on the screen.
  // We put our renderer into the render window using AddRenderer. We also
  // set the size to be 300 pixels by 300.
  //

  renWin->AddRenderer( ren1 );
  renWin->SetSize( 300, 300 );

  // we typecast to an X specific interactor
  // Since we have decided to make this an X program
  //vtkXRenderWindowInteractor *iren = vtkXRenderWindowInteractor::New();
  iren = vtkXRenderWindowInteractor::New();
  iren->SetRenderWindow(renWin);
  iren->SetWidget(vtk_widg);

  renWin->Render();
  iren->Initialize(XtWidgetToApplicationContext(vtk_widg)) ;

  signal_orientation->SetInteractor(iren);
  signal_orientation->SetEnabled(1);
  signal_orientation->InteractiveOff();

  //
  // Free up any objects we created. All instances in VTK are deleted by
  // using the Delete() method.
  //
  fprintf( stderr, ":( exiting vtk window\n" );	
}

               // single voxel signal callback
void voxel_signal_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
  if( voxel_signal_on ) return;
  voxel_signal_on = true;
  MCW_invert_widget( button_signal );
  if( voxel_odf_on ) MCW_invert_widget( button_odf );
  if( voxel_shd_on ) MCW_invert_widget( button_shd );
  if( voxel_dt2_on ) MCW_invert_widget( button_dt2 );
  voxel_odf_on = voxel_shd_on = voxel_dt2_on = false;

  view_voxel_signal();
}

void view_voxel_signal( void )
{
               // return if no dwi dataset is loaded, otherwise load it.
  if( dwi_dset == NULL )
  {
    cerr<<"dwi dataset to view not loaded"<<endl;
    return;
  }  
  else DSET_load( dwi_dset );

  int typeDset = DSET_BRICK_TYPE( dwi_dset, 0 );
  if( typeDset != MRI_short ) cerr<<"Debug: check to make sure we are " 
    <<"looking at shorts"<<endl;
               // allocate memory
  int nvert = current_dif_state->img->dgrad->nvert;
  short **sptr = new short*[nvert];
  float *fxar = new float[nvert];
               // skip the first array, which is b=0 image
  for( int i=0; i<nvert; ++i ) 
    sptr[i] = (short*)DSET_ARRAY( dwi_dset, i+1 );
  for( int i=0; i<nvert; ++i )
    fxar[i] = (float)sptr[i][ijkvox];
  
  vtkFloatArray *vSignal = vtk_LoadSignal( fxar, nvert );
  vtkPolyData *vGridSig = MapSignal2VertexGrid( vGrid, vSignal );

//  Send_Data_to_vtk_window( vGridSig );
               // visualize             
  if( dataActor != NULL ) ren1->RemoveActor( dataActor );
  dataMapper->SetInput( vGridSig );
  dataMapper->Modified();
  dataActor->SetMapper( dataMapper );
  ren1->AddActor( dataActor );
  ren1->ResetCamera() ;
  renWin->Render();  
               // release memory
  vGridSig->Delete();
  vSignal->Delete();
  delete[] sptr;
  delete[] fxar;
}

void voxel_odf_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
  if( voxel_odf_on ) return;
  voxel_odf_on = true;
  MCW_invert_widget( button_odf );
  if( voxel_signal_on ) MCW_invert_widget( button_signal );
  if( voxel_shd_on ) MCW_invert_widget( button_shd );
  if( voxel_dt2_on ) MCW_invert_widget( button_dt2 );
  voxel_signal_on = voxel_shd_on = voxel_dt2_on = false;

  view_voxel_odf();
}

void view_voxel_odf( void )
{
  if( shd_dset == NULL )
  {
    cerr<<"shd dataset to compute SHD coefficients not loaded"<<endl;
    return;
  }
  else DSET_load( shd_dset );

  int typeDset = DSET_BRICK_TYPE( shd_dset, 0 );
  if( typeDset != MRI_complex ) cerr<<"Debug: check to make sure we are " 
    <<"looking at complex data"<<endl;
               // allocate memory
  int ndif = DSET_NVALS( shd_dset );
  complex **cptr = new complex*[ndif];
  complex *cxar = new complex[ndif];
  for( int i=0; i<ndif; ++i )
    cptr[i] = (complex*)DSET_ARRAY( shd_dset, i );
  for( int i=0; i<ndif; ++i )
    cxar[i] = cptr[i][ijkvox];
  
  current_dif_state->shd->calc->Alm = 
    alm_alloc( current_dif_state->shd->calc->Lmax );
  current_dif_state->shd->calc->Olm = 
    alm_alloc( current_dif_state->shd->calc->Lmax );
  zvtoAlm( current_dif_state->shd->calc->Alm, cxar, 
    current_dif_state->shd->calc->Lmax );
  alm2olm(current_dif_state->shd->calc->Alm,
    current_dif_state->shd->calc->Olm,
    current_dif_state->shd->calc->Lmax);
    
//  Send_Olm_to_vtk_window(current_dif_state->shd->calc->Olm,
//    current_dif_state->shd->calc->Lmax);
               // visualize             
  shapeO->SetAlm(current_dif_state->shd->calc->Olm, 
    current_dif_state->shd->calc->Lmax);
  shapeO_source->Update();

  if( dataActor != NULL ) ren1->RemoveActor( dataActor );
  dataMapper->SetInput(shapeO_source->GetOutput());
  dataActor->SetMapper(dataMapper);
  ren1->AddActor( dataActor );
  ren1->ResetCamera() ;
  renWin->Render();  
               // releae memory
  delete[] cptr;
  delete[] cxar;
}

void voxel_shd_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
  if( voxel_shd_on ) return;
  voxel_shd_on = true;
  MCW_invert_widget( button_shd );
  if( voxel_signal_on ) MCW_invert_widget( button_signal );
  if( voxel_odf_on ) MCW_invert_widget( button_odf );
  if( voxel_dt2_on ) MCW_invert_widget( button_dt2 );
  voxel_signal_on = voxel_odf_on = voxel_dt2_on = false;

  view_voxel_shd();
}

void view_voxel_shd( void )
{
  if( shd_dset == NULL )
  {
    cerr<<"shd dataset to compute SHD coefficients not loaded"<<endl;
    return;
  }
  else DSET_load( shd_dset );

  int typeDset = DSET_BRICK_TYPE( shd_dset, 0 );
  if( typeDset != MRI_complex ) cerr<<"Debug: check to make sure we are " 
    <<"looking at complex data"<<endl;
               // allocate memory
  int ndif = DSET_NVALS( shd_dset );
  complex **cptr = new complex*[ndif];
  complex *cxar = new complex[ndif];
  for( int i=0; i<ndif; ++i )
    cptr[i] = (complex*)DSET_ARRAY( shd_dset, i );
  for( int i=0; i<ndif; ++i )
    cxar[i] = cptr[i][ijkvox];
  
  current_dif_state->shd->calc->Alm = 
    alm_alloc( current_dif_state->shd->calc->Lmax );
  zvtoAlm( current_dif_state->shd->calc->Alm, cxar, 
    current_dif_state->shd->calc->Lmax );
    
 // Send_Alm_to_vtk_window(current_dif_state->shd->calc->Alm,
 //   current_dif_state->shd->calc->Lmax);
               // visualize             
  shape->SetAlm(current_dif_state->shd->calc->Alm, 
    current_dif_state->shd->calc->Lmax );
  shape_source->Update();

  if( dataActor != NULL ) ren1->RemoveActor( dataActor );
  dataMapper->SetInput(shape_source->GetOutput());
  dataActor->SetMapper(dataMapper);
  ren1->AddActor( dataActor );
  ren1->ResetCamera() ;
  renWin->Render();  
               // release memory
  delete[] cptr;
  delete[] cxar;
}
void voxel_dt2_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
  if( voxel_dt2_on ) return;
  voxel_dt2_on = true;
  MCW_invert_widget( button_dt2 );
  if( voxel_signal_on ) MCW_invert_widget( button_signal );
  if( voxel_odf_on ) MCW_invert_widget( button_odf );
  if( voxel_shd_on ) MCW_invert_widget( button_shd );
  voxel_signal_on = voxel_odf_on = voxel_shd_on = false;

  view_voxel_dt2();
}  

void view_voxel_dt2( void )
{
  if( func_dset == NULL )
  {
    cerr<<"dti dataset not loaded"<<endl;
    return;
  }
  else DSET_load( func_dset );

  int typeDset = DSET_BRICK_TYPE( func_dset, 0 );
  if( typeDset != MRI_float ) cerr<<"Debug: check to make sure we are " 
    <<"looking at floats"<<endl;
               // allocate memory
  int ndif = DSET_NVALS( func_dset );
  float **fptr = new float*[ndif];
  float *fxar = new float[ndif];
  for( int i=0; i<ndif; ++i )
    fptr[i] = (float *)DSET_ARRAY( func_dset,i );
  for( int i=0; i<ndif; ++i )
    fxar[i] = fptr[i][ijkvox];
  
//  Send_DT2_to_vtk_window( fxar );
               // visualize             
               // retrieve eigenvalues
  float l1 = fxar[6], l2 = fxar[7], l3 = fxar[8];
  ellipsoid->SetXRadius( l1 );
  ellipsoid->SetYRadius( l2 );
  ellipsoid->SetZRadius( l3 );
  ellipSource->SetParametricFunction( ellipsoid );
  ellipSource->SetScalarModeToDistance();

  if( dataActor != NULL ) ren1->RemoveActor( dataActor );
  dataMapper->SetInput( ellipSource->GetOutput() );
  dataActor->SetMapper( dataMapper );
  ren1->AddActor( dataActor );
  ren1->ResetCamera();
  renWin->Render();
               // release memory
  delete[] fptr;
  delete[] fxar;
}

/* axial view callback */
void axial_view_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  int dims[3];
  vtkFloatingPointType spacing[3];
  vtkFloatingPointType origin[3];

  vgrid->GetDimensions(dims);
  vgrid->GetSpacing(spacing);
  vgrid->GetOrigin(origin);
  for (int i = 0; i < 3; i++) {
    origin[i] += spacing[i]*dims[i]/2.0;
  }
  renv->GetActiveCamera()->SetFocalPoint(origin);
  cout << "Setting focal point: " << origin[0] << ", "
       << origin[1] << ", "
       << origin[2] << endl;
  origin[2] += spacing[2]*dims[2];
  renv->GetActiveCamera()->SetPosition(origin);
  cout << "Setting camera position: " << origin[0] << ", "
       << origin[1] << ", "
       << origin[2] << endl;
  renv->GetActiveCamera()->SetViewUp(0.0, -1.0, 0.0);

  renv->ResetCamera();
  renvWin->Render();
}

/* sagittal view callback */
void sagittal_view_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  int dims[3];
  vtkFloatingPointType spacing[3];
  vtkFloatingPointType origin[3];

  vgrid->GetDimensions(dims);
  vgrid->GetSpacing(spacing);
  vgrid->GetOrigin(origin);
  for (int i = 0; i < 3; i++) {
    origin[i] += spacing[i]*dims[i]/2.0;
  }
  renv->GetActiveCamera()->SetFocalPoint(origin);
  cout << "Setting focal point: " << origin[0] << ", "
       << origin[1] << ", "
       << origin[2] << endl;
  origin[0] += spacing[0]*dims[0];
  renv->GetActiveCamera()->SetPosition(origin);
  cout << "Setting camera position: " << origin[0] << ", "
       << origin[1] << ", "
       << origin[2] << endl;
  renv->GetActiveCamera()->SetViewUp(0.0, 0.0, 1.0);

  renv->ResetCamera();
  renvWin->Render();
}

/* coronal view callback */
void coronal_view_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  int dims[3];
  vtkFloatingPointType spacing[3];
  vtkFloatingPointType origin[3];

  vgrid->GetDimensions(dims);
  vgrid->GetSpacing(spacing);
  vgrid->GetOrigin(origin);
  for (int i = 0; i < 3; i++) {
    origin[i] += spacing[i]*dims[i]/2.0;
  }
  renv->GetActiveCamera()->SetFocalPoint(origin);
  cout << "Setting focal point: " << origin[0] << ", "
       << origin[1] << ", "
       << origin[2] << endl;
  origin[1] += spacing[1]*dims[1];
  renv->GetActiveCamera()->SetPosition(origin);
  cout << "Setting camera position: " << origin[0] << ", "
       << origin[1] << ", "
       << origin[2] << endl;
  renv->GetActiveCamera()->SetViewUp(0.0, 0.0, 1.0);

  renv->ResetCamera();
  renvWin->Render();
}

void axial_vector_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  if (axial_vectors) {
    axial_vectors = false;
    if(sliceThreshers[2] != NULL) {
      sliceThreshers[2]->ThresholdByUpper(1.0);
    }
  }
  else {
    axial_vectors = true;
    if(sliceThreshers[2] != NULL) {
      sliceThreshers[2]->ThresholdByUpper(fai_thresh_av->fval);
    }
  }
  renvWin->Render();
}

void sagittal_vector_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  if (sagittal_vectors) {
    sagittal_vectors = false;
    if(sliceThreshers[0] != NULL) {
      sliceThreshers[0]->ThresholdByUpper(1.0);
    }
  }
  else {
    sagittal_vectors = true;
    if(sliceThreshers[0] != NULL) {
      sliceThreshers[0]->ThresholdByUpper(fai_thresh_av->fval);
    }
  }
  renvWin->Render();
}

void coronal_vector_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  if (coronal_vectors) {
    coronal_vectors = false;
    if(sliceThreshers[1] != NULL) {
      sliceThreshers[1]->ThresholdByUpper(1.0);
    }
  }
  else {
    coronal_vectors = true;
    if(sliceThreshers[1] != NULL) {
      sliceThreshers[1]->ThresholdByUpper(fai_thresh_av->fval);
    }
  }
  renvWin->Render();
}

void boundingbox_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  if (show_outline) {
    show_outline = false;
  }
  else {
    show_outline = true;
  }
  recompute_slicer(w, client_data, call_data);
}

void axes_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  if (show_axes) {
    show_axes = false;
    orientation->SetEnabled(0);
  }
  else {
    show_axes = true;
    orientation->SetEnabled(1);
  }
  renvWin->Render();
}

void colormap_cb(Widget w, XtPointer client_data, XtPointer call_data) {
   int i;
   for(i = 0; i < 3; ++i)
   {
      if(w == colormap_button[i])
      {
	 break;
      }
   }
   if(i == 3)
   {
      abort();
   }

   char wState = 
      reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

   switch(wState)
   {
      case XmSET:
	 colormap[i] = true;
	 break;
      case XmUNSET:
	 colormap[i] = false;
	 break;
   }

   recompute_slicer(w, client_data, call_data);
}


/* quit callback */

void quit_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
  if(vgrid!=NULL) vgrid->Delete() ;
  XtUnmapWidget( (Widget)client_data ) ; 
}

//void fai_thresh_av_CB( MCW_arrowval * av , XtPointer cd )
void fai_thresh_av_CB( void )
{
  char *program_name = "fai_thresh_av_CB";
  int cc ;

//  fprintf(stderr,"Inside %s: fval = %f\n",program_name,av->fval);

#if 0
  if(planeWidget!=NULL) {
    vtkPlane    *realPlane = vtkPlane::New();
    vtkPolyData *plane = vtkPolyData::New();

    planeWidget->GetPolyData(plane);
    planeWidget->GetPlane(realPlane);
    float n[3]; realPlane->GetNormal(n); realPlane->SetNormal(-n[0],-n[1],-n[2]);
    if(thresher!=NULL) thresher->ThresholdByUpper(fai_thresh_av->fval);

    realPlane->Delete();
    plane->Delete();
  }
#endif

  if(thresher!=NULL) thresher->ThresholdByUpper(fai_thresh_av->fval);
  for (int i = 0; i < 3; ++i) {
    if(sliceThreshers[i] != NULL) {
      sliceThreshers[i]->ThresholdByUpper(fai_thresh_av->fval);
    }
    if(cmapThreshers[i] != NULL) {
      cmapThreshers[i]->ThresholdByUpper(255.0*fai_thresh_av->fval-25.5);
    }
  }
  renvWin->Render();

  return ;
}

/*-------------------------------------------------------------------------
   fai_thresh_cb
   When the user presses Enter in a textfield that might have an
   expression entered, evaluate the expression numerically and
   load that number back into the textfield.
---------------------------------------------------------------------------*/

void fai_thresh_cb( Widget wtex, XtPointer client_data, XtPointer call_data )
{
   MCW_arrowval * av         = (MCW_arrowval *) client_data ;
   XmAnyCallbackStruct * cbs = (XmAnyCallbackStruct *) call_data ;
   float sval ;
   int iv ;

   MCW_invert_widget(wtex) ;

   sval = DIFF_evaluate( av ) ;
   AV_assign_fval( av , sval ) ;

   MCW_invert_widget(wtex) ;
   return ;
}

/* callback to write MCell input files */
void toMCell_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  static bool displayed = false;
  char *program_name = "toMCell_cb" ;

  int evec_offset = 0;
  int nvox = DSET_NVOX(func_dset);
  printf("nvox: %d\n", nvox);
  int nbrk = DSET_NVALS(func_dset);
  int nx   = DSET_NX(func_dset);
  int ny   = DSET_NY(func_dset);
  int nz   = DSET_NZ(func_dset);
  int nxy  = nx * ny;		

  float dx = DSET_DX(func_dset);
  float dy = DSET_DY(func_dset);
  float dz = DSET_DZ(func_dset);

  float max_dim = 0.0;
  max_dim = max_dim > dx ? max_dim : dx;
  max_dim = max_dim > dy ? max_dim : dy;
  max_dim = max_dim > dz ? max_dim : dz;

  float release_x = state.xhair_x;
  float release_y = state.xhair_y;
  float release_z = state.xhair_z;
  ofstream release_site_file("viz_data/release_site_location", ios::out);
  release_site_file << release_x << " " << release_y << " " << release_z
		    << endl;
  release_site_file.close();

  float vec[7];
  vtkStructuredPoints *Evecs = vtkStructuredPoints::New();
  Evecs->SetNumberOfScalarComponents(7);

  vtkFloatArray *NewVectors = vtkFloatArray::New();
  NewVectors->SetNumberOfComponents(7);
  NewVectors->SetNumberOfTuples(nvox);

  int typeDset = DSET_BRICK_TYPE( func_dset, evec_offset );
  
  switch(typeDset) {
  case MRI_float:
    { /* "{" necessary to protect initialization of origin_dicom below */

      ofstream mdlfile("tensor.mdl", ios::out);
      mdlfile.precision(10);
      mdlfile << "dt = " << max_dim*max_dim*1000.0 << endl
	      << "TIME_STEP = dt" << endl
	      << "ITERATIONS = " << diffusion_steps << endl;

      float *dxx, *dxy, *dxz, *dyy, *dyz, *dzz, *fai;

      /*
       * To compute the origin in terms of Dicom coordinates, we use
       * the axes' to_dicomm transformation
       */
      THD_fvec3 origin_dset;
      LOAD_FVEC3(origin_dset, 
		 DSET_XORG(func_dset), 
		 DSET_YORG(func_dset), 
		 DSET_ZORG(func_dset));
      if (dx < 0.0) {
	origin_dset.xyz[0] = origin_dset.xyz[0] + dx * (nx - 1);
      }
      if (dy < 0.0) {
	origin_dset.xyz[1] = origin_dset.xyz[1] + dy * (ny - 1);
      }
      if (dz < 0.0) {
	origin_dset.xyz[2] = origin_dset.xyz[2] + dz * (nz - 1);
      }

      THD_fvec3 origin_dicom = THD_3dmm_to_dicomm(func_dset, 
						  origin_dset);

      Evecs->SetOrigin((vtkFloatingPointType) origin_dicom.xyz[0],
		       (vtkFloatingPointType) origin_dicom.xyz[1],
		       (vtkFloatingPointType) origin_dicom.xyz[2]);

      /*
       * We use the Dicom axes as our canonical coordinate system,
       * which are x = R->L, y = A->P, z = I->S
       */

      if (func_dset->daxes->xxorient == ORI_R2L_TYPE ||
	  func_dset->daxes->xxorient == ORI_L2R_TYPE) {
	if (func_dset->daxes->yyorient == ORI_P2A_TYPE ||
	    func_dset->daxes->yyorient == ORI_A2P_TYPE) {
	  Evecs->SetDimensions(nx, ny, nz);
	  Evecs->SetSpacing(fabs(dx), fabs(dy), fabs(dz));

	  mdlfile << "PARTITION_X = [[" 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0+(nx)*fabs(dx))*1000.0
		  << " STEP "
		  << fabs(dx)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Y = [[" 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0+(ny)*fabs(dy))*1000.0
		  << " STEP "
		  << fabs(dy)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Z = [[" 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0+(nz)*fabs(dz))*1000.0
		  << " STEP "
		  << fabs(dz)*1000.0 << "]]" << endl;

	  printf("PARTITION_X = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[0] - fabs(dx)/2.0)*1000.0,
		 (origin_dicom.xyz[0] - fabs(dx)/2.0 + (nx)*fabs(dx))*1000.0,
		 fabs(dx)*1000.0);
	  printf("PARTITION_Y = [[%f TO %f STEP %f]]\n", 
		 origin_dicom.xyz[1] - fabs(dy)/2.0,
		 origin_dicom.xyz[1] - fabs(dy)/2.0 + (ny)*fabs(dy),
		 fabs(dy)*1000.0);
	  printf("PARTITION_Z = [[%f TO %f STEP %f]]\n", 
		 origin_dicom.xyz[2] - fabs(dz)/2.0,
		 origin_dicom.xyz[2] - fabs(dz)/2.0 + (nz)*fabs(dz),
		 fabs(dz)*1000.0);
	}
	else { //yyorient is I2S or S2I
	  Evecs->SetDimensions(nx, nz, ny);
	  Evecs->SetSpacing(fabs(dx), fabs(dz), fabs(dy));

	  mdlfile << "PARTITION_X = [[" 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0+(nx)*fabs(dx))*1000.0
		  << " STEP "
		  << fabs(dx)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Y = [[" 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0+(nz)*fabs(dz))*1000.0
		  << " STEP "
		  << fabs(dz)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Z = [[" 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0+(ny)*fabs(dy))*1000.0
		  << " STEP "
		  << fabs(dy)*1000.0 << "]]" << endl;

	  printf("PARTITION_X = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[0] - fabs(dx)/2.0)*1000.0,
		 (origin_dicom.xyz[0] - fabs(dx)/2.0 + (nx)*fabs(dx))*1000.0,
		 fabs(dx)*1000.0);
	  printf("PARTITION_Y = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[2] - fabs(dz)/2.0)*1000.0,
		 (origin_dicom.xyz[2] - fabs(dz)/2.0 + (nz)*fabs(dz))*1000.0,
		 fabs(dz)*1000.0);
	  printf("PARTITION_Z = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[1] - fabs(dy)/2.0)*1000.0,
		 (origin_dicom.xyz[1] - fabs(dy)/2.0 + (ny)*fabs(dy))*1000.0,
		 fabs(dy)*1000.0);
	}
      }
      else if (func_dset->daxes->xxorient == ORI_P2A_TYPE ||
	       func_dset->daxes->xxorient == ORI_A2P_TYPE) {
	if (func_dset->daxes->yyorient == ORI_R2L_TYPE ||
	      func_dset->daxes->yyorient == ORI_L2R_TYPE) {
	  Evecs->SetDimensions(ny, nx, nz);
	  Evecs->SetSpacing(fabs(dy), fabs(dx), fabs(dz));

	  mdlfile << "PARTITION_X = [[" 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0+(ny)*fabs(dy))*1000.0
		  << " STEP "
		  << fabs(dy)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Y = [[" 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0+(nx)*fabs(dx))*1000.0
		  << " STEP "
		  << fabs(dx)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Z = [[" 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0+(nz)*fabs(dz))*1000.0
		  << " STEP "
		  << fabs(dz)*1000.0 << "]]" << endl;

	  printf("PARTITION_X = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[1] - fabs(dy)/2.0)*1000.0,
		 (origin_dicom.xyz[1] - fabs(dy)/2.0 + (ny)*fabs(dy))*1000.0,
		 fabs(dy)*1000.0);
	  printf("PARTITION_Y = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[0] - fabs(dx)/2.0)*1000.0,
		 (origin_dicom.xyz[0] - fabs(dx)/2.0 + (nx)*fabs(dx))*1000.0,
		 fabs(dx)*1000.0);
	  printf("PARTITION_Z = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[2] - fabs(dz)/2.0)*1000.0,
		 (origin_dicom.xyz[2] - fabs(dz)/2.0 + (nz)*fabs(dz))*1000.0,
		 fabs(dz)*1000.0);
	}
	else { //yyorient is I2S or S2I
	  Evecs->SetDimensions(nz, nx, ny);
	  Evecs->SetSpacing(fabs(dz), fabs(dx), fabs(dy));

	  mdlfile << "PARTITION_X = [[" 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0+(nz)*fabs(dz))*1000.0
		  << " STEP "
		  << fabs(dz)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Y = [[" 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0+(nx)*fabs(dx))*1000.0
		  << " STEP "
		  << fabs(dx)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Z = [[" 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0+(ny)*fabs(dy))*1000.0
		  << " STEP "
		  << fabs(dy)*1000.0 << "]]" << endl;

	  printf("PARTITION_X = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[2] - fabs(dz)/2.0)*1000.0,
		 (origin_dicom.xyz[2] - fabs(dz)/2.0 + (nz)*fabs(dz)),
		 fabs(dz)*1000.0);
	  printf("PARTITION_Y = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[0] - fabs(dx)/2.0)*1000.0,
		 (origin_dicom.xyz[0] - fabs(dx)/2.0 + (nx)*fabs(dx))*1000.0,
		 fabs(dx)*1000.0);
	  printf("PARTITION_Z = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[1] - fabs(dy)/2.0)*1000.0,
		 (origin_dicom.xyz[1] - fabs(dy)/2.0 + (ny)*fabs(dy))*1000.0,
		 fabs(dy)*1000.0);
	}
      }
      else { //xxorient is I2S or S2I
	if (func_dset->daxes->yyorient == ORI_P2A_TYPE ||
	    func_dset->daxes->yyorient == ORI_A2P_TYPE) {
	  Evecs->SetDimensions(nz, ny, nx);
	  Evecs->SetSpacing(fabs(dz), fabs(dy), fabs(dx));

	  mdlfile << "PARTITION_X = [[" 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0+(nz)*fabs(dz))*1000.0
		  << " STEP "
		  << fabs(dz)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Y = [[" 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0+(ny)*fabs(dy))*1000.0
		  << " STEP "
		  << fabs(dy)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Z = [[" 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0+(nx)*fabs(dx))*1000.0
		  << " STEP "
		  << fabs(dx)*1000.0 << "]]" << endl;

	  printf("PARTITION_X = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[2] - fabs(dz)/2.0)*1000.0,
		 (origin_dicom.xyz[2] - fabs(dz)/2.0 + (nz)*fabs(dz))*1000.0,
		 fabs(dz)*1000.0);
	  printf("PARTITION_Y = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[1] - fabs(dy)/2.0)*1000.0,
		 (origin_dicom.xyz[1] - fabs(dy)/2.0 + (ny)*fabs(dy))*1000.0,
		 fabs(dy)*1000.0);
	  printf("PARTITION_Z = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[0] - fabs(dx)/2.0)*1000.0,
		 (origin_dicom.xyz[0] - fabs(dx)/2.0 + (nx)*fabs(dx))*1000.0,
		 fabs(dx)*1000.0);
	}
	else { //yyorient is R2L or L2R
	  Evecs->SetDimensions(ny, nz, nx);
	  Evecs->SetSpacing(fabs(dy), fabs(dz), fabs(dx));

	  mdlfile << "PARTITION_X = [[" 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[1]-fabs(dy)/2.0+(ny)*fabs(dy))*1000.0
		  << " STEP "
		  << fabs(dy)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Y = [[" 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[2]-fabs(dz)/2.0+(nz)*fabs(dz))*1000.0
		  << " STEP "
		  << fabs(dz)*1000.0 << "]]" << endl;
	  mdlfile << "PARTITION_Z = [[" 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0)*1000.0
		  << " TO " 
		  << (origin_dicom.xyz[0]-fabs(dx)/2.0+(nx)*fabs(dx))*1000.0
		  << " STEP "
		  << fabs(dx)*1000.0 << "]]" << endl;

	  printf("PARTITION_X = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[1] - fabs(dy)/2.0)*1000.0,
		 (origin_dicom.xyz[1] - fabs(dy)/2.0 + (ny)*fabs(dy))*1000.0,
		 fabs(dy)*1000.0);
	  printf("PARTITION_Y = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[2] - fabs(dz)/2.0)*1000.0,
		 (origin_dicom.xyz[2] - fabs(dz)/2.0 + (nz)*fabs(dz))*1000.0,
		 fabs(dz)*1000.0);
	  printf("PARTITION_Z = [[%f TO %f STEP %f]]\n", 
		 (origin_dicom.xyz[0] - fabs(dx)/2.0)*1000.0,
		 (origin_dicom.xyz[0] - fabs(dx)/2.0 + (nx)*fabs(dx))*1000.0,
		 fabs(dx)*1000.0);
	}
      }

      for (int i=0; i < nx; ++i) {
	for (int j=0; j < ny; ++j) {
	  for (int k=0; k < nz; ++k) {
	    int afniIndex = DSET_ixyz_to_index(func_dset,i,j,k);

	    dxx = (float *) DSET_ARRAY(func_dset,evec_offset  ) ;
	    dxy = (float *) DSET_ARRAY(func_dset,evec_offset+1) ;
	    dyy = (float *) DSET_ARRAY(func_dset,evec_offset+2) ;
	    dxz = (float *) DSET_ARRAY(func_dset,evec_offset+3) ;
	    dyz = (float *) DSET_ARRAY(func_dset,evec_offset+4) ;
	    dzz = (float *) DSET_ARRAY(func_dset,evec_offset+5) ;
	    fai = (float *) DSET_ARRAY(func_dset,evec_offset+18) ;

	    vec[0] = dxx[afniIndex];
	    vec[1] = dxy[afniIndex];
	    vec[2] = dyy[afniIndex];
	    vec[3] = dxz[afniIndex];
	    vec[4] = dyz[afniIndex];
	    vec[5] = dzz[afniIndex];
	    vec[6] = fai[afniIndex];
	    // my own threshold function
	    if (vec[6] < fai_thresh_av->fval) {
	      vec[6] = 0.0;
	    }

	    /* Load up the polydata */

	    /* 
	     * As with origin, use the to_dicom transform
	     * to transform positon into dicom coordinates,
	     * to eliminate effect of axis orientation
	     */
	    THD_fvec3 position_dset;
	    LOAD_FVEC3(position_dset,
		       i * dx + DSET_XORG(func_dset),
		       j * dy + DSET_YORG(func_dset),
		       k * dz + DSET_ZORG(func_dset));

	    THD_fvec3 position_dicom =
	      THD_3dmm_to_dicomm(func_dset, position_dset);

	    int vtkIndex = Evecs->FindPoint(
					    (vtkFloatingPointType) position_dicom.xyz[0],
					    (vtkFloatingPointType) position_dicom.xyz[1],
					    (vtkFloatingPointType) position_dicom.xyz[2]);

	    NewVectors->SetTuple(vtkIndex,vec);
	  }
	}
      }

      int rel_site_index = Evecs->FindPoint(release_x, release_y, release_z);

      Evecs->GetPointData()->SetScalars(NewVectors);

      vtkStructuredPointsWriter *pwriter = vtkStructuredPointsWriter::New();
      pwriter->SetFileName("tensor.vtk");
      pwriter->SetFileTypeToBinary();
      pwriter->SetInput(Evecs);
      pwriter->SetScalarsName("tensor");
      Evecs->Modified();
      pwriter->Write();
      pwriter->Delete();
      NewVectors->Delete();
      Evecs->Delete();

      mdlfile << "DEFINE_LIGAND my_molecule {" << endl
	      << "  DIFFUSION_CONSTANT = 1.0e-5" << endl
	      << "}" << endl;
      mdlfile << "INSTANTIATE my_domain OBJECT {" << endl
	      << "  molecule_release_site SPHERICAL_RELEASE_SITE {" << endl
	      << "    LOCATION = [" 
	      << release_x*1000.0 << ", " << release_y*1000.0 << ", " << release_z*1000.0 
	      << "]" << endl
	      << "    LIGAND = my_molecule" << endl 
	      << "    NUMBER_TO_RELEASE = 1000000" << endl
	      << "    SITE_DIAMETER = 0.0" << endl 
	      << "  }" << endl << "}" << endl;
      mdlfile << "VIZ_DATA_OUTPUT {" << endl
	      << "  MODE = DX" << endl 
	      << "  STATE_VALUES {my_molecule = 1}" << endl
	      << "  MOLECULE_FILE_PREFIX = \"viz_data/molecule\"" << endl
	      << "  ITERATION_LIST = [[0 TO " << diffusion_steps 
	      << " STEP " << diffusion_steps/animation_frames << " ]]" << endl
	      << "}" << endl;
      mdlfile.close();

      cout << "Done writing MCell files." << endl;
    }
    break;
  default: 
    fprintf(stderr,
	    "%s:  Eigenvectors should be floats!\n"
	    "(something else found)\n",program_name);
    break;
  }

}

/* reload data callback */
void reload_data_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  if (display_diffusion()) {
    update_diffusion();
  }
}

/* save image callback */
void save_image_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  static int i = 0;
  static struct stat buf;
  
  w2i->SetInput(renvWin);
  w2i->Update();
  w2i->Modified();
  png_image_writer->SetInput(w2i->GetOutput());
  char filename[256];

  /* check that "saved_images" exists */
  if (stat("saved_images", &buf) == 0) {
    /* check that it's a directory */
    if (buf.st_mode & S_IFDIR) {
      /* check that we can write to it */
      if (access("saved_images", W_OK) == 0) {
	sprintf(filename, "saved_images/image-%d.png", i);
	while (stat(filename, &buf) == 0) {
	  i++;
	  sprintf(filename, "saved_images/image-%d.png", i);
	}
	png_image_writer->SetFileName(filename);
	png_image_writer->Write();
      }
      else {
	/* error: can't write to "saved_images" directory */
	MCW_popup_message(save_image_button,
			  "Unable to save images\nin \"saved_images\" directory.", MCW_USER_KILL);
      }
    }
    else {
      /* error: "saved_images" exists but is not a directory */
      MCW_popup_message(save_image_button,
			"Unable to save images\nin \"saved_images\" directory.", MCW_USER_KILL);
    }
  }
  else {
    /* create "saved_images" directory */
    if (mkdir("saved_images", 0755) == 0) {
      sprintf(filename, "saved_images/image-%d.png", i);
      while (stat(filename, &buf) == 0) {
	i++;
	sprintf(filename, "saved_images/image-%d.png", i);
      }
      png_image_writer->SetFileName(filename);
      png_image_writer->Write();
    }
    else {
      /* error: couldn't create directory "saved_images" */
      MCW_popup_message(save_image_button,
			"Unable to save images\nin \"saved_images\" directory.", MCW_USER_KILL);
    }
  }
}	

/* Advanced controls callback */
void advanced_controls_cb(Widget w, XtPointer client_data,
			  XtPointer call_data) {
  static int advanced = 0;
  advanced = !advanced;

  if (advanced) {
    XtUnmanageChild(state.left_animation_frame);
    XtManageChild(state.right_animation_frame);
  }
  else {
    XtUnmanageChild(state.right_animation_frame);
    XtManageChild(state.left_animation_frame);
  }
}

/* animation callback */

void animation_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
  char wState =
    reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

  switch(wState) {
  case XmSET:
    if (sphereActor == NULL) {
      DisplayAnimation();
    }
    else {
      renv->AddActor(sphereActor);
      updateAnimation(NULL,NULL) ;
    }
    break;
  case XmUNSET:
    if (timer_id) {
      XtRemoveTimeOut(timer_id);
    }
    if (sphereActor) {
      renv->RemoveActor(sphereActor);
    }
    renvWin->Render();  
    break;
  }
}

/* diffusion path callback */

void diffusion_path_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
  char wState = 
    reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

  switch(wState) {
  case XmSET:
    if (track_contour_actor == NULL 
	|| volume == NULL 
	|| origin_sphere_actor == NULL) {
      if (!display_diffusion()) {
	XtVaSetValues(w,
		      XmNset, XmUNSET,
		      NULL);
      }
    }
    else {
      if (state.trackType == UIState::CONTOUR) {
	renv->AddActor(track_contour_actor);
      }
      else if (state.trackType == UIState::CLOUD) {
	renv->AddVolume(volume);
      }
      renv->AddActor(origin_sphere_actor);
      update_diffusion() ;
    }
    break;
  case XmUNSET:
    if (timer_id) {
      XtRemoveTimeOut(timer_id);
    }
    if (track_contour_actor) {
      renv->RemoveActor(track_contour_actor);
    }
    if (volume) {
      renv->RemoveVolume(volume);
    }
    if (origin_sphere_actor) {
      renv->RemoveActor(origin_sphere_actor);
    }
    renvWin->Render();  
    break;
  }
}

void max_conc_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
  char wState = 
    reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

  switch(wState) {
  case XmSET:
    if (max_conc_volume == NULL) {
      if (display_diffusion()) {
	update_diffusion();
      }
      else {
	XtVaSetValues(w,
		      XmNset, XmUNSET,
		      NULL);
      }
    }
    else {
      renv->AddVolume(max_conc_volume);
    }
    renvWin->Render();
    break;
  case XmUNSET:
    if (max_conc_volume) {
      renv->RemoveVolume(max_conc_volume);
    }
    renvWin->Render();
    break;
  }
}

/* vector field callback */

void vfield_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   static bool displayed = false;
  char *program_name = "vfield_cb" ;
  int debug = 0 ;

  if(debug) {
    fprintf(stderr,"Inside %s\n",program_name);
    vgrid->Print(cout);
  }

  if(!displayed)
  {
     DisplayVectorField();

     XmString xstr = XmStringCreateLtoR("Disable Global Field", XmFONTLIST_DEFAULT_TAG);
     XtVaSetValues(vfield_button, XmNlabelString, xstr, NULL);
     XmStringFree(xstr);
  }
  else
  {
     renv->RemoveActor(vgridActor);
     renvWin->Render();  
     XmString xstr = XmStringCreateLtoR("Enable", XmFONTLIST_DEFAULT_TAG);
     XtVaSetValues(vfield_button, XmNlabelString, xstr, NULL);
     XmStringFree(xstr);
  }

  displayed = !displayed;
}
#ifdef OLD_RECOMPUTE_SLICER
void recompute_slicer(Widget w, XtPointer client_data, XtPointer call_data)
{
  Boolean FIX_ARROW_LENGTHS = 0;
  double spacing[3];
  double min_spacing;

  char *program_name = "recompute_slicer" ;
  int debug  = 0 ;
  int debug2 = 0 ;

  if(debug2) {
    fprintf(stderr,"Inside %s: DO_SLICER=%i\n",program_name,DO_STREAM);
    igrid->Print(cout);
  }

  if(igrid==NULL) {
    if(w) {
      char buf[256] ;
      sprintf(buf," \n"
	      "** No anatomical dataset chosen!\n") ;
      (void) MCW_popup_message( w , buf ,
				MCW_USER_KILL | MCW_TIMER_KILL ) ;
      PLUTO_beep() ; 
    }
    else {
      fprintf(stderr, "** No anatomical dataset chosen!\n");
    }
    return ;
   };

  if(vgrid==NULL) {
    fprintf(stderr,"%s: vgrid is NULL!\n",program_name);
    return ;
  }

  vtkFloatingPointType iRange[2];
  vtkFloatingPointType cRange[2];
  igrid->GetScalarRange(iRange);
  cgrid->GetScalarRange(cRange);

  if(debug) fprintf(stderr,"%s: anat range = (%f,%f)\n",program_name,iRange[0],iRange[1]) ;
  if(debug) fprintf(stderr,"%s: c-anat range = (%f,%f)\n",program_name,cRange[0],cRange[1]) ;
  iRange[0] = 0;			// Peg lower limit to zero
  cRange[0] = 0;			// Peg lower limit to zero

  vtkFloatingPointType vRange[2];
  vgrid->GetScalarRange(vRange);
  if(debug) fprintf(stderr,"%s: FAI range = (%f,%f)\n",program_name,vRange[0],vRange[1]) ;

  int iDims[3];
  int cDims[3];
  igrid->GetDimensions(iDims);  
  cgrid->GetDimensions(cDims);
  if(1) printf("Grid dimensions = (%d,%d,%d)\n",iDims[0],iDims[1],iDims[2]);
  int vDims[3];
  vgrid->GetDimensions(vDims);

  vtkFloatingPointType boundingBox[6];
  vtkFloatingPointType cboundingBox[6];
  igrid->ComputeBounds();
  igrid->GetBounds(boundingBox);
  cgrid->ComputeBounds();
  cgrid->GetBounds(cboundingBox);


  vtkFloatingPointType vBoundingBox[6];
  vgrid->ComputeBounds();
  vgrid->GetBounds(vBoundingBox);

  vtkFloatingPointType res[3];
  vtkFloatingPointType cres[3];
  for (int i = 0; i < 3; ++i)
    {
      res[i] = (boundingBox[2*i + 1] - boundingBox[2*i])/(float)iDims[i];
    }

  for (int i = 0; i < 3; ++i)
    {
      cres[i] = (cboundingBox[2*i + 1] - cboundingBox[2*i])/(float)cDims[i];
    }

  vtkFloatingPointType vRes[3];
  for (int i = 0; i < 3; ++i) {
    vRes[i] = (vBoundingBox[2*i + 1] - vBoundingBox[2*i])/(float)vDims[i];
  }


  float lims[2];

  printf("recompute slicer: Anat value range = (%f, %f)\n", iRange[0], iRange[1]);
  printf("recompute slicer: c-Anat value range = (%f, %f)\n", cRange[0], cRange[1]);

  // Careful you don't use vRange after this!
  vRange[0] = (vtkFloatingPointType) fai_thresh_av->fval;
  if(debug) fprintf(stderr,"%s: vRange = (%f,%f)\n",program_name,vRange[0],vRange[1]) ;
    
  cgrid->GetSpacing(spacing);
  min_spacing = spacing[0];
  for (int i = 1; i < 3; i++) {
    min_spacing = (min_spacing < spacing[i]) ? min_spacing : spacing[i];
  }
  slicer_cylinder->SetRadius(0.1*min_spacing);
  slicer_cylinder->SetHeight(1.5*min_spacing);
  slicer_tf_filter->SetInput(slicer_cylinder->GetOutput());
  slicer_tf_filter->SetTransform(slicer_transform);
  vtkPolyData *x_cylinder = slicer_tf_filter->GetOutput();

  for (int i = 0; i < 3; ++i) {
    if (state.drawSlice[i]) {
      vtkFloatingPointType normal[3] = {0.0, 0.0, 0.0};
      normal[i] = 1.0;
      slicer_planes[i]->SetNormal(normal);
      slicer_cplanes[i]->SetNormal(normal);

      //TODO: make sure we use boundingbox that gets this right
      vtkFloatingPointType origin[3] = {0.0, 0.0, 0.0};
      vtkFloatingPointType corigin[3] = {0.0, 0.0, 0.0};
      cout << "slice number " << state.sliceNum[i] << " in dim " << i << endl;
      origin[i] = boundingBox[2*i] + res[i] * (state.sliceNum[i]+0.5);
      slicer_planes[i]->SetOrigin(origin);
      if (colormap[i]) {
	float cSliceNum = (corigin[i] - cboundingBox[2*i])/cres[i];

	corigin[i] = cboundingBox[2*i] + cres[i] * (cSliceNum+0.5);
	slicer_cplanes[i]->SetOrigin(corigin);
      }

      /*
       * Set up sub-volumes for possibly faster cutting
       */
      slicer_iVolumeFilters[i]->SetInput(igrid);
      slicer_iVolumeFilters[i]->SetSampleRate(1,1,1);

      slicer_vVolumeFilters[i]->SetInput(vgrid);
      slicer_vVolumeFilters[i]->SetSampleRate(1,1,1);

      int iVolOfInterest[6] = {0, iDims[0] - 1, 0, iDims[1] - 1, 
			       0, iDims[2] - 1};
      iVolOfInterest[2*i] = state.sliceNum[i]-1;
      iVolOfInterest[2*i + 1] = state.sliceNum[i]+1;
      slicer_iVolumeFilters[i]->SetVOI(iVolOfInterest);

      int vVolOfInterest[6] = {0, vDims[0] - 1, 0, vDims[1] - 1,
			       0, vDims[2] - 1};
      float vSliceNum = (origin[i] - vBoundingBox[2*i])/vRes[i];
      vVolOfInterest[2*i] = (int)floor(vSliceNum) - 1;
      vVolOfInterest[2*i + 1] = (int)ceil(vSliceNum) + 1;
      slicer_vVolumeFilters[i]->SetVOI(vVolOfInterest);
	  
      //Set up cutter filter
      //TODO: consider using general probe rather than cutter
      slicer_iCutters[i]->SetInput(slicer_iVolumeFilters[i]->GetOutput());
      cmapThreshers[i]->SetInput(cgrid);
      cout << "Color Map Thresher is using component "
	   << cmapThreshers[i]->GetSelectedComponent() << endl;
      slicer_cmapCutters[i]->SetInput(cmapThreshers[i]->GetOutput());

      slicer_iCutters[i]->SetCutFunction(slicer_planes[i]);

      slicer_cmapCutters[i]->SetCutFunction(slicer_cplanes[i]);

      slicer_vCutters[i]->SetInput(slicer_vVolumeFilters[i]->GetOutput());
      slicer_vCutters[i]->SetCutFunction(slicer_planes[i]);

      sliceThreshers[i]->SetInput(slicer_vCutters[i]->GetOutput());

      //Set up glyphs
      slicer_glyphs[i]->SetSource(x_cylinder);
      slicer_glyphs[i]->ScalingOff();

      slicer_glyphs[i]->SetColorModeToColorByScalar();
      slicer_glyphs[i]->SetVectorModeToUseVector();
      slicer_glyphs[i]->SetInput(sliceThreshers[i]->GetOutput());
      slicer_glyphs[i]->OrientOn();
      slicer_glyphs[i]->Modified();

      // Set up mapper for anatomical image
      slicer_iMappers[i]->SetInput(slicer_iCutters[i]->GetOutput());
      slicer_iMappers[i]->SetLookupTable(slicer_hue_lut);
      slicer_iMappers[i]->SetScalarRange(iRange);
      slicer_iMappers[i]->SetColorModeToMapScalars();

      // Set up mapper for diffusion color map
      slicer_cmapMappers[i]->SetInput(slicer_cmapCutters[i]->GetOutput());

      slicer_vMappers[i]->SetInput(slicer_glyphs[i]->GetOutput());
      slicer_vMappers[i]->SetLookupTable(slicer_vLut);
      slicer_vMappers[i]->SetScalarRange(vRange);
      slicer_vMappers[i]->SetColorModeToMapScalars();

      //Set up actor
      slicer_imgActors[i]->SetMapper(slicer_iMappers[i]);
      renv->AddActor(slicer_imgActors[i]);

      if (colormap[i]) {
	slicer_cmapActors[i]->SetMapper(slicer_cmapMappers[i]);
	renv->AddActor(slicer_cmapActors[i]);
      }
      else {
	if (slicer_cmapActors[i] != NULL) {
	  renv->RemoveActor(slicer_cmapActors[i]);
	}
      }

      slicer_vecActors[i]->SetMapper(slicer_vMappers[i]);
      renv->AddActor(slicer_vecActors[i]);
    }
    else {
      if (imgActors[i] != NULL) {
	renv->RemoveActor(imgActors[i]);
      }
      if (vecActors[i] != NULL) {
	renv->RemoveActor(vecActors[i]);
      }
      if (cmapActors[i] != NULL) {
	renv->RemoveActor(cmapActors[i]);
      }
    }
  }

  /*** Outline data ***/ 
  if (show_outline) {
    slicer_outline->SetInput(igrid);
    slicer_outlineMapper->SetInput(slicer_outline->GetOutput());
    slicer_outlineActor->SetMapper(slicer_outlineMapper);
    renv->AddActor(slicer_outlineActor);   /* Done outlining, add it ... */
  }
  else {
    if (slicer_outlineActor) {
      renv->RemoveActor(slicer_outlineActor);
    }
  }

  /* Render! */ 

//  renv->ResetCamera() ;
  renvWin->Render();  

  fprintf(stderr,"Finished plane cut.\n");
}
#endif

void recompute_slicer(Widget w, XtPointer client_data, XtPointer call_data)
{
  Boolean FIX_ARROW_LENGTHS = 0;
  double spacing[3];
  double min_spacing;

  char *program_name = "recompute_slicer" ;
  int debug  = 0 ;
  int debug2 = 0 ;

  if(debug2) {
    fprintf(stderr,"Inside %s: DO_SLICER=%i\n",program_name,DO_STREAM);
    igrid->Print(cout);
  }

  if(igrid==NULL) {
    if(w) {
      char buf[256] ;
      sprintf(buf," \n"
	      "** No anatomical dataset chosen!\n") ;
      (void) MCW_popup_message( w , buf ,
				MCW_USER_KILL | MCW_TIMER_KILL ) ;
      PLUTO_beep() ; 
    }
    else {
      fprintf(stderr, "** No anatomical dataset chosen!\n");
    }
    return ;
   }

  if(vgrid==NULL) {
    fprintf(stderr,"%s: vgrid is NULL!\n",program_name);
    return ;
  }

  int iDims[3];
  int cDims[3];
  igrid->GetDimensions(iDims);  
  cgrid->GetDimensions(cDims);
  if(0) printf("Grid dimensions = (%d,%d,%d)\n",iDims[0],iDims[1],iDims[2]);
  int vDims[3];
  vgrid->GetDimensions(vDims);

  vtkFloatingPointType iRange[2];
  vtkFloatingPointType cRange[2];
  igrid->GetScalarRange(iRange);
  cgrid->GetScalarRange(cRange);

  if(debug) fprintf(stderr,"%s: anat range = (%f,%f)\n",
    program_name,iRange[0],iRange[1]) ;
  if(debug) fprintf(stderr,"%s: c-anat range = (%f,%f)\n",
    program_name,cRange[0],cRange[1]) ;
  iRange[0] = 0;			// Peg lower limit to zero
  cRange[0] = 0;			// Peg lower limit to zero

  vtkFloatingPointType vRange[2];
  vgrid->GetScalarRange(vRange);
  if(debug) fprintf(stderr,"%s: FAI range = (%f,%f)\n",
    program_name,vRange[0],vRange[1]) ;

               // Outline data
  if (show_outline) {
    slicer_outline->SetInput(igrid);
    slicer_outlineMapper->SetInput(slicer_outline->GetOutput());
    slicer_outlineActor->SetMapper(slicer_outlineMapper);
    renv->AddActor(slicer_outlineActor);   /* Done outlining, add it ... */
  }
  else {
    if (slicer_outlineActor) {
      renv->RemoveActor(slicer_outlineActor);
    }
  }
               // interactive slicer widgets
  if( axial_vectors == false && sagittal_vectors == false &&
    coronal_vectors == false && colormap[0] == false && 
    colormap[1] == false && colormap[2] == false )
  { 
    for( int i=0; i<3; ++i )
    if( state.drawSlice[i] )
    {
      switch( i )
      {
        case 0: 
	{ 
	  slicer_widgets[i]->SetPlaneOrientationToXAxes();
          slicer_widgets[i]->SetSliceIndex(state.sliceNum[i]);
	  slicer_widgets[i]->SetKeyPressActivationValue('x');
	}  
	  break;
	case 1:
	{ 
	  slicer_widgets[i]->SetPlaneOrientationToYAxes();
          slicer_widgets[i]->SetSliceIndex(state.sliceNum[i]);
	  slicer_widgets[i]->SetKeyPressActivationValue('y');
	}  
	  break;
	case 2:
	{ 
	  slicer_widgets[i]->SetPlaneOrientationToZAxes();
          slicer_widgets[i]->SetSliceIndex(state.sliceNum[i]);
	  slicer_widgets[i]->SetKeyPressActivationValue('z');
	}  
	  break;
	default:;  
      }
      slicer_widgets[i]->On();
      slicer_widgets[i]->InteractionOn();
      slicer_widgets[i]->EnabledOn();
    }
    else
    {
      slicer_widgets[i]->Off();
    }
    renvWin->Render();  
    return;
  }    

  vtkFloatingPointType boundingBox[6];
  vtkFloatingPointType cboundingBox[6];
  igrid->ComputeBounds();
  igrid->GetBounds(boundingBox);
  cgrid->ComputeBounds();
  cgrid->GetBounds(cboundingBox);

  vtkFloatingPointType vBoundingBox[6];
  vgrid->ComputeBounds();
  vgrid->GetBounds(vBoundingBox);

  vtkFloatingPointType res[3];
  vtkFloatingPointType cres[3];
  for (int i = 0; i < 3; ++i)
    res[i] = (boundingBox[2*i + 1] - boundingBox[2*i])/(float)iDims[i];

  for (int i = 0; i < 3; ++i)
    cres[i] = (cboundingBox[2*i + 1] - cboundingBox[2*i])/(float)cDims[i];

  vtkFloatingPointType vRes[3];
  for (int i = 0; i < 3; ++i) 
    vRes[i] = (vBoundingBox[2*i + 1] - vBoundingBox[2*i])/(float)vDims[i];

  float lims[2];

  printf("recompute slicer: Anat value range = (%f, %f)\n", iRange[0], iRange[1]);
  printf("recompute slicer: c-Anat value range = (%f, %f)\n", cRange[0], cRange[1]);

  // Careful you don't use vRange after this!
  vRange[0] = (vtkFloatingPointType) fai_thresh_av->fval;
  if(debug) fprintf(stderr,"%s: vRange = (%f,%f)\n",
    program_name,vRange[0],vRange[1]) ;
    
  cgrid->GetSpacing(spacing);
  min_spacing = spacing[0];
  for (int i = 1; i < 3; i++) {
    min_spacing = (min_spacing < spacing[i]) ? min_spacing : spacing[i];
  }
  slicer_cylinder->SetRadius(0.1*min_spacing);
  slicer_cylinder->SetHeight(1.5*min_spacing);
  slicer_tf_filter->SetInput(slicer_cylinder->GetOutput());
  slicer_tf_filter->SetTransform(slicer_transform);
  vtkPolyData *x_cylinder = slicer_tf_filter->GetOutput();

  for (int i = 0; i < 3; ++i) {
    if (state.drawSlice[i]) {
      vtkFloatingPointType normal[3] = {0.0, 0.0, 0.0};
      normal[i] = 1.0;
      slicer_planes[i]->SetNormal(normal);
      slicer_cplanes[i]->SetNormal(normal);
      slicer_cplanes2[i]->SetNormal(normal);

      //TODO: make sure we use boundingbox that gets this right
      vtkFloatingPointType origin[3] = {0.0, 0.0, 0.0};
      vtkFloatingPointType corigin[3] = {0.0, 0.0, 0.0};
      vtkFloatingPointType corigin2[3] = {0.0, 0.0, 0.0};
      cout << "slice number " << state.sliceNum[i] << " in dim " << i << endl;
      origin[i] = boundingBox[2*i] + res[i] * (state.sliceNum[i]+0.5);
      slicer_planes[i]->SetOrigin(origin);
      if (colormap[i]) {
	float cSliceNum = (origin[i] - cboundingBox[2*i])/cres[i];

	corigin[i] = cboundingBox[2*i] + cres[i] * (cSliceNum+0.01);
	corigin2[i] = cboundingBox[2*i] + cres[i] * (cSliceNum-0.01);
	slicer_cplanes[i]->SetOrigin(corigin);
	slicer_cplanes2[i]->SetOrigin(corigin2);
      }

      /*
       * Set up sub-volumes for possibly faster cutting
       */
      slicer_iVolumeFilters[i]->SetInput(igrid);
      slicer_iVolumeFilters[i]->SetSampleRate(1,1,1);

      slicer_vVolumeFilters[i]->SetInput(vgrid);
      slicer_vVolumeFilters[i]->SetSampleRate(1,1,1);

      int iVolOfInterest[6] = {0, iDims[0] - 1, 0, iDims[1] - 1, 
			       0, iDims[2] - 1};
      iVolOfInterest[2*i] = state.sliceNum[i]-1;
      iVolOfInterest[2*i + 1] = state.sliceNum[i]+1;
      slicer_iVolumeFilters[i]->SetVOI(iVolOfInterest);

      int vVolOfInterest[6] = {0, vDims[0] - 1, 0, vDims[1] - 1,
			       0, vDims[2] - 1};
      float vSliceNum = (origin[i] - vBoundingBox[2*i])/vRes[i];
      vVolOfInterest[2*i] = (int)floor(vSliceNum) - 1;
      vVolOfInterest[2*i + 1] = (int)ceil(vSliceNum) + 1;
      slicer_vVolumeFilters[i]->SetVOI(vVolOfInterest);
	  
      //Set up cutter filter
      //TODO: consider using general probe rather than cutter
      slicer_iCutters[i]->SetInput(slicer_iVolumeFilters[i]->GetOutput());
      cmapThreshers[i]->SetInput(cgrid);
      cout << "Color Map Thresher is using component "
	   << cmapThreshers[i]->GetSelectedComponent() << endl;
      slicer_cmapCutters[i]->SetInput(cmapThreshers[i]->GetOutput());
      slicer_cmapCutters2[i]->SetInput(cmapThreshers[i]->GetOutput());

      slicer_iCutters[i]->SetCutFunction(slicer_planes[i]);

      slicer_cmapCutters[i]->SetCutFunction(slicer_cplanes[i]);
      slicer_cmapCutters2[i]->SetCutFunction(slicer_cplanes2[i]);

      slicer_vCutters[i]->SetInput(slicer_vVolumeFilters[i]->GetOutput());
      slicer_vCutters[i]->SetCutFunction(slicer_planes[i]);

      sliceThreshers[i]->SetInput(slicer_vCutters[i]->GetOutput());

      //Set up glyphs
      slicer_glyphs[i]->SetSource(x_cylinder);
      slicer_glyphs[i]->ScalingOff();

      slicer_glyphs[i]->SetColorModeToColorByScalar();
      slicer_glyphs[i]->SetVectorModeToUseVector();
      slicer_glyphs[i]->SetInput(sliceThreshers[i]->GetOutput());
      slicer_glyphs[i]->OrientOn();
      slicer_glyphs[i]->Modified();

      // Set up mapper for anatomical image
      slicer_iMappers[i]->SetInput(slicer_iCutters[i]->GetOutput());
      slicer_iMappers[i]->SetLookupTable(slicer_hue_lut);
      slicer_iMappers[i]->SetScalarRange(iRange);
      slicer_iMappers[i]->SetColorModeToMapScalars();

      // Set up mapper for diffusion color map
      slicer_cmapMappers[i]->SetInput(slicer_cmapCutters[i]->GetOutput());
      slicer_cmapMappers2[i]->SetInput(slicer_cmapCutters2[i]->GetOutput());

      slicer_vMappers[i]->SetInput(slicer_glyphs[i]->GetOutput());
      slicer_vMappers[i]->SetLookupTable(slicer_vLut);
      slicer_vMappers[i]->SetScalarRange(vRange);
      slicer_vMappers[i]->SetColorModeToMapScalars();

      //Set up actor
      slicer_imgActors[i]->SetMapper(slicer_iMappers[i]);
      renv->AddActor(slicer_imgActors[i]);

      if (colormap[i]) {
	slicer_cmapActors[i]->SetMapper(slicer_cmapMappers[i]);
	slicer_cmapActors2[i]->SetMapper(slicer_cmapMappers2[i]);
	renv->AddActor(slicer_cmapActors[i]);
	renv->AddActor(slicer_cmapActors2[i]);
      }
      else {
	if (slicer_cmapActors[i] != NULL) {
	  renv->RemoveActor(slicer_cmapActors[i]);
	}
	if (slicer_cmapActors2[i] != NULL) {
	  renv->RemoveActor(slicer_cmapActors2[i]);
	}
      }

      slicer_vecActors[i]->SetMapper(slicer_vMappers[i]);
      renv->AddActor(slicer_vecActors[i]);
    }
    else {
      if (slicer_imgActors[i] != NULL) {
	renv->RemoveActor(slicer_imgActors[i]);
      }
      if (slicer_vecActors[i] != NULL) {
	renv->RemoveActor(slicer_vecActors[i]);
      }
      if (slicer_cmapActors[i] != NULL) {
	renv->RemoveActor(slicer_cmapActors[i]);
      }
      if (slicer_cmapActors2[i] != NULL) {
	renv->RemoveActor(slicer_cmapActors2[i]);
      }
    }
  }

  /* Render! */ 

//  renv->ResetCamera() ;
  renvWin->Render();  

  fprintf(stderr,"Finished plane cut.\n");
}

/* compute contours */
void compute_isoSurface(Widget w, XtPointer client_data, XtPointer call_data)
{
  char *program_name = "compute_isoSurface" ;
  int debug  = 0 ;
  int debug2 = 0 ;

  if(igrid==NULL) 
  {
    char buf[256] ;
    sprintf(buf," \n** No anatomical dataset chosen!\n") ;
    (void) MCW_popup_message( w, buf, MCW_USER_KILL | MCW_TIMER_KILL );
    PLUTO_beep() ; 
    return;
  }

  vtkFloatingPointType range[2];
  igrid->GetScalarRange(range);
  if(debug) fprintf(stderr,"%s: range = (%f,%f)\n",program_name,range[0],
    range[1]) ;
  range[0] = 0;			// Peg lower limit to zero

  // Color table
  vtkLookupTable *hueLut = vtkLookupTable::New();
//  hueLut->SetTableRange(range[0],range[1]);
  hueLut->SetHueRange(0, 1);
  hueLut->SetSaturationRange(1, 1);
  hueLut->Build();

  vtkContourFilter *iso = vtkContourFilter::New();
  vtkSmoothPolyDataFilter *smooth = vtkSmoothPolyDataFilter::New();
  vtkPolyDataNormals *normals = vtkPolyDataNormals::New();
  vtkPolyDataMapper  *isoMapper = vtkPolyDataMapper::New();

  if(isoActor != NULL)
  {
    renv->RemoveActor( isoActor );
    isoActor->Delete();
    renvWin->Render();
  }  
  isoActor = vtkLODActor::New();

  float contour_value = state.isoSurface_value * range[1]/
    state.isosurf_value_max;
//cout<<"*************contour="<<contour_value<<endl;    
  if( (contour_value - 0) < 0.0001 ) return;
  iso->SetInput(igrid);
  iso->SetValue( 0,contour_value );
  smooth->SetInput( iso->GetOutput() );
  smooth->SetNumberOfIterations( 10 );
  smooth->SetRelaxationFactor( 0.5 );

  normals->SetInput(smooth->GetOutput());
  normals->SetFeatureAngle(45);
               // mapper
  isoMapper->SetInput(normals->GetOutput());
  isoMapper->ScalarVisibilityOn();
  isoMapper->SetScalarRange(range);
  isoMapper->SetLookupTable(hueLut);

               // Actor
  isoActor->SetMapper(isoMapper);
  isoActor->GetProperty()->SetOpacity(state.isoSurface_opacity);

               // add to renderer
  renv->AddActor( isoActor ); // outline actor

               // Render! 
//  renv->ResetCamera() ;
  renvWin->Render();  
}

/* compute streamlines */
void recompute_streamlines(Widget w, XtPointer client_data, 
			   XtPointer call_data)
{
   DO_STUBE = state.drawStreamtube;

   if (streamLineActor != NULL)
   {
      renv->RemoveActor(streamLineActor);
      streamLineActor->Delete();
      streamLineActor = NULL;
   }
   if (streamTubeActor != NULL)
   {
      renv->RemoveActor(streamTubeActor);
      streamTubeActor->Delete();
      streamTubeActor = NULL;
   }
   renv->RemoveActor(probeActor);

   if(pointWidget != NULL && pointWidget->GetInteractor() != NULL)
   {
      pointWidget->EnabledOff();
   }
   if(lineWidget != NULL && lineWidget->GetInteractor() != NULL)
   {
      lineWidget->EnabledOff();
   }
   if(planeWidget != NULL && planeWidget->GetInteractor() != NULL)
   {
      planeWidget->EnabledOff();
   }

   if(state.streamEnabled)
   {
      char *program_name = "recompute_streamlines" ;
      int debug = 0 ;

      if(debug) {
	 fprintf(stderr,"Inside %s: DO_STREAM=%i, DO_STUBE=%i\n",
		 program_name,DO_STREAM,DO_STUBE);
	 vgrid->Print(cout);
      }

      int dims[3];
      vgrid->GetDimensions(dims);
      if(1) printf("Grid dimensions = (%d,%d,%d)\n",dims[0],dims[1],dims[2]);

      //if(DO_STREAM) DO_RIBBON = logqyn("Ribbon filter","y") ;
      DO_VORTICITY = false;
      DO_PLANES    = false;
      DO_PROBES    = !DO_PLANES ;

      if(DO_PROBES) 
      {
	 switch (state.probeType)
	 {
	    case UIState::PLANE:
	       DO_PLANE_WIDGET = true;
	       DO_LINE_WIDGET = false;
	       DO_POINT_WIDGET = false;
	       break;
	    case UIState::LINE:
	       DO_LINE_WIDGET = true;
	       DO_PLANE_WIDGET = false;
	       DO_POINT_WIDGET = false;
	       break;
	    case UIState::POINT:
	       DO_POINT_WIDGET = true;
	       DO_LINE_WIDGET = false;
	       DO_PLANE_WIDGET = false;
	       break;
	    default:
	       abort();
	       break;
	 }
      }

      /*** Outline data ***/ 

      if(outline==NULL) outline = vtkOutlineFilter::New();

      outline->SetInput(vgrid);
      vtkPolyDataMapper *outlineMapper = vtkPolyDataMapper::New();
      outlineMapper->SetInput(outline->GetOutput());
      vtkActor *outlineActor = vtkActor::New();
      outlineActor->SetMapper(outlineMapper);
      outlineActor->GetProperty()->SetColor(0,0,0);

      renv->AddActor(outlineActor);   /* Done outlining, add it ... */

      /*** done outlining data ***/ 

      /* Set up streamlining players */ 

      vtkStreamLine     *streamLine       = vtkStreamLine::New();
      vtkPolyDataMapper *streamLineMapper = vtkPolyDataMapper::New();
                         streamLineActor  = vtkActor::New();

      vtkTubeFilter     *streamTube       = vtkTubeFilter::New();
      vtkPolyDataMapper *streamTubeMapper = vtkPolyDataMapper::New();
                         streamTubeActor  = vtkActor::New();

      vtkRibbonFilter   *streamRibbon     = vtkRibbonFilter::New();

      vtkProbeFilter    *streamProbe      = vtkProbeFilter::New();
      streamProbe->SetSource(vgrid);

      /******** Probing widgets ********/ 

      vtkPlaneSource *planeSource = vtkPlaneSource::New();


      /******** Probing sources ********/ 

      vtkPolyData    *seeds = vtkPolyData::New();
      vtkProbeFilter *probe = vtkProbeFilter::New();

      /******** Integration params ********/ 
    
      /* The StepLength parameter controls the time increment used to
	 generate individual points along the streamline(s). Smaller
	 values result in more line primitives but smoother
	 streamlines. The StepLength instance variable is defined in
	 terms of time (i.e., the distance that the particle travels in
	 the specified time period). Thus, the line segments will be
	 smaller in areas of low velocity and larger in regions of high
	 velocity. 

	 IntegrationStepLength, defined by the superclass vtkStreamer,
	 is used to control integration step size and is expressed as a
	 fraction of the cell length.) */

      float TermSpeed  = 0.002 ;
      /* Set up the integrator */ 

      vtkRungeKutta4 *integ = vtkRungeKutta4::New();
      streamLine->SetIntegrator(integ) ;
      streamLine->SetMaximumPropagationTime(UIState::STREAM_MAX_TIME) ;
      streamLine->SetNumberOfThreads(1) ; 
      streamLine->SetStepLength(UIState::VIS_STEP_TIME) ; 
      streamLine->SetIntegrationStepLength(state.streamStepLength/vgrid->GetCell(0)->GetLength2()) ; 
      streamLine->SetIntegrationDirectionToIntegrateBothDirections() ; 
      streamLine->SetTerminalSpeed(TermSpeed) ;

      if(DO_VORTICITY) {
	 streamLine->SpeedScalarsOff() ;
	 streamLine->OrientationScalarsOn() ;
	 streamLine->VorticityOn() ;
      } else {
	 streamLine->SpeedScalarsOn() ;
	 streamLine->OrientationScalarsOff() ;
	 streamLine->VorticityOff() ;
      }

      /* Graphics params */ 

      vtkFloatingPointType Stream_LineWidth = 1.0 ;
      vtkFloatingPointType Ribbon_Width     = 1.0 ;
      
      /***************** Threshold data below fai threshold *****************/

      vtkFloatingPointType range[2];
      vgrid->GetScalarRange(range);

//      range[0] = fai_thresh_av->fval;
      range[0] = state.streamFA;

      vtkLookupTable* lut = CreateStandardColorTable(range);

      /********************************************************************/
      if( streamThresher == NULL ) streamThresher = vtkThreshold::New();
      streamThresher->ThresholdByUpper( state.streamFA );
      streamThresher->SetInput( vgrid );

      streamLine->SetInput( streamThresher->GetOutput() );	

      /* Set source for appropriate probing widget */ 

      if(DO_LINE_WIDGET) {
	 streamLine->SetSource(seeds) ;
      }

      if(debug) streamLine->Print(cout) ;

      if(DO_STUBE) {
	 printf("\nStreamtubing...\n");
    
	 bool colorByCurvature = state.colorByCurvature;

#if 0
	 SET_LIMS(flims,.1,1.) ;
	 Tube_Radius = pinput("tube radius",Tube_Radius,flims);
#endif
	 streamTube->SetRadius(state.tubeRadius) ;
	 streamTube->SetNumberOfSides(12) ;
	 streamTube->UseDefaultNormalOn() ;
      
	 // Source
	 // I don't think this cleaning does anything!
	 vtkCleanPolyData *cleanStream = vtkCleanPolyData::New();
	 cleanStream->SetInput(streamLine->GetOutput()) ;
	 //streamTube->SetInput(streamLine->GetOutput()) ;

	 //Probe
	 if (colorByCurvature)
	 {
// 	    vtkPolyLineCurvature* curvatures = vtkPolyLineCurvature::New();
// 	    curvatures->SetInput(cleanStream->GetOutput());
// 	    curvatures->SetScalarOutputToCurvature();
// 	    streamTube->SetInput(curvatures->GetOutput());
// 	    streamTubeMapper->SetInput(streamTube->GetOutput());
// 	    lut->SetScaleToLog10();
	 }
	 else
	 {
	    streamTube->SetInput(cleanStream->GetOutput()) ;
	    streamProbe->SetInput(streamTube->GetOutput());
	    streamTubeMapper->SetInput(streamProbe->GetPolyDataOutput()) ;
	    lut->SetScaleToLinear();
	 }

	 // Mapper
	 streamTubeMapper->SetScalarRange(range);
	 streamTubeMapper->SetLookupTable(lut);
	 // Actor
	 streamTubeActor->SetMapper(streamTubeMapper);
	 // streamTubeActor->GetProperty()->BackfaceCullingOn();

	 renv->AddActor(streamTubeActor);
	 printf("finished streamtubing...\n");fflush(stdout) ;

      } else if(DO_RIBBON) {
	 printf("\nStreamribboning...\n");
	 
	 streamRibbon->SetInput(streamLine->GetOutput());
	 streamRibbon->SetWidth(Ribbon_Width);
	 //streamRibbon->SetWidthFactor(1);
	 streamProbe->SetInput(streamRibbon->GetOutput());
	 streamLineMapper->SetInput(streamProbe->GetPolyDataOutput());
	 streamLineMapper->SetScalarRange(range); 
	 streamLineMapper->SetLookupTable(lut);
	 streamLineActor->SetMapper(streamLineMapper);
	 renv->AddActor(streamLineActor);
	 
      } else {

	 printf("\nStreamlining...\n");
	 //streamLine->Print(cout) ;
	 
	 bool colorByCurvature = state.colorByCurvature ;

	 streamProbe->SetInput(streamLine->GetOutput());
	 
	 if(colorByCurvature)
	 {
// 	    vtkPolyLineCurvature* curvatures = vtkPolyLineCurvature::New();
// 	    curvatures->SetInput(streamProbe->GetPolyDataOutput());
// 	    curvatures->SetScalarOutputToCurvature();
// 	    streamLineMapper->SetInput(curvatures->GetOutput());
	 }
	 else
	 {
	    streamLineMapper->SetInput(streamProbe->GetPolyDataOutput());
	 }

	 streamLineMapper->SetScalarRange(range); 
	 streamLineMapper->SetLookupTable(lut);
	 streamLineActor->SetMapper(streamLineMapper);
	 streamLineActor->GetProperty()->SetLineWidth(Stream_LineWidth);
	 renv->AddActor(streamLineActor);

      }

      if(DO_LINE_WIDGET) {
	 
	 fprintf(stderr,"Inside DO_LINE_WIDGET\n");
	 
	 vtkLWCallback *myCallback = vtkLWCallback::New();
	 myCallback->PolyData = seeds;

	 if(DO_STREAM) {
	   printf("setting streamLineActor\n");
	   myCallback->Actor = streamLineActor;
	 }
	 if(DO_STUBE) {
	   myCallback->Actor = streamTubeActor;
	   printf("setting streamTubeActor\n");
	 }
	 if (!DO_STREAM && !DO_STUBE) {
	   printf("we shouldn't be here: we're going to crash\n");
	 }

	 if(lineWidget == NULL) 
	 {
	    lineWidget = vtkLineWidget::New();
	    lineWidget->SetInteractor(irenv);
	    //lineWidget->SetInput(vgrid);
	    lineWidget->SetInput(streamThresher->GetOutput());
	    lineWidget->SetAlignToYAxis();
	    lineWidget->PlaceWidget();
	    lineWidget->GetPolyData(seeds);
	    lineWidget->ClampToBoundsOff();
	    lineWidget->AddObserver(vtkCommand::InteractionEvent,myCallback);
	    lineWidget->KeyPressActivationOff();
	 }
	 lineWidget->EnabledOn();

      } else if (DO_PLANE_WIDGET) {

      	 fprintf(stderr,"Inside DO_PLANE_WIDGET\n");

	 if(planeWidget == NULL) 
	 {
	    planeWidget = vtkPlaneWidget::New();

	    planeWidget->SetInteractor(irenv);
	    planeWidget->SetInput(streamThresher->GetOutput());
	    planeWidget->NormalToXAxisOn();
#if 0
	    SET_LIMS(flims,1,MAX(MAX(dims[0],dims[1]),dims[2])) ;
	    int pwRes = (int) pinput("plane widget resolution",32,flims);
#endif
	    planeWidget->SetResolution(state.probeResolution);
	    planeWidget->SetRepresentationToOutline();
	    planeWidget->PlaceWidget();
	    planeWidget->KeyPressActivationOff();
	 }
	 planeWidget->EnabledOn();

	 // extract polygonal plane geometry of the widget
	 vtkPolyData *plane = vtkPolyData::New();
	 planeWidget->GetPolyData(plane);

	 // extract implicit plane geometry of the widget
	 vtkPlane *realPlane = vtkPlane::New();
	 planeWidget->GetPlane(realPlane);

	 // Here we create an instance of our callback class
	 vtkPlaneCallback *planeCB = vtkPlaneCallback::New();
	 planeCB->planeData = plane;     // link to polygonal representation of planewidget
	 planeCB->realPlane = realPlane; // link to implicit  representation of planewidget
	 
	 planeWidget->AddObserver(vtkCommand::StartInteractionEvent, planeCB);
	 planeWidget->AddObserver(vtkCommand::InteractionEvent, planeCB);
	 planeWidget->AddObserver(vtkCommand::EndInteractionEvent, planeCB);

	 probe->SetInput(plane) ;
	 probe->SetSource(streamThresher->GetOutput());
	 streamLine->SetSource(probe->GetOutput()) ;

	 vtkPolyDataMapper *probeMapper = vtkPolyDataMapper::New();
	 probeMapper->SetInput((vtkPolyData *)probe->GetOutput());

	 probeActor = vtkActor::New();
	 probeActor->SetMapper(probeMapper);
	 probeActor->GetProperty()->SetRepresentationToWireframe();
	 renv->AddActor(probeActor); 

      } else if(DO_POINT_WIDGET) {
	 
	 fprintf(stderr,"Inside DO_POINT_WIDGET\n");
    
	 if(pointWidget == NULL)
	 {
	    pointWidget = vtkPointWidget::New();

	    pointWidget->SetInteractor(irenv);
	    pointWidget->SetInput(streamThresher->GetOutput());
	    pointWidget->AllOff();
	    pointWidget->PlaceWidget();
	    pointWidget->KeyPressActivationOff();
	 }
	 pointWidget->EnabledOn();

	 vtkPolyData* point = vtkPolyData::New();
	 pointWidget->GetPolyData(point);

	 vtkPointCallback *pointCB = vtkPointCallback::New();
	 pointCB->pointData = point;

	 pointWidget->AddObserver(vtkCommand::StartInteractionEvent, pointCB);
	 pointWidget->AddObserver(vtkCommand::InteractionEvent, pointCB);
	 pointWidget->AddObserver(vtkCommand::EndInteractionEvent, pointCB);

	 probe->SetInput(point) ;
	 probe->SetSource(streamThresher->GetOutput());
	 streamLine->SetSource(probe->GetOutput()) ;
	 
	 vtkPolyDataMapper *probeMapper = vtkPolyDataMapper::New();
	 probeMapper->SetInput((vtkPolyData *)probe->GetOutput());
    
	 probeActor = vtkActor::New();
	 probeActor->SetMapper(probeMapper);
	 probeActor->GetProperty()->SetRepresentationToWireframe();
	 renv->AddActor(probeActor); 
      }
      else if(DO_PLANES) {

	 fprintf(stderr,"Inside DO_PLANE_SOURCE\n");

	 /*
	   vtkPSCallback *myCallback = vtkPSCallback::New();
	   vtkPolyData *plane = vtkPolyData::New();
	   myCallback->PolyData = plane;
	   
	   if(DO_STREAM) myCallback->Actor = streamLineActor;
	   if(DO_STUBE)  myCallback->Actor = streamTubeActor;
	 */

	 SET_LIMS(flims,1,dims[0]) ;
	 int xdim = (int) pinput("xdim",1,flims);
	 SET_LIMS(flims,1,dims[1]) ;
	 int ydim = (int) pinput("ydim",1,flims);
	 planeSource->SetResolution(xdim,ydim);

	 vtkFloatingPointType orig[] = {0.,0.,0.};
	 vtkFloatingPointType cent[] = {dims[0]/2.,dims[1]/2,dims[2]/2.};
	 planeSource->SetCenter(cent);
	 vtkFloatingPointType pt[3];
	 pt[0] = dims[0]; pt[1] = orig[1]; pt[2] = dims[2]/2.;
	 planeSource->SetPoint1(pt);
	 pt[0] = orig[0]; pt[1] = dims[1]; pt[2] = dims[2]/2.;
	 planeSource->SetPoint2(pt);

	 vtkTransform *trans = vtkTransform::New();
	 trans->Translate(-orig[0]/2.,-orig[1]/2.,0.) ;

	 vtkTransformPolyDataFilter *filt = vtkTransformPolyDataFilter::New();
	 filt->SetInput(planeSource->GetOutput());
	 filt->SetTransform(trans);

	 // Outline
	 vtkOutlineFilter *outTrans = vtkOutlineFilter::New();
	 outTrans->SetInput(filt->GetOutput());
	 vtkPolyDataMapper *mapOut = vtkPolyDataMapper::New();
	 mapOut->SetInput(outTrans->GetOutput());
	 vtkActor *outActor = vtkActor::New();
	 outActor->SetMapper(mapOut);
	 outActor->GetProperty()->SetColor(1.,1.,.1);
	 renv->AddActor(outActor); 

	 //planeSource->AddObserver(vtkCommand::InteractionEvent,myCallback);

	 probe->SetInput(planeSource->GetOutput()) ;
	 probe->SetSource(streamThresher->GetOutput());
	 streamLine->SetSource(planeSource->GetOutput()) ;

	 vtkPolyDataMapper *probeMapper = vtkPolyDataMapper::New();
	 probeMapper->SetInput((vtkPolyData *)probe->GetOutput());

	 probeActor = vtkActor::New();
	 probeActor->SetMapper(probeMapper);
	 probeActor->GetProperty()->SetRepresentationToWireframe();
	 
	 renv->AddActor(probeActor); 

      }
   }

   /* Render! */ 

//   renv->ResetCamera() ;
   renvWin->Render();  

}

void slice_toggle_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   int i;
   for(i = 0; i < 3; ++i)
   {
      if(w == state.sliceEnable[i])
      {
	 break;
      }
   }
   if(i == 3)
   {
      abort();
   }

   char wState = 
      reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

   switch(wState)
   {
      case XmSET:
	 state.drawSlice[i] = true;
	 break;
      case XmUNSET:
	 state.drawSlice[i] = false;
	 break;
   }

   recompute_slicer(w, client_data, call_data);
}

void frame_changed_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  state.frame = 
    reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;
  update_diffusion();
}

void specular_changed_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  state.specular = 
    reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;
  if (track_contour_actor) {
    track_contour_actor->GetProperty()->SetSpecular(state.specular/100.0);
    track_contour_actor->Modified();
    update_diffusion();
  }
}

void ambient_changed_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  state.ambient = 
    reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;
  if (track_contour_actor) {
    track_contour_actor->GetProperty()->SetAmbient(state.ambient/100.0);
    track_contour_actor->Modified();
    update_diffusion();
  }
}

void diffuse_changed_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  state.diffuse = 
    reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;
  if (track_contour_actor) {
    track_contour_actor->GetProperty()->SetDiffuse(state.diffuse/100.0);
    track_contour_actor->Modified();
    update_diffusion();
  }
}

void min_contour_changed_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  state.min_contour = 
    reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;
  if (track_contour) {
    track_contour->GenerateValues(state.num_contours, 
				  1.0*state.min_contour,
				  1.0*state.max_contour);
    update_diffusion();
  }
}

void max_contour_changed_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  state.max_contour = 
    reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;
  if (track_contour) {
    track_contour->GenerateValues(state.num_contours, 
				  1.0*state.min_contour,
				  1.0*state.max_contour);
    update_diffusion();
  }
}

void num_contours_changed_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  state.num_contours = 
    reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;
  if (track_contour) {
    track_contour->GenerateValues(state.num_contours, 
				  1.0*state.min_contour,
				  1.0*state.max_contour);
    update_diffusion();
  }
}

void opacity_changed_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  state.opacity = 
    reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;
  if (track_contour_actor) {
    track_contour_actor->GetProperty()->SetOpacity(state.opacity/100.0);
    track_contour_actor->Modified();
    update_diffusion();
  }
}

void slice_changed_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   int i;
   for(i = 0; i < 3; ++i)
   {
      if(w == state.sliders[i]) break;
   }
   if(i == 3) abort();

   state.sliceNum[i] = 
      reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;

   sprintf(state.sliderText[i], "%d", state.sliceNum[i]);
   /*   XtVaSetValues(state.posText[i],
		 XmNvalue, state.sliderText[i],
		 NULL); */

   if (state.drawSlice[i])
      recompute_slicer(w, client_data, call_data);
}

void scroll_drag_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   int i;
   for(i = 0; i < 3; ++i)
   {
      if(w == state.sliders[i]) break;
   }
   if(i == 3) abort();

   state.sliceNum[i] = 
      reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;

   sprintf(state.sliderText[i], "%d", state.sliceNum[i]);
   /*    XtVaSetValues(state.posText[i],
		 XmNvalue, state.sliderText[i],
		 NULL); */
   if (state.drawSlice[i])
      recompute_slicer(w, client_data, call_data);
}

/* streamline callback */
void stream_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
  fprintf(stderr,"Inside stream_cb\n");

  state.streamEnabled = !state.streamEnabled;
  if (state.streamEnabled) {
     XmString xstr = XmStringCreateLtoR("Disable", XmFONTLIST_DEFAULT_TAG);
     XtVaSetValues(stream_button, XmNlabelString, xstr, NULL);
     XmStringFree(xstr);
  }
  else {
     XmString xstr = XmStringCreateLtoR("Enable", XmFONTLIST_DEFAULT_TAG);
     XtVaSetValues(stream_button, XmNlabelString, xstr, NULL);
     XmStringFree(xstr);
               // more needed to be cleaned up when disabled
     if( streamThresher != NULL )
     {
       streamThresher->Delete();
       streamThresher = NULL;
     }  
  }
  DO_STREAM = state.streamEnabled;
  
  recompute_streamlines(w, client_data, call_data);
}

void tube_toggle_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   char wState = 
      reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

   switch(wState)
   {
      case XmSET:
	 state.drawStreamtube = true;
	 break;
      case XmUNSET:
	 state.drawStreamtube = false;
	 break;
   }

   recompute_streamlines(w, client_data, call_data);
}

void cbc_toggle_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   char wState = 
      reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

   switch(wState)
   {
      case XmSET:
	 state.colorByCurvature = true;
	 break;
      case XmUNSET:
	 state.colorByCurvature = false;
	 break;
   }

   recompute_streamlines(w, client_data, call_data);
}

void radius_changed_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   state.tubeRadius = 
      reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
      pow(10, UIState::RADIUS_DECIMAL_POINTS);
   
   if (state.streamEnabled && state.drawStreamtube)
   {
      recompute_streamlines(w, client_data, call_data);
   }
}

void proberes_changed_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   state.probeResolution = 
      reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position;
   
   if (state.streamEnabled && (state.probeType == UIState::PLANE))
   {
      recompute_streamlines(w, client_data, call_data);
   }
}

void streamline_fa_changed_cb(Widget w, XtPointer client_data, XtPointer 
  call_data)
{
   state.streamFA = 
     reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
     pow(10, UIState::DST_THRESHOLD_DECIMAL_POINTS);
   
   if (state.streamEnabled)
      recompute_streamlines(w, client_data, call_data);
}

void istep_changed_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   state.streamStepLength = 
      reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
      pow(10, UIState::STEPLENGTH_DECIMAL_POINTS);
   
   if (state.streamEnabled)
   {
      recompute_streamlines(w, client_data, call_data);
   }
}

void contour_track_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  char wState = 
    reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;
   if(wState = XmSET) {
      state.trackType = UIState::CONTOUR;
      if (renv && volume) {
	renv->RemoveVolume(volume);
      }
      if (renv && track_contour_actor) {
	renv->AddActor(track_contour_actor);
      }
      update_diffusion();
   }
}

void cloud_track_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  char wState = 
    reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;
   if(wState = XmSET) {
      state.trackType = UIState::CLOUD;
      if (renv && track_contour_actor) {
	renv->RemoveActor(track_contour_actor);
      }
      if (renv && volume) {
	renv->AddVolume(volume);
      }
      update_diffusion();
   }
}

void pointprobe_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   char wState = 
      reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

   if(wState = XmSET)
   {
      state.probeType = UIState::POINT;
   }

   recompute_streamlines(w, client_data, call_data);
}

void lineprobe_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   char wState = 
      reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

   if(wState = XmSET)
   {
      state.probeType = UIState::LINE;
   }

   recompute_streamlines(w, client_data, call_data);
}

void planeprobe_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
   char wState = 
      reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

   if(wState = XmSET)
   {
      state.probeType = UIState::PLANE;
   }

   recompute_streamlines(w, client_data, call_data);
}

/* contour callback */
void isoSurface_CB(Widget w, XtPointer client_data, XtPointer call_data)
{ 
  state.isosurfEnabled = !state.isosurfEnabled;
  if( state.isosurfEnabled )
  {
    XmString xstr = XmStringCreateLtoR( "Disable", XmFONTLIST_DEFAULT_TAG );
    XtVaSetValues(isoSurface_button, XmNlabelString, xstr, NULL);
    XmStringFree(xstr);
  }
  else
  {
    XmString xstr = XmStringCreateLtoR( "Enable", XmFONTLIST_DEFAULT_TAG );
    XtVaSetValues(isoSurface_button, XmNlabelString, xstr, NULL);
    XmStringFree(xstr);
               // clean up
    if( isoActor != NULL )
    {
      renv->RemoveActor( isoActor );
      isoActor->Delete();
      isoActor = NULL;
      renvWin->Render();
    }  
  }
  DO_ISOSURFACE = state.isosurfEnabled;

//  compute_isoSurface( w, client_data, call_data);
}

void updateWidgets()
{
#if 0
   for (int i = 0; i < 3; ++i)
   {
     /*      if(state.posText[i] != NULL)
      {
	 XtVaSetValues(state.posText[i],
		       XmNmaximumValue, state.maxSliceNum[i],
		       XmNposition, state.sliceNum[i],
		       NULL);
		       } */
   }
#endif
   for (int i = 0; i < 3; ++i)
   {
      if(state.sliders[i] != NULL)
      {
	 XtVaSetValues(state.sliders[i],
		       XmNminimum, 0,
		       XmNmaximum, state.maxSliceNum[i],
		       XmNvalue, state.sliceNum[i],
		       NULL);
	 /*	 XtVaSetValues(state.posText[i],
		       XmNvalue, state.sliderText[i],
		       NULL); */
      }
   }
   if (state.frame_slider != NULL) {
     XtVaSetValues(state.frame_slider,
		   XmNminimum, 1,
		   XmNmaximum, animation_frames,
		   XmNvalue, 1,
		   NULL);
   }

   if (state.min_contour_slider != NULL) {
     XtVaSetValues(state.min_contour_slider,
		   XmNminimum, 1,
		   XmNmaximum, 255,
		   XmNvalue, 4,
		   NULL);
   }

   if (state.max_contour_slider != NULL) {
     XtVaSetValues(state.max_contour_slider,
		   XmNminimum, 1,
		   XmNmaximum, 255,
		   XmNvalue, 128,
		   NULL);
   }

   if (state.num_contours_slider != NULL) {
     XtVaSetValues(state.num_contours_slider,
		   XmNminimum, 1,
		   XmNmaximum, 5,
		   XmNvalue, 3,
		   NULL);
   }

   if (state.opacity_slider != NULL) {
     XtVaSetValues(state.opacity_slider,
		   XmNminimum, 0,
		   XmNmaximum, 100,
		   XmNvalue, 20,
		   NULL);
   }

   if (state.specular_slider != NULL) {
     XtVaSetValues(state.specular_slider,
		   XmNminimum, 0,
		   XmNmaximum, 100,
		   XmNvalue, 20,
		   NULL);
   }

   if (state.ambient_slider != NULL) {
     XtVaSetValues(state.ambient_slider,
		   XmNminimum, 0,
		   XmNmaximum, 100,
		   XmNvalue, 80,
		   NULL);
   }

   if (state.diffuse_slider != NULL) {
     XtVaSetValues(state.diffuse_slider,
		   XmNminimum, 0,
		   XmNmaximum, 100,
		   XmNvalue, 30,
		   NULL);
   }

//   if(state.probeResText != NULL)
//   {
//      XtVaSetValues(state.probeResText,
//		    XmNmaximumValue, state.maxProbeResolution,
//		    XmNposition, state.probeResolution, NULL);
//   }

   int minCont = (int)(state.minContourLevel * 
		       pow(10, state.contourDecimalPoints));
   int maxCont = (int)(state.maxContourLevel * 
		       pow(10, state.contourDecimalPoints));
   if(state.minContourText != NULL)
   {
      XtVaSetValues(state.minContourText,
		    XmNminimumValue, minCont,
		    XmNmaximumValue, maxCont,
		    XmNposition, minCont,
		    XmNdecimalPoints, state.contourDecimalPoints,
		    XmNincrementValue, state.contourIncrement,
		    NULL);
   }
   if(state.maxContourText != NULL)
   {
      XtVaSetValues(state.maxContourText,
		    XmNminimumValue, minCont,
		    XmNmaximumValue, maxCont,
		    XmNposition, maxCont,
		    XmNdecimalPoints, state.contourDecimalPoints,
		    XmNincrementValue, state.contourIncrement,
		    NULL);
   }
}

  /* Current hardwired - haven't really figured out how this works yet! */ 
#define FRAC             0.77
#define VTK_WIDG_WIDTH   800
#define VTK_WIDG_HEIGHT  400
#define BUTTON_HEIGHT    40

Widget setup_vector_widgets(Widget sh,vtkXOpenGLRenderWindow *rw)
{
  Widget exit_button;
  Widget toMCell_button;
  Widget diffusion_path_button;
  Widget max_conc_button;
  Widget animation_button;
  Widget tube_button;
  Widget contour_button;
  Widget slicer_button;
  Widget control_rowcol, button_rowcol, advanced_rowcol;
  Widget toplevel;
  Widget form;
  Widget widg_ret ;
  Widget separator;
  XmString xstr ;

  /* X Window stuff begin */

  XtSetLanguageProc(NULL,NULL,NULL);

  // get the display connection and give it to the renderer

  rw->SetDisplayId(XtDisplay(sh));

  toplevel = XtVaCreateWidget("Diffusion Vector Visualizer",
			       topLevelShellWidgetClass,sh,
                               XmNdepth, rw->GetDesiredDepth(),
                               XmNvisual, rw->GetDesiredVisual(),
                               XmNcolormap, rw->GetDesiredColormap(),
                               NULL);

  form = XtVaCreateWidget("form",
			  xmFormWidgetClass, toplevel, 
			  XmNwidth, 1000, XmNheight, 1000,
			  NULL);

  // rowcol for buttons

  /*Widget allFrame = 
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass, form, 
			     XmNheight, 50, 
			     NULL); */
  
  button_rowcol =  XtVaCreateWidget("AFNI" , xmRowColumnWidgetClass , 
				    form ,
				    XmNorientation  , XmVERTICAL,
				    XmNpacking      , XmPACK_TIGHT,
				    XmNwidth, 300,//275,
				    XmNresizeWidth, true,//false,
				    XmNbottomAttachment, XmATTACH_FORM,
				    XmNtopAttachment, XmATTACH_FORM,
				    //XmNtopWidget, widg_ret,
				    XmNleftAttachment, XmATTACH_NONE,
				    XmNrightAttachment, XmATTACH_FORM,
				    /*XmNrecomputeSize , False ,*/
				    XmNtraversalOn , False ,
				    XmNinitialResourcesPersistent , False ,
				    XmNspacing, 0, 
				    NULL); 

  /*  Widget button_frame = 
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     control_rowcol, 
			     NULL);

  button_rowcol =      XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     button_frame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     XmNspacing, 0, 
			     NULL);*/


  /*  Widget advanced_frame = 
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     control_rowcol, 
			     NULL);

  advanced_rowcol =    XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     advanced_frame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     XmNspacing, 0, 
			     NULL);*/

  widg_ret = XtVaCreateManagedWidget("vtk_vector_widg",
				     xmPrimitiveWidgetClass, form, 
                                     XmNwidth, VTK_WIDG_WIDTH, XmNheight, VTK_WIDG_HEIGHT,
                                     XmNleftAttachment, XmATTACH_FORM,
                                     XmNrightAttachment, XmATTACH_WIDGET,
                                     XmNtopAttachment, XmATTACH_FORM,
				     XmNbottomAttachment , XmATTACH_FORM ,
				     XmNrightWidget, button_rowcol,
                                     NULL);


  // Slicer pane

  Widget slicerFrame = 
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     button_rowcol, 
			     NULL);

  Widget slicerCol = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     slicerFrame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     XmNspacing, 0, 
			     NULL);

  xstr = XmStringCreateLtoR( "Slicer" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget slicerLabel = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     slicerCol,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  Widget zRow = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass,
			     slicerCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  /* set axial view on -- all others are off by default */
  state.drawSlice[2] = true;
  xstr = XmStringCreateLtoR( "Axial" , XmFONTLIST_DEFAULT_TAG ) ;
  state.sliceEnable[2] = 
     XtVaCreateManagedWidget("AFNI" , xmToggleButtonWidgetClass , 
			     zRow ,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNset, True,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;
  XtAddCallback(state.sliceEnable[2],XmNvalueChangedCallback, 
		slice_toggle_cb,(XtPointer *)toplevel);

  /*  state.posText[2] =
     XtVaCreateManagedWidget("AFNI", xmTextWidgetClass,
			     zRow,
			     XmNcolumns, 4,
			     XmNspinBoxChildType, XmNUMERIC,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL); */

  state.sliders[2] =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     zRow,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 125,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);
  XtAddCallback(state.sliders[2],XmNvalueChangedCallback, 
		slice_changed_cb,(XtPointer *)toplevel);
  XtAddCallback(state.sliders[2],XmNdragCallback, 
		scroll_drag_cb,(XtPointer *)toplevel);


  Widget xRow = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass,
			     slicerCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);
  
  xstr = XmStringCreateLtoR( "Sagittal" , XmFONTLIST_DEFAULT_TAG ) ;
  state.sliceEnable[0] = 
     XtVaCreateManagedWidget("AFNI" , xmToggleButtonWidgetClass , 
			     xRow ,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;
  XtAddCallback(state.sliceEnable[0],XmNvalueChangedCallback, 
		slice_toggle_cb,(XtPointer *)toplevel);

  /*  state.posText[0] =
     XtVaCreateManagedWidget("AFNI", xmTextWidgetClass,
			     xRow,
			     XmNcolumns, 4,
			     XmNspinBoxChildType, XmNUMERIC,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL); */

  state.sliders[0] =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     xRow,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 125,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);
  /*     XtVaCreateManagedWidget("AFNI", xmScrollBarWidgetClass,
			     slicerCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNsliderSize, 10,
			     XmNincrement, 1,
			     XmNpageIncrement, 1,
			     NULL);*/
  XtAddCallback(state.sliders[0],XmNvalueChangedCallback, 
		slice_changed_cb,(XtPointer *)toplevel);
  XtAddCallback(state.sliders[0],XmNdragCallback, 
		scroll_drag_cb,(XtPointer *)toplevel);

  Widget yRow = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass,
			     slicerCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);
  

  xstr = XmStringCreateLtoR( "Coronal" , XmFONTLIST_DEFAULT_TAG ) ;
  state.sliceEnable[1] = 
     XtVaCreateManagedWidget("AFNI" , xmToggleButtonWidgetClass , 
			     yRow ,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;
  XtAddCallback(state.sliceEnable[1],XmNvalueChangedCallback, 
		slice_toggle_cb,(XtPointer *)toplevel);

  /*  state.posText[1] =
     XtVaCreateManagedWidget("AFNI", xmTextWidgetClass,
			     yRow,
			     XmNcolumns, 4,
			     XmNspinBoxChildType, XmNUMERIC,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL); */

  state.sliders[1] =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     yRow,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 125,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);
  /*     XtVaCreateManagedWidget("AFNI", xmScrollBarWidgetClass,
			     slicerCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNsliderSize, 10,
			     XmNincrement, 1,
			     XmNpageIncrement, 1,
			     NULL); */
  XtAddCallback(state.sliders[1],XmNvalueChangedCallback, 
		slice_changed_cb,(XtPointer *)toplevel);
  XtAddCallback(state.sliders[1],XmNdragCallback, 
		scroll_drag_cb,(XtPointer *)toplevel);


  // View Pane
  Widget view_frame = 
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     button_rowcol,
			     NULL);
  Widget view_col = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     view_frame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     NULL);

  xstr = XmStringCreateLtoR("Snap to View", XmFONTLIST_DEFAULT_TAG);
  Widget view_label= 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     view_col,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  Widget view_row = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     view_col,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  xstr = XmStringCreateLtoR("Axial", XmFONTLIST_DEFAULT_TAG);
  Widget axial_view_button =
    XtVaCreateManagedWidget("AFNI" ,
			    xmPushButtonWidgetClass,
			    view_row,
			    XmNlabelString, xstr,
			    XmNtraversalOn, False,
			    XmNinitialResourcesPersistent, False,
			    NULL);

  XtAddCallback(axial_view_button,XmNactivateCallback,
		axial_view_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR("Sagittal", XmFONTLIST_DEFAULT_TAG);
  Widget sagittal_view_button =
    XtVaCreateManagedWidget("AFNI" ,
			    xmPushButtonWidgetClass,
			    view_row,
			    XmNlabelString, xstr,
			    XmNtraversalOn, False,
			    XmNinitialResourcesPersistent, False,
			    NULL);

  XtAddCallback(sagittal_view_button,XmNactivateCallback,
		sagittal_view_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR("Coronal", XmFONTLIST_DEFAULT_TAG);
  Widget coronal_view_button =
    XtVaCreateManagedWidget("AFNI" ,
			    xmPushButtonWidgetClass,
			    view_row,
			    XmNlabelString, xstr,
			    XmNtraversalOn, False,
			    XmNinitialResourcesPersistent, False,
			    NULL);

  XtAddCallback(coronal_view_button,XmNactivateCallback,
		coronal_view_cb,(XtPointer *)toplevel);


  // Colormap pane

  Widget color_frame = 
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     button_rowcol,
			     NULL);
  Widget color_col = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     color_frame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     NULL);

  xstr = XmStringCreateLtoR( "Colormap on Slice" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget colormap_label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     color_col,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  Widget color_row = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     color_col,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  xstr = XmStringCreateLtoR("Axl", XmFONTLIST_DEFAULT_TAG);
  colormap_button[2] =
    XtVaCreateManagedWidget("AFNI" ,
			    xmToggleButtonWidgetClass,
			    color_row,
			    XmNlabelString, xstr,
			    XmNtraversalOn, False,
			    XmNinitialResourcesPersistent, False,
			    NULL);

  XtAddCallback(colormap_button[2],XmNvalueChangedCallback,
		colormap_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR("Sag", XmFONTLIST_DEFAULT_TAG);
  colormap_button[0] =
    XtVaCreateManagedWidget("AFNI" ,
			    xmToggleButtonWidgetClass,
			    color_row,
			    XmNlabelString, xstr,
			    XmNtraversalOn, False,
			    XmNinitialResourcesPersistent, False,
			    NULL);

  XtAddCallback(colormap_button[0],XmNvalueChangedCallback,
		colormap_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR("Cor", XmFONTLIST_DEFAULT_TAG);
  colormap_button[1] =
    XtVaCreateManagedWidget("AFNI" ,
			    xmToggleButtonWidgetClass,
			    color_row,
			    XmNlabelString, xstr,
			    XmNtraversalOn, False,
			    XmNinitialResourcesPersistent, False,
			    NULL);

  XtAddCallback(colormap_button[1],XmNvalueChangedCallback,
		colormap_cb,(XtPointer *)toplevel);

  //Vector pane

  Widget vectorFrame = 
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     button_rowcol,
			     NULL);
  Widget vectorCol = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     vectorFrame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     NULL);

  xstr = XmStringCreateLtoR( "Vector Field" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget vectorLabel = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     vectorCol,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  Widget vector_row = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     vectorCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  xstr = XmStringCreateLtoR("Axl", XmFONTLIST_DEFAULT_TAG);
  Widget axial_vector_button =
    XtVaCreateManagedWidget("AFNI" ,
			    xmToggleButtonWidgetClass,
			    vector_row,
			    XmNlabelString, xstr,
			    XmNset, False,
			    NULL);

  XtAddCallback(axial_vector_button,XmNvalueChangedCallback,
		axial_vector_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR("Sag", XmFONTLIST_DEFAULT_TAG);
  Widget sagittal_vector_button =
    XtVaCreateManagedWidget("AFNI" ,
			    xmToggleButtonWidgetClass,
			    vector_row,
			    XmNlabelString, xstr,
			    XmNset, False,
			    NULL);

  XtAddCallback(sagittal_vector_button,XmNvalueChangedCallback,
		sagittal_vector_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR("Cor", XmFONTLIST_DEFAULT_TAG);
  Widget coronal_vector_button =
    XtVaCreateManagedWidget("AFNI" ,
			    xmToggleButtonWidgetClass,
			    vector_row,
			    XmNlabelString, xstr,
			    XmNset, False,
			    NULL);

  XtAddCallback(coronal_vector_button,XmNvalueChangedCallback,
		coronal_vector_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR( "Enable Global Field" , XmFONTLIST_DEFAULT_TAG ) ;
  vfield_button = 
     XtVaCreateManagedWidget("AFNI" , xmPushButtonWidgetClass , 
			     vectorCol ,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;

  XtAddCallback(vfield_button,XmNactivateCallback,vfield_cb,(XtPointer *)toplevel);



//animation pane
  Widget all_animation_frame =
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     button_rowcol,
			     NULL);
    

  Widget all_animation_row = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     all_animation_frame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     NULL);

#ifdef EXPERIMENTAL
  xstr = XmStringCreateLtoR( "Diffusion Track" , XmFONTLIST_DEFAULT_TAG ) ;

  Widget diffusion_track_Label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     all_animation_row,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  xstr = XmStringCreateLtoR( "Reload data" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget reload_data_button = 
     XtVaCreateManagedWidget("AFNI" , xmPushButtonWidgetClass , 
			     all_animation_row ,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;

  XtAddCallback(reload_data_button,XmNactivateCallback,reload_data_cb,
		(XtPointer *)toplevel);


  state.left_animation_frame =
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     all_animation_row,
			     NULL);
  state.right_animation_frame =
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     all_animation_row,
			     NULL);
  Widget right_animation_col = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     state.right_animation_frame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     NULL);

  Widget animationCol = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     state.left_animation_frame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     NULL);

#endif /* EXPERIMENTAL */

  xstr = XmStringCreateLtoR( "Export MCell Files" , XmFONTLIST_DEFAULT_TAG ) ;
  toMCell_button = 
     XtVaCreateManagedWidget("AFNI" , xmPushButtonWidgetClass , 
			     all_animation_row ,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;

  XtAddCallback(toMCell_button,XmNactivateCallback,toMCell_cb,(XtPointer *)toplevel);

#ifdef EXPERIMENTAL
  Widget frame_row =
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     animationCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN,
			     XmNradioBehavior, True,
			     XmNradioAlwaysOne, True,
			     NULL);

  xstr = XmStringCreateLtoR( "Frame" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget frame_row_label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     frame_row,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  state.frame_slider =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     frame_row,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 120,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);

  XtAddCallback(state.frame_slider,XmNvalueChangedCallback, 
		frame_changed_cb,(XtPointer *)toplevel);


  xstr = XmStringCreateLtoR( "Plot Type:" , XmFONTLIST_DEFAULT_TAG ) ;

  Widget plot_type_label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     animationCol,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  Widget plotType =
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     animationCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNradioBehavior, True,
			     XmNradioAlwaysOne, True,
			     NULL);


  xstr = XmStringCreateLtoR( "Contour" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget contourToggle =
     XtVaCreateManagedWidget("AFNI" , xmToggleButtonWidgetClass , 
			     plotType ,
			     XmNlabelString , xstr ,
			     XmNset, True,
			     NULL ) ;
  XtAddCallback(contourToggle,XmNvalueChangedCallback, 
		contour_track_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR( "Cloud" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget cloudToggle =
     XtVaCreateManagedWidget("AFNI" , xmToggleButtonWidgetClass , 
			     plotType ,
			     XmNlabelString , xstr ,
			     NULL ) ;
  XtAddCallback(cloudToggle,XmNvalueChangedCallback, 
		cloud_track_cb,(XtPointer *)toplevel);

  Widget min_contour_row =
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     right_animation_col,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN ,
			     XmNradioBehavior, True,
			     XmNradioAlwaysOne, True,
			     NULL);

  xstr = XmStringCreateLtoR( "min. contour" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget min_contour_row_label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     min_contour_row,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  state.min_contour_slider =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     min_contour_row,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 125,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);

  XtAddCallback(state.min_contour_slider,XmNvalueChangedCallback, 
		min_contour_changed_cb,(XtPointer *)toplevel);

  Widget max_contour_row =
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     right_animation_col,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN ,
			     XmNradioBehavior, True,
			     XmNradioAlwaysOne, True,
			     NULL);

  xstr = XmStringCreateLtoR( "max. contour" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget max_contour_row_label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     max_contour_row,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  state.max_contour_slider =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     max_contour_row,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 125,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);

  XtAddCallback(state.max_contour_slider,XmNvalueChangedCallback, 
		max_contour_changed_cb,(XtPointer *)toplevel);

  Widget num_contours_row =
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     right_animation_col,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN ,
			     XmNradioBehavior, True,
			     XmNradioAlwaysOne, True,
			     NULL);

  xstr = XmStringCreateLtoR( "num. contours" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget num_contours_row_label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     num_contours_row,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  state.num_contours_slider =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     num_contours_row,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 125,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);

  XtAddCallback(state.num_contours_slider,XmNvalueChangedCallback, 
		num_contours_changed_cb,(XtPointer *)toplevel);

  Widget opacity_row =
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     right_animation_col,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN ,
			     XmNradioBehavior, True,
			     XmNradioAlwaysOne, True,
			     NULL);

  xstr = XmStringCreateLtoR( "opac." , XmFONTLIST_DEFAULT_TAG ) ;
  Widget opacity_row_label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     opacity_row,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  state.opacity_slider =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     opacity_row,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 125,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);

  XtAddCallback(state.opacity_slider,XmNvalueChangedCallback, 
		opacity_changed_cb,(XtPointer *)toplevel);

  Widget specular_row =
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     right_animation_col,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN ,
			     XmNradioBehavior, True,
			     XmNradioAlwaysOne, True,
			     NULL);

  xstr = XmStringCreateLtoR( "spec." , XmFONTLIST_DEFAULT_TAG ) ;
  Widget specular_row_label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     specular_row,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  state.specular_slider =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     specular_row,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 125,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);

  XtAddCallback(state.specular_slider,XmNvalueChangedCallback, 
		specular_changed_cb,(XtPointer *)toplevel);

  Widget ambient_row =
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     right_animation_col,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN,
			     XmNradioBehavior, True,
			     XmNradioAlwaysOne, True,
			     NULL);

  xstr = XmStringCreateLtoR( "amb." , XmFONTLIST_DEFAULT_TAG ) ;
  Widget ambient_row_label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     ambient_row,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  state.ambient_slider =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     ambient_row,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 125,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);

  XtAddCallback(state.ambient_slider,XmNvalueChangedCallback, 
		ambient_changed_cb,(XtPointer *)toplevel);

  Widget diffuse_row =
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     right_animation_col,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_COLUMN,
			     XmNradioBehavior, True,
			     XmNradioAlwaysOne, True,
			     NULL);

  xstr = XmStringCreateLtoR( "diff." , XmFONTLIST_DEFAULT_TAG ) ;
  Widget diffuse_row_label = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     diffuse_row,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  state.diffuse_slider =
     XtVaCreateManagedWidget("AFNI", xmScaleWidgetClass,
			     diffuse_row,
			     XmNorientation, XmHORIZONTAL,
			     XmNscaleWidth, 125,
			     XmNscaleMultiple , 1 ,  /* single step */
			     XmNshowArrows, XmEACH_SIDE,
			     XmNshowValue, XmNEAR_BORDER,
			     NULL);

  XtAddCallback(state.diffuse_slider,XmNvalueChangedCallback, 
		diffuse_changed_cb,(XtPointer *)toplevel);


  XtUnmanageChild(state.right_animation_frame);

  xstr = XmStringCreateLtoR( "Show Diffusion Track" , XmFONTLIST_DEFAULT_TAG ) ;

  diffusion_path_button = 
     XtVaCreateManagedWidget("AFNI" , xmToggleButtonWidgetClass , 
			     animationCol,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;

  XtAddCallback(diffusion_path_button,XmNvalueChangedCallback,
		diffusion_path_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR( "Show Path of Max. Conc." , XmFONTLIST_DEFAULT_TAG ) ;
  max_conc_button = 
     XtVaCreateManagedWidget("AFNI" , xmToggleButtonWidgetClass , 
			     animationCol ,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;

  XtAddCallback(max_conc_button,XmNvalueChangedCallback,
		max_conc_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR( "Show Diffusion Animation" , XmFONTLIST_DEFAULT_TAG ) ;
  animation_button = 
     XtVaCreateManagedWidget("AFNI" , xmToggleButtonWidgetClass , 
			     animationCol ,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;

  XtAddCallback(animation_button,XmNvalueChangedCallback,
		animation_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR( "Advanced controls..." , XmFONTLIST_DEFAULT_TAG );
  Widget advanced_controls_button = 
     XtVaCreateManagedWidget("AFNI" , xmPushButtonWidgetClass , 
			     all_animation_row ,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;
  XtAddCallback(advanced_controls_button,XmNactivateCallback,
		advanced_controls_cb,(XtPointer *)toplevel);
#endif /* EXPERIMENTAL */

               // DST fiber tracking pane
  Widget dstFrame = XtVaCreateManagedWidget( "AFNI", 
    xmFrameWidgetClass, button_rowcol, NULL );  
  Widget dstCol = XtVaCreateManagedWidget( "AFNI", 
    xmRowColumnWidgetClass, dstFrame, 
    XmNorientation, XmVERTICAL,
    XmNpacking, XmPACK_TIGHT, 
    XmNtraversalOn, False, 
    XmNinitialResourcesPersistent, False, 
    XmNframeChildType, XmFRAME_WORKAREA_CHILD, NULL );

  xstr = XmStringCreateLtoR( "DST Fiber Tract Mapping", 
    XmFONTLIST_DEFAULT_TAG );
  Widget dst_controlPanel_pb = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, dstCol,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_controlPanel_pb, XmNactivateCallback, 
    DST_controlPanel_CB, (XtPointer*)toplevel );

               // Streamline fiber tracking pane
  Widget streamlineFrame = XtVaCreateManagedWidget( "AFNI", 
    xmFrameWidgetClass, button_rowcol, NULL );  
  Widget streamlineCol = XtVaCreateManagedWidget( "AFNI", 
    xmRowColumnWidgetClass, streamlineFrame, 
    XmNorientation, XmVERTICAL,
    XmNpacking, XmPACK_TIGHT, 
    XmNtraversalOn, False, 
    XmNinitialResourcesPersistent, False, 
    XmNframeChildType, XmFRAME_WORKAREA_CHILD, NULL );

  xstr = XmStringCreateLtoR( "Streamline Fiber Tracking", 
    XmFONTLIST_DEFAULT_TAG );
  Widget streamline_controlPanel_pb = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, streamlineCol,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( streamline_controlPanel_pb, XmNactivateCallback, 
    streamline_controlPanel_CB, (XtPointer*)toplevel );

               // contour pane
  Widget isoSurfaceFrame = XtVaCreateManagedWidget( "AFNI", 
    xmFrameWidgetClass, button_rowcol, NULL );  
  Widget isoSurfaceCol = XtVaCreateManagedWidget( "AFNI", 
    xmRowColumnWidgetClass, isoSurfaceFrame, 
    XmNorientation, XmVERTICAL,
    XmNpacking, XmPACK_TIGHT, 
    XmNtraversalOn, False, 
    XmNinitialResourcesPersistent, False, 
    XmNframeChildType, XmFRAME_WORKAREA_CHILD, NULL );

  xstr = XmStringCreateLtoR( "IsoSurface Rendering", 
    XmFONTLIST_DEFAULT_TAG );
  Widget isoSurface_controlPanel_pb = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, isoSurfaceCol,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( isoSurface_controlPanel_pb, XmNactivateCallback, 
    isoSurface_controlPanel_CB, (XtPointer*)toplevel );

#ifdef OLD_CONTOUR_STUFF
  // Contour pane

  Widget contourFrame = 
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     button_rowcol,
			     NULL);
  Widget contourCol = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     contourFrame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     NULL);


  xstr = XmStringCreateLtoR( "Contour" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget contourLabel = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     contourCol,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  xstr = XmStringCreateLtoR( "Enable" , XmFONTLIST_DEFAULT_TAG ) ;
  contour_button = 
     XtVaCreateManagedWidget("AFNI" , xmPushButtonWidgetClass , 
			     contourCol ,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;

  XtAddCallback(contour_button,XmNactivateCallback,isoSurface_CB,(XtPointer *)toplevel);


  Widget numContoursRow = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     contourCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  Widget numContours = 
     XtVaCreateManagedWidget("AFNI", xmSpinBoxWidgetClass,
			     numContoursRow,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  state.numContoursText =
     XtVaCreateManagedWidget("AFNI", xmTextWidgetClass,
			     numContours,
			     XmNcolumns, 2,
			     XmNminimumValue, state.MIN_NUM_CONTOURS,
			     XmNmaximumValue, state.MAX_NUM_CONTOURS,
			     XmNposition, state.DEFAULT_NUM_CONTOURS,
			     XmNspinBoxChildType, XmNUMERIC,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  xstr = XmStringCreateLtoR( "# of levels" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget numContoursLabel = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     numContoursRow,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  Widget minContourRow = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     contourCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  Widget minContour = 
     XtVaCreateManagedWidget("AFNI", xmSpinBoxWidgetClass,
			     minContourRow,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);
			     
  state.minContourText =
     XtVaCreateManagedWidget("AFNI", xmTextWidgetClass,
			     minContour,
			     XmNcolumns, 5,
			     XmNspinBoxChildType, XmNUMERIC,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  xstr = XmStringCreateLtoR( "Min contour level" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget minContourLabel = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     minContourRow,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);
  Widget maxContourRow = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     contourCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  Widget maxContour = 
     XtVaCreateManagedWidget("AFNI", xmSpinBoxWidgetClass,
			     maxContourRow,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);
			     
  state.maxContourText =
     XtVaCreateManagedWidget("AFNI", xmTextWidgetClass,
			     maxContour,
			     XmNcolumns, 5,
			     XmNspinBoxChildType, XmNUMERIC,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);

  xstr = XmStringCreateLtoR( "Max contour level" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget maxContourLabel = 
     XtVaCreateManagedWidget("AFNI", xmLabelWidgetClass,
			     maxContourRow,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);
#endif

  //Miscellaneous pane

  Widget miscFrame = 
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     button_rowcol,
			     NULL);

  Widget miscCol = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     miscFrame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     NULL);

  static float fai_step = .05 ;
  static float fai_thresh = .5 ;
  static float fai_max = 1.0;

  fai_thresh_av =  new_MCW_arrowval( miscCol, "FAI thresh", 
				     MCW_AV_downup, 0,
				     (int)(100*fai_max), 
				     (int)(100.*fai_thresh),
				     MCW_AV_edittext , 2,
				     fai_thresh_av_CB,NULL,NULL,NULL ) ;

  fai_thresh_av->fstep = fai_step;

  MCW_reghelp_children(fai_thresh_av->wrowcol,"FAI threshold") ;
  XtAddCallback( fai_thresh_av->wtext, XmNactivateCallback, fai_thresh_cb, fai_thresh_av) ;

  Widget save_image_frame =
    XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			    button_rowcol,
			    NULL);

  Widget save_image_col = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     save_image_frame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     NULL);

  xstr = XmStringCreateLtoR( "Show bounding box" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget show_boundingbox_button =
    XtVaCreateManagedWidget("AFNI" ,
			    xmToggleButtonWidgetClass,
			    save_image_col,
			    XmNlabelString, xstr,
			    XmNset, True,
			    NULL);

  XtAddCallback(show_boundingbox_button,XmNvalueChangedCallback,
		boundingbox_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR( "Show axes" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget show_axes_button =
    XtVaCreateManagedWidget("AFNI" ,
			    xmToggleButtonWidgetClass,
			    save_image_col,
			    XmNlabelString, xstr,
			    XmNset, True,
			    NULL);

  XtAddCallback(show_axes_button,XmNvalueChangedCallback,
		axes_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR( "Save Image" , XmFONTLIST_DEFAULT_TAG ) ;
  save_image_button = 
     XtVaCreateManagedWidget("AFNI" , xmPushButtonWidgetClass , 
			     save_image_col,
			     XmNlabelString , xstr ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL ) ;

  XtAddCallback(save_image_button,XmNactivateCallback,save_image_cb,(XtPointer *)toplevel);

  Widget exitFrame = 
     XtVaCreateManagedWidget("AFNI", xmFrameWidgetClass,
			     button_rowcol,
			     NULL);
  Widget exitCol = 
     XtVaCreateManagedWidget("AFNI", xmRowColumnWidgetClass, 
			     exitFrame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNframeChildType, XmFRAME_WORKAREA_CHILD,
			     NULL);

  xstr = XmStringCreateLtoR( "Exit" , XmFONTLIST_DEFAULT_TAG ) ;
  exit_button = XtVaCreateManagedWidget("AFNI" , xmPushButtonWidgetClass , 
					exitCol ,
					XmNlabelString , xstr ,
					XmNtraversalOn , False ,
					XmNinitialResourcesPersistent , False ,
					NULL ) ;


  XtAddCallback(exit_button,XmNactivateCallback,quit_cb,(XtPointer *)toplevel);

  // Management

  XtManageChild(button_rowcol) ;
  XtManageChild(form) ;
  XtRealizeWidget(toplevel) ;
  XtMapWidget(toplevel);

  updateWidgets();

  return (widg_ret) ;
}

Widget setup_widgets(Widget sh,vtkXOpenGLRenderWindow *rw)
{
  Widget toplevel;
  Widget form;
  Widget widg_ret;
//  Widget button_exit, button_signal, button_odf, button_shd, button_dt2;

  /* X Window stuff begin */

  XtSetLanguageProc(NULL,NULL,NULL);

  // get the display connection and give it to the renderer

  rw->SetDisplayId(XtDisplay(sh));

  toplevel = XtVaCreateWidget("Diffusion Visualizer",
    topLevelShellWidgetClass,sh,
    XmNdepth, rw->GetDesiredDepth(),
    XmNvisual, rw->GetDesiredVisual(),
    XmNcolormap, rw->GetDesiredColormap(), NULL);

  form = XtVaCreateWidget("form",xmFormWidgetClass, toplevel, 
    XmNwidth, 350, XmNheight, 380, NULL);
  widg_ret = XtVaCreateManagedWidget("vtk_widg",
    xmPrimitiveWidgetClass, form, 
    XmNwidth, 350, XmNheight, 350,
    XmNleftAttachment, XmATTACH_FORM,
    XmNrightAttachment, XmATTACH_FORM,
    XmNtopAttachment, XmATTACH_FORM,
    XmNbottomAttachment , XmATTACH_POSITION ,
    XmNbottomPosition, (int)((1.- FRAC) * VTK_WIDG_HEIGHT), NULL);
               // buttons
  button_signal = XtVaCreateManagedWidget("Signal",
    xmPushButtonWidgetClass, form,
    XmNbottomAttachment, XmATTACH_FORM,
    XmNtopAttachment, XmATTACH_WIDGET,
    XmNtopWidget, widg_ret,
    XmNleftAttachment, XmATTACH_FORM,
    XmNrightAttachment, XmATTACH_POSITION,
    XmNrightPosition,20,
    XmNtraversalOn, False ,
    XmNrecomputeSize, False ,
    XmNinitialResourcesPersistent, False, NULL);
  XtAddCallback(button_signal,XmNactivateCallback,voxel_signal_CB,
    (XtPointer *)toplevel);
  button_odf = XtVaCreateManagedWidget("ODF",
    xmPushButtonWidgetClass, form,
    XmNbottomAttachment, XmATTACH_FORM,
    XmNtopAttachment, XmATTACH_WIDGET,
    XmNtopWidget, widg_ret,
    XmNleftAttachment, XmATTACH_WIDGET,
    XmNleftWidget, button_signal,
    XmNrightAttachment, XmATTACH_POSITION,
    XmNrightPosition, 40,
    XmNtraversalOn, False ,
    XmNrecomputeSize, False ,
    XmNinitialResourcesPersistent , False , NULL);
  XtAddCallback(button_odf,XmNactivateCallback,voxel_odf_CB,
    (XtPointer *)toplevel);
  button_shd = XtVaCreateManagedWidget("SHD",
    xmPushButtonWidgetClass, form,
    XmNbottomAttachment, XmATTACH_FORM,
    XmNtopAttachment, XmATTACH_WIDGET,
    XmNtopWidget, widg_ret,
    XmNleftAttachment, XmATTACH_WIDGET,
    XmNleftWidget, button_odf,
    XmNrightAttachment, XmATTACH_POSITION,
    XmNrightPosition, 60,
    XmNtraversalOn, False ,
    XmNrecomputeSize, False ,
    XmNinitialResourcesPersistent , False , NULL);
  XtAddCallback(button_shd,XmNactivateCallback,voxel_shd_CB,
    (XtPointer *)toplevel);
  button_dt2 = XtVaCreateManagedWidget("DT2",
    xmPushButtonWidgetClass, form,
    XmNbottomAttachment, XmATTACH_FORM,
    XmNtopAttachment, XmATTACH_WIDGET,
    XmNtopWidget, widg_ret,
    XmNleftAttachment, XmATTACH_WIDGET,
    XmNleftWidget, button_shd,
    XmNrightAttachment, XmATTACH_POSITION,
    XmNrightPosition, 80,
    XmNtraversalOn, False ,
    XmNrecomputeSize, False ,
    XmNinitialResourcesPersistent , False , NULL);
  XtAddCallback(button_dt2,XmNactivateCallback,voxel_dt2_CB,
    (XtPointer *)toplevel);
  button_exit = XtVaCreateManagedWidget("Exit",
    xmPushButtonWidgetClass, form,
    XmNbottomAttachment, XmATTACH_FORM,
    XmNtopAttachment, XmATTACH_WIDGET,
    XmNtopWidget, widg_ret,
    XmNleftAttachment, XmATTACH_WIDGET,
    XmNleftWidget, button_dt2,
    XmNrightAttachment, XmATTACH_FORM,
    XmNtraversalOn, False ,
    XmNrecomputeSize, False ,
    XmNinitialResourcesPersistent , False , NULL);
  XtAddCallback(button_exit,XmNactivateCallback,quit_cb,(XtPointer *)toplevel);

  XtManageChild(form);
  XtRealizeWidget(toplevel);
  XtMapWidget(toplevel);

  return (widg_ret) ;
}

/*****************************************************
 * diffusion-simulation fiber tracking 
 *****************************************************/

               // send dwi dataset and gradient info to the vtk window
void send_3dview_to_vtk_vector_window( Three_D_View *threeDview, 
  THD_3dim_dataset *dwi, DIF_state *difState )
{
  im3d = threeDview;
  dwi_dset = dwi;
  current_dif_state = difState;
}

               // filter datasets for DST fiber tracking
#define USEFUL_DIFF_DSET(ds)                                  \
    (( ISVALID_DSET(ds)                      )             && \
     ( DSET_INMEMORY(ds)                     )             && \
     ( DSET_BRICK_TYPE(ds,0) == MRI_short ||                  \
       DSET_BRICK_TYPE(ds,0) == MRI_byte  ||                  \
      (DSET_BRICK_TYPE(ds,0) == MRI_complex && complex_ok) || \
      (DSET_BRICK_TYPE(ds,0) == MRI_float && float_ok)))

void DST_load_dsl( Widget w, THD_3dim_dataset *mset, int numSubBricks,
  int float_ok, int complex_ok )
{
  THD_session *session = im3d->ss_now;  // current session
  int viewtype = im3d->vinfo->view_type;
  THD_3dim_dataset *qset;
  int id, nx=0, ny=0, nz=0;

  ndsl = 0;
/*  
                   // choose fiber tract dataset, in VTK format
  if( w == dst_tract_pb )
  {
    for( id = 0; id < session->num_dsset; ++ id )
    {
      qset = session->dsset[id][viewtype];
      if( USEFUL_DIFF_DSET( qset ) ) continue;
      ndsl ++;
      dsl = (PLUGIN_dataset_link *)XtRealloc( (char*)dsl, 
        sizeof(PLUGIN_dataset_link) * ndsl );
      make_PLUGIN_dataset_link( qset, dsl + (ndsl-1) );
    }
printf("*********DST_load_dsl: session->num_dsset=%i\n",session->num_dsset);
    return;
  }
*/  
                   // retrieve dataset dimensions
  if( ISVALID_DSET( mset ) )
  {  
    nx = DSET_NX( mset ); ny = DSET_NY( mset ); nz = DSET_NZ( mset );
  }
                   // scan through all datasets
  for( id = 0; id < session->num_dsset; ++ id )
  {
    qset = session->dsset[id][viewtype];
    if( !USEFUL_DIFF_DSET( qset ) ) continue;
                   // number of sub-bricks allowed in dataset
    if( DSET_NVALS( qset ) != numSubBricks ) continue; 
                   // dimensions have to be satisfied
    if( nx > 0 && DSET_NX( qset ) != nx ) continue;
    if( ny > 0 && DSET_NY( qset ) != ny ) continue;
    if( nz > 0 && DSET_NZ( qset ) != nz ) continue;
    
    ndsl ++;
    dsl = (PLUGIN_dataset_link *)XtRealloc( (char *)dsl, 
      sizeof(PLUGIN_dataset_link)*ndsl );

    make_PLUGIN_dataset_link( qset , dsl + (ndsl-1) );  /* cf. afni_plugin.c */
  }
printf("DST_load_dsl: session->num_dsset=%i\n",session->num_dsset);
  return;
}
      
                   // used in function "scandir" to select tract dataset 
		   // in vtk format
static int DST_select_vtk( const struct dirent *dir )
{
  if( strstr( dir->d_name, FT_VTK_SUFFIX ) != NULL || 
      strstr( dir->d_name, FT_DT4_VTK_SUFFIX ) != NULL ) return 1;
  return 0;
}
 
                   // drop-down menu to choose tract dataset
void DST_load_vtk( Widget w )
{
  static char **strlist = NULL;
  char label[THD_MAX_NAME];
  int numVTKfiles = 0;

  numVTKfiles = scandir( "./", &dp, DST_select_vtk, alphasort );
  if( numVTKfiles < 0 ) return; // error occurs

  POPDOWN_strlist_chooser;
  strlist = (char **)XtRealloc( (char*)strlist, numVTKfiles * sizeof(char*) );
  for( int i = 0; i < numVTKfiles; ++ i )
    strlist[i] = dp[i]->d_name;

  sprintf( label, "Fiber tract dataset in VTK format" );
  MCW_choose_strlist( w, label, numVTKfiles, 0, strlist, 
    reinterpret_cast<void (*)()>(DST_tract_dset_CB), NULL );

  return;
}

                   // Callback function for choosing dataset.
void DST_choose_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
  static char **strlist = NULL; 
//  THD_3dim_dataset *qset;
  char label[THD_MAX_NAME];
  int id, ltop, llen;

                   // choose tract dataset in VTK format
  if( w == dst_tract_pb )
  {
    DST_load_vtk( w );
    return;
  }
                   // choose 4th-order DT dataset
  if( w == dt4_dset_pb ) 
//    DST_load_dsl( w, func_dset, 16, 1, 0 );
    DST_load_dsl( w, func_dset, 22, 1, 0 );
                   // chooose dataset in AFNI format with only one sub-brick
  if( w == dst_seeds_pb || w == dst_ftTarget_pb || w == dt4_seeds_pb )
    DST_load_dsl( w, func_dset, 1, 1, 0 );

  if( ndsl < 1 )
  {
    (void) MCW_popup_message( w, "Didn't find\nany datasets\nto load!",
      MCW_USER_KILL | MCW_TIMER_KILL ) ;
    XBell(im3d->dc->display,100) ; return ;
  }
//  if( id = 0; id < ndsl; ++id )
//    qset = PLUTO_find_dset( &(dsl[id].idcode) );
                   // make a popup chooser for the user to browse
  POPDOWN_strlist_chooser;
  strlist = (char **)XtRealloc( (char*)strlist, sizeof(char*) * ndsl );
  for( id=0 ; id < ndsl ; ++id ) 
    strlist[id] = dsl[id].title ;

  sprintf( label, "AFNI Dataset from\nthe %s", 
    VIEW_typestr[im3d->vinfo->view_type] );  
                   // choose dataset from list
  MCW_choose_strlist( w, label, ndsl, 0, strlist, 
      reinterpret_cast<void (*)()>(DST_dataset_CB), NULL );

  return;
}
               // load the selected DST dataset
void DST_dataset_CB( Widget w, XtPointer ft, MCW_choose_cbs *cbs )
{
  THD_3dim_dataset *qset;
  int id = cbs->ival;

  qset = PLUTO_find_dset( &(dsl[id].idcode) );
  if( qset == NULL ){ XBell( im3d->dc->display, 100 ); return; }
               // seeds dataset
  if( w == dst_seeds_pb || w == dt4_seeds_pb )
  {
    seeds_dset = qset;
    DSET_load( seeds_dset );
                   // retrieve the file name for seeds dataset
    strcpy( seeds_dset_prefix, DSET_PREFIX( seeds_dset ) );
printf(">> choose seeds dataset: done --> %s\n", seeds_dset_prefix);  
  }
               // fiber target zone dataset
  if( w == dst_ftTarget_pb )
  {
    ftTarget_dset = qset;
    DSET_load( ftTarget_dset );
printf(">> choose fiber target zone dataset: done --> %s\n", 
DSET_PREFIX( ftTarget_dset ));  
  }
               // 4th-order DT dataset
  if( w == dt4_dset_pb )
  {
    dt4_dset = qset;
    DSET_load( dt4_dset );
printf(">> choose 4th-order DT dataset: done --> %s\n",DSET_PREFIX(dt4_dset));  
  }

  return;
}

                   // choose the fiber tract dataset
void DST_tract_dset_CB( Widget w, XtPointer fd, MCW_choose_cbs *cbs )
{
  int id = cbs->ival;

  tract_dset_name = dp[id]->d_name; 
printf( ">> choose fiber tract dataset: done --> %s\n", tract_dset_name );   
  return;
}

                   // callback function for compute button
void DST_compute_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
  char *prog_name = "DST_compute_CB";

  if( seeds_dset == NULL ) 
  {
    (void) MCW_popup_message( w, "\n** No seeds dataset chosen! **\n",
      MCW_USER_KILL | MCW_TIMER_KILL ) ;
    PLUTO_beep(); return;
  }
               // select the right dataset for 'compute' button
  THD_3dim_dataset *dti_dset = NULL; 
  bool useOrigDset; 
  if( state.dst_isotropicVoxel == false ) 
  {
    dti_dset = func_dset;
    useOrigDset = true;
  }  
  else if( dti_isovox_dset == NULL )
  {
    (void) MCW_popup_message( w, "\n** dataset not resampled yet! **\n",
      MCW_USER_KILL | MCW_TIMER_KILL ) ;
    PLUTO_beep(); return;
  }
  else
  {
    dti_dset = dti_isovox_dset;
    useOrigDset = false;
  }
               // Retrieve dimensions 
  int nvox = DSET_NVOX(dti_dset);
  int dims[3];
  float voxSize[3];

  dims[0] = DSET_NX(dti_dset);
  dims[1] = DSET_NY(dti_dset);
  dims[2] = DSET_NZ(dti_dset);
  voxSize[0] = DSET_DX(dti_dset);
  voxSize[1] = DSET_DY(dti_dset);
  voxSize[2] = DSET_DZ(dti_dset);

                   // retrieve tensor components from dti_dset
  int tensorOffset = 0;
                   // pointer to the initial address for each of the six 
		   // tensor components
  float *tensor[6]; 
  for( int i = 0; i < 6; ++ i )
    tensor[i] = (float *)DSET_ARRAY( dti_dset, tensorOffset+i );

                   // retrieve FA, MD, principal eigenvector
  float *fa, *md, *eigvec[3];	
  int eigvecOffset, faOffset, mdOffset;

  if( useOrigDset )
  {
    eigvecOffset = 9; faOffset = 18; mdOffset = 19;
  }
  else
  {
    eigvecOffset = 6; faOffset = 9; mdOffset = 10;
  }
  fa = (float *)DSET_ARRAY( dti_dset, faOffset );
  md = (float *)DSET_ARRAY( dti_dset, mdOffset );
  eigvec[0] = (float *)DSET_ARRAY( dti_dset, eigvecOffset );
  eigvec[1] = (float *)DSET_ARRAY( dti_dset, eigvecOffset + 1 );
  eigvec[2] = (float *)DSET_ARRAY( dti_dset, eigvecOffset + 2 );

                   // retrieve seeds points
  int **seedsXYZ, nnzero;
  if( useOrigDset )
    seedsXYZ = DST_maskXYZ( &nnzero, seeds_dset, nvox );
  else  
    seedsXYZ = DST_resampledMaskXYZ( &nnzero, seeds_dset, nvox );
  if( nnzero == 0 )
  {
    fprintf( stderr, "*** Error: there are no seeds from %s!\n"
      "Returning from %s\n", DSET_FILECODE(seeds_dset),prog_name);
    return;
  }  
                   // retrieve target zone points if selected 
  int **ftTargetXYZ, nnzero_ftTarget = 0;
  if( ftTarget_dset != NULL )
  {
    if( useOrigDset )
      ftTargetXYZ = DST_maskXYZ( &nnzero_ftTarget, ftTarget_dset, nvox );
    else  
      ftTargetXYZ = DST_resampledMaskXYZ( &nnzero_ftTarget, ftTarget_dset, 
        nvox );
  }  
                   // retrieve the b0 image in dwi dataset
  float *b0_float = NULL;
  int b0_type;
  if( useOrigDset )
  {
    b0_type = DSET_BRICK_TYPE( dwi_dset, 0 );
    b0_float = DST_b0_image( b0_type, dwi_dset, nvox );
  }
  else
  {
    b0_type = DSET_BRICK_TYPE( b0_isovox_dset, 0 );
    b0_float = DST_b0_image( b0_type, b0_isovox_dset, nvox );
  }

                   // retrieve tracking thresholds     
  float threshold[7];
  threshold[0] = state.dstFA;
  threshold[1] = state.dstDistRatio;
  threshold[2] = state.dstCurv;
  threshold[3] = state.dstCoher;
  threshold[4] = state.dstIntegTime;
  threshold[5] = state.dst_b0_bound[0];
  threshold[6] = state.dst_b0_bound[1];

                   // do fiber tracking with starting seeds from drawing area
printf(">> start DST compute with %d seeds\n", nnzero );
printf(">> DST thresholds: FA=%.2f dist-ratio=%.2f curv=%.0f coher=%.0f\n \
  integ-time=%.4f b0_lo=%g b0_hi=%g\n",
  threshold[0],threshold[1],threshold[2],threshold[3],threshold[4], 
  threshold[5],threshold[6]);

                   // fiber tracking starts here
  Args_Table_ dstArgs = diffsimFT_interface( nvox, dims, voxSize, 
    tensor, fa, md, eigvec, threshold, b0_float, nnzero, 
    seedsXYZ, seeds_dset_prefix, nnzero_ftTarget, ftTargetXYZ );
  if( NULL == dstArgs ) return;

                   // done with seeds
  for( int i = 0; i < 3; ++ i )
    free( seedsXYZ[i] );
  free( seedsXYZ );  
                   // done with target zone points
  if( nnzero_ftTarget != 0 )
  {
    for( int i = 0; i < 3; ++ i )
      free( ftTargetXYZ[i] );
    free( ftTargetXYZ ); 
  }
  if( ftTarget_dset != NULL )
  { 
    DSET_unload( ftTarget_dset );
    ftTarget_dset = NULL;
  }
                   // done with the b0 image
  switch( b0_type )
  {
    case MRI_float:
      break;
    case MRI_short:
    case MRI_int:
    default:
      free( b0_float );
      break;
  }    

printf(">> DST compute: done --> '%s' generated\n", dstArgs->tractFileName );
  free( dstArgs );
  return;
}
 
                   // retrieve b0 image from dwi dataset
float *DST_b0_image( int b0_type, THD_3dim_dataset *dwi_dset, int nvox )
{
  float *b0_float = NULL;
  short *b0_short = NULL;
  int *b0_int = NULL;
  int i;

  switch( b0_type )
  {
    case MRI_short:
    {
      b0_short = (short *)DSET_ARRAY( dwi_dset, 0 );
      b0_float = (float *)malloc( nvox*sizeof( float ) );
      for( i = 0; i < nvox; ++ i ) b0_float[i] = b0_short[i];
    }
      break;
    case MRI_int:
    {
      b0_int = (int *)DSET_ARRAY( dwi_dset, 0 );
      b0_float = (float *)malloc( nvox*sizeof( float ) );
      for( i = 0; i < nvox; ++ i ) b0_float[i] = b0_int[i];
    }
      break;
    case MRI_float:
      b0_float = (float *)DSET_ARRAY( dwi_dset, 0 );
      break;
    default:
    {
      b0_float = (float *)malloc( nvox*sizeof( float ) );
      for( i = 0; i < nvox; ++ i ) b0_float[i] = 0;
      fprintf( stderr, "** b0 image: dataset type not supported yet." 
               "Instead, a b0 image with all zero values will be used.\n" );
    }	       
      break;
  }
  return b0_float;
}

int **DST_resampledMaskXYZ( int *nnzero, THD_3dim_dataset *seeds_dset, int nvox)
{
  string dti_isovox_name = DSET_PREFIX( dti_isovox_dset );
  dti_isovox_name = DST_DATA_DIR + dti_isovox_name + ORIG;
  string seeds_name = DSET_PREFIX( seeds_dset );
               // size of the isotropic voxel
  float voxSize = state.dst_voxelSize; 
  ostringstream oss_isoVoxel;
  oss_isoVoxel << ISO_VOXEL << voxSize;

  string seeds_isovox_name = DST_DATA_DIR + seeds_name 
    + oss_isoVoxel.str() + ORIG;
  seeds_name += ORIG;
  THD_3dim_dataset *seeds_isovox_dset = NULL;
  
               // check to see if seeds dataset is already resampled
  if( (seeds_isovox_dset = THD_open_dataset( 
    const_cast<char*>( seeds_isovox_name.c_str() ) )) != NULL )
  {
    DSET_load( seeds_isovox_dset );
cout <<">> DST load resampled mask: done" <<endl; 
    return DST_maskXYZ( nnzero, seeds_isovox_dset, nvox );
  }  
               // resample mask
  ostringstream sysCommand;
  sysCommand << "3dfractionize -template " << dti_isovox_name.c_str()
    << " -input " << seeds_name.c_str()
    << " -prefix " << seeds_isovox_name.c_str()
    << " -preserve -clip 0.2" << endl;
cout << ">> resample mask dataset:\n"<< sysCommand.str();
  if( system( sysCommand.str().c_str() ) )
  {
    cout << "** Something is wrong with using 3dfractionize" << endl; 
    *nnzero = 0;
    return NULL;
  }

  seeds_isovox_dset = THD_open_dataset( 
    const_cast<char*>( seeds_isovox_name.c_str() ) );
  DSET_load( seeds_isovox_dset );
cout <<">> DST load resampled mask: done" <<endl; 

  return DST_maskXYZ( nnzero, seeds_isovox_dset, nvox );
}

                   // create a byte mask to retrieve coordinates of seeds
int **DST_maskXYZ( int *nnzero, THD_3dim_dataset *seeds_dset, int nvox )
{
  int type, volumeOffset = 0;
  float thresh;  
  byte *mask = NULL;

  type = DSET_BRICK_TYPE( seeds_dset, volumeOffset );
  switch( type )
  {
    case MRI_short:
      thresh = 0;
      break;
    case MRI_float:
      thresh = 1;
      break;
    default:
    {
      cout << "** " << DSET_PREFIX( seeds_dset ) 
        << ": dataset type not supported yet." << endl;
      *nnzero = 0;
      return NULL;
    }
  }

  *nnzero = thd_mask_from_brick( seeds_dset, volumeOffset, thresh, &mask, 1 );
                   // retrieve coordinates of the seeds
/*
      short *seeds = (short *)DSET_ARRAY( seeds_dset, 0 );
      int nnz = 0;
      for( int i = 0; i < nvox; ++ i )
      if( 0 != seeds[i] ) nnz ++; cout<<"*******nnzero= "<< nnz<<endl;
*/
  if( *nnzero == 0 )
    return NULL;

  int **seedsXYZ, cnt;
  seedsXYZ = (int **)malloc( 3 * sizeof(int*) );
  for( int i = 0; i < 3; ++ i )
    seedsXYZ[i] = (int *)malloc( *nnzero * sizeof(int) );

  cnt = 0;	
  for( int i = 0; i < nvox; ++ i )
  if( mask[i] ) 
  {/*
//        seedsXYZ[0][cnt] = DSET_index_to_ix( seeds_dset, i );
    seedsXYZ[0][cnt] = dims[0]-1 - DSET_index_to_ix( seeds_dset, i );
    seedsXYZ[1][cnt] = DSET_index_to_jy( seeds_dset, i );
    seedsXYZ[2][cnt] = dims[2]-1 - DSET_index_to_kz( seeds_dset, i );
//        seedsXYZ[2][cnt] = DSET_index_to_kz( seeds_dset, i );
*/
    // shark
    seedsXYZ[0][cnt] = DSET_index_to_ix( seeds_dset, i );
    seedsXYZ[1][cnt] = DSET_index_to_jy( seeds_dset, i );
    seedsXYZ[2][cnt] = DSET_index_to_kz( seeds_dset, i );
    cnt ++;
  }
                   // done with the mask
  if( mask) free( mask );
  return seedsXYZ;
}

                   // callback function for view button
void DST_view_cb( Widget w, XtPointer client_data, XtPointer call_data )
{
  if( tract_dset_name == NULL )
  {
    (void) MCW_popup_message( w, "\n** No fiber tract dataset chosen! **\n",
      MCW_USER_KILL | MCW_TIMER_KILL ) ;
    PLUTO_beep(); return;
  }
cout<<">> start to visualize DST reconstructed fibers"<<endl;

  double *p;
  float xorg, yorg, zorg;
//  xorg = DSET_XORG( func_dset );
//  yorg = DSET_YORG( func_dset );
//  zorg = (DSET_NZ(func_dset)-1) * DSET_DZ(func_dset) + DSET_ZORG( func_dset );
  
  //shark
//  xorg = (DSET_NX(func_dset)-1) * DSET_DX(func_dset) + DSET_XORG( func_dset );
  xorg = DSET_XORG( func_dset );
  yorg = DSET_YORG( func_dset );
  zorg = DSET_ZORG( func_dset );

//  dstTubeActor = new vtkActor* [dstArgs->numTractFiles];
                   // read fiber tracking data
  vtkPolyDataReader *dstReader = vtkPolyDataReader::New();
  dstReader->SetFileName( tract_dset_name ); 
  dstReader->Update();
  dstReader_stack.push( dstReader );
printf(">> read dataset file: done --> %s\n", tract_dset_name );  
                   // tract data coordinates tranformation to get consistent 
		   // with the underlay images
  vtkPolyData *dstData = dstReader->GetOutput();
  vtkPoints *points = dstData->GetPoints();
  int numPoints = points->GetNumberOfPoints();
  for( int i = 0; i < numPoints; ++i )
  {
    p = points->GetPoint( i );    
/*    p[0] += xorg;
    p[1] += yorg;
          // p2 = (NZ - p2/DZ - 1)*DZ + ZORG
    p[2] = zorg - p[2];
*/
    p[0] += xorg;// - p[0];
    p[1] += yorg;
    p[2] += zorg;
    points->SetPoint( i, p );
  }
               // specify the scale for streamtube radius
  float dx, dy, dz; 
  dx = (float)fabs( DSET_DX(func_dset) );
  dy = (float)fabs( DSET_DY(func_dset) );
  dz = (float)fabs( DSET_DZ(func_dset) );
  float voxSize;  // the smallest size among dx, dy, dz
  voxSize = ( dx < dy ) ? dx : dy;
  voxSize = ( voxSize < dz ) ? voxSize : dz;
  float tubeRadius_scale = 1; // 1 for human brain
               // for rat & shark
  if( voxSize < 0.5 ) tubeRadius_scale = 0.1;

                   // tube filter
  vtkPolyDataMapper *dstTubeMapper = vtkPolyDataMapper::New();
  if( state.dst_drawStreamtube == true )
  {
    vtkTubeFilter *tubeFilter = vtkTubeFilter::New();
    tubeFilter->SetInput( dstReader->GetOutput() );
    tubeFilter->SetRadius( state.dst_tubeRadius * tubeRadius_scale );
    tubeFilter->SetNumberOfSides( 12 );
    tubeFilter->CappingOn();
    tubeFilter->UseDefaultNormalOn();
    dstTubeFilter_stack.push( tubeFilter );
    dstTubeMapper->SetInput( tubeFilter->GetOutput() );
  }
  else
  {
    dstTubeFilter_stack.push( NULL );
    dstTubeMapper->SetInput( dstReader->GetOutput() );
  }  
                   // color lookup table for DST fibers
  if( dst_lut == NULL )
  {
    dst_lut = vtkLookupTable::New();
    dst_lut->SetHueRange(0.6667,0); // blue to red
    dst_lut->SetValueRange(1,1);
    dst_lut->SetSaturationRange(1,1);
    dst_lut->SetAlphaRange(1,1);
    dst_lut->SetNumberOfColors( 256 );
    dst_lut->Build();
  }
  dstTubeMapper->SetLookupTable( dst_lut );
  dstTubeMapper->SetScalarRange( dstData->GetScalarRange() );
  dstTubeMapper_stack.push( dstTubeMapper );

  vtkActor *dstTubeActor = vtkActor::New();
  dstTubeActor->SetMapper( dstTubeMapper );
  dstTubeActor->GetProperty()->SetColor(1,1,0);
  dstTubeActor_stack.push( dstTubeActor );
 
  renv->AddActor( dstTubeActor );
  renvWin->Render();

  fprintf( stderr, ">> visualize fibers: done...\n" );
  fflush( stdout );
  return;
}

                   // callback function for clear button
void DST_clear_cb( Widget w, XtPointer client_data, XtPointer call_data )
{
  vtkActor *dstTubeActor;
  vtkPolyDataReader *dstReader;
  vtkPolyDataMapper *dstTubeMapper;
  vtkTubeFilter *dstTubeFilter;

  if( !dstTubeActor_stack.empty() )
  {
    dstTubeActor = dstTubeActor_stack.top();
    dstTubeActor_stack.pop();
    dstReader = dstReader_stack.top();
    dstReader_stack.pop();
    dstTubeMapper = dstTubeMapper_stack.top();
    dstTubeMapper_stack.pop();
    dstTubeFilter = dstTubeFilter_stack.top();
    dstTubeFilter_stack.pop();

    if( dstTubeActor != NULL )
    {
      renv->RemoveActor( dstTubeActor );
      dstTubeActor->Delete();
      dstReader->Delete();
      dstTubeMapper->Delete();
      if( dstTubeFilter != NULL ) dstTubeFilter->Delete();
      renvWin->Render();
cout<<">> clear fiber tract from viewer: done"<<endl;  
    }
  }
  return;
}

void DST_fa_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
  state.dstFA = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
    pow(10, UIState::DST_THRESHOLD_DECIMAL_POINTS);
  return;
}

void DST_distRatio_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
  state.dstDistRatio = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
    pow(10, UIState::DST_THRESHOLD_DECIMAL_POINTS);
  return;
}

void DST_curv_CB( Widget w, XtPointer client_data, XtPointer call_data)
{
  state.dstCurv = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position;
//    /pow(10, UIState::DST_THRESHOLD_DECIMAL_POINTS);
  return;
}

void DST_coher_CB( Widget w, XtPointer client_data, XtPointer call_data)
{
  state.dstCoher = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position;
//    /pow(10, UIState::DST_THRESHOLD_DECIMAL_POINTS);
  return;
}

void DST_integTime_CB( Widget w, XtPointer client_data, XtPointer call_data)
{
  state.dstIntegTime = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
    pow(10, UIState::DST_THRESHOLD_DECIMAL_POINTS_TIME);
  return;
}

void DST_stats_CB( Widget w, XtPointer client_data, XtPointer call_data)
{
  if( tract_dset_name == NULL )
  {
    (void) MCW_popup_message( w, "\n** No fiber tract dataset chosen! **\n",
      MCW_USER_KILL | MCW_TIMER_KILL ) ;
    PLUTO_beep(); return;
  }

  string statsFile = tract_dset_name;
  size_t found, found_dt4;
                   // retrieve file name for tract stats 
  found = statsFile.rfind( FT_VTK_SUFFIX );
  found_dt4 = statsFile.rfind( FT_DT4_VTK_SUFFIX );
  if( found != string::npos )
    statsFile.replace( found, 10, FT_STATS_SUFFIX );
  else if( found_dt4 != string::npos )
    statsFile.replace( found_dt4, 13, FT_DT4_STATS_SUFFIX );
  else  
  {
    (void) MCW_popup_message( w, "\n** No fiber tract dataset chosen! **\n",
      MCW_USER_KILL | MCW_TIMER_KILL ) ;
    PLUTO_beep(); return;
  }
                   // open the tract stats file
  ifstream fin;
  fin.open( statsFile.c_str() );
  if( !fin )
  {
    (void) MCW_popup_message( w, "\n** Cannot open tract stats file! **\n",
      MCW_USER_KILL | MCW_TIMER_KILL ) ;
    PLUTO_beep(); return;
  }
printf(">> read tract stats file: done --> %s\n", statsFile.c_str() );  
                   // read stats from file
  char aLine[60];
  string stats;
  while( !fin.eof() )
  {
    fin.getline( aLine, 50 );
    stats = stats + aLine + "\n";
  }
  fin.close();
                   // pop up the stats window
  (void)new_MCW_textwin( integTime_row, const_cast<char*>(stats.c_str()), 
    TEXT_READONLY );
  return;
}

void DST_b0_changed_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
   int i;
   for( i = 0; i < 2; ++i )
      if( w == state.dst_b0_slider[i] ) break;
   if( i == 2 ) abort();

   state.dst_b0_bound[i] = 
      reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value;

   sprintf( state.dst_b0_sliderText[i], "%d", state.dst_b0_bound[i] );
}

void DST_tubeToggle_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
  char wState = 
    reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

  switch(wState)
  {
    case XmSET:
      state.dst_drawStreamtube = true;
      break;
    case XmUNSET:
      state.dst_drawStreamtube = false;
      break;
  }
  return;
}

void DST_tubeRadius_changed_CB( Widget w, XtPointer client_data, XtPointer 
  call_data )
{
  state.dst_tubeRadius = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
    pow(10, UIState::RADIUS_DECIMAL_POINTS);
  return;  
}

void DST_colorbarToggle_CB( Widget w, XtPointer client_data, XtPointer 
  call_data )
{
  bool dst_showColorbar;
  char wState = 
    reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

  switch(wState)
  {
    case XmSET:
      dst_showColorbar = true;
      break;
    case XmUNSET:
      dst_showColorbar = false;
      break;
  }

  if( dst_showColorbar ) 
  {
    if( !dstTubeActor_stack.empty() )
    {
      dst_colorbar = vtkScalarBarActor::New();
      dst_colorbar->SetLookupTable( dst_lut );
      dst_colorbar->GetPositionCoordinate()->
        SetCoordinateSystemToNormalizedViewport();
      dst_colorbar->GetPositionCoordinate()->SetValue( 0.2,0.05 );
      dst_colorbar->SetOrientationToHorizontal();
      dst_colorbar->SetWidth(0.7);
      dst_colorbar->SetHeight(0.1);
//      dst_colorbar->SetPosition(0.95, 0.1);
      dst_colorbar->SetLabelFormat("%.3f");
      renv->AddActor2D( dst_colorbar );
    }  
  }
  else 
  {
    if( dst_colorbar != NULL ) 
    {
      renv->RemoveActor( dst_colorbar );
      dst_colorbar->Delete();
      dst_colorbar = NULL;
    }
  }
  renvWin->Render();
  return;
}

void DST_isotropicVoxelToggle_CB( Widget w, XtPointer client_data, XtPointer 
  call_data )
{
  char wState = 
    reinterpret_cast<XmToggleButtonCallbackStruct*>(call_data)->set;

  switch(wState)
  {
    case XmSET:
      state.dst_isotropicVoxel = true;
      break;
    case XmUNSET:
      state.dst_isotropicVoxel = false;
      break;
  }
  return;
}

void DST_voxelSize_changed_CB( Widget w, XtPointer client_data, XtPointer 
  call_data )
{
  state.dst_voxelSize = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
    pow(10, UIState::DST_VOXEL_SIZE_DECIMAL_POINTS);
  if( dti_isovox_dset != NULL && b0_isovox_dset != NULL )
  {
    DSET_unload( dti_isovox_dset );  
    DSET_unload( b0_isovox_dset );
    dti_isovox_dset = NULL;
    b0_isovox_dset = NULL;
  }
  return;  
}

void DST_resample_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
               // resample is not enabled yet
  if( state.dst_isotropicVoxel == false ) return;
               // size of the isotropic voxel
  float voxSize = state.dst_voxelSize; 
  ostringstream oss_isoVoxel;
  oss_isoVoxel << ISO_VOXEL << voxSize;
               // create a directory to store resampled datasets 
	       // if it doesn't exist
  if( mkdir( DST_DATA_DIR, 0755 ) !=0 && errno != EEXIST )
  {
    cout << "** Fail to create directory: " << DST_DATA_DIR << endl;  
    return;
  } 
               // datasets names
  string dwi_name = DSET_PREFIX( dwi_dset );
  string dwi_isovox_name = DST_DATA_DIR + dwi_name + oss_isoVoxel.str();
  string b0_isovox_name = dwi_isovox_name + ".b0" + ORIG;
  string dti_name = DSET_PREFIX( func_dset );
  string dti_isovox_name = DST_DATA_DIR + dti_name   
    + oss_isoVoxel.str() + ORIG;
  string dti_dst_name = DST_DATA_DIR + dti_name
    + oss_isoVoxel.str() + ".DST" + ORIG;

               // looking for resampled datasets in the directory
	       // to see if they are already there
  if( (b0_isovox_dset = THD_open_dataset( 
    const_cast<char*>( b0_isovox_name.c_str() ) )) != NULL &&
    (dti_isovox_dset = THD_open_dataset( 
    const_cast<char*>( dti_dst_name.c_str() ) )) != NULL )
  {
    DSET_load( b0_isovox_dset );
    DSET_load( dti_isovox_dset ); 
    cout <<">> DST load resampled datasets: done" <<endl; 
    return;
  }
               // start to do resampling ============
               // resample the dwi dataset
  ostringstream sysCommand;
  string dwi_name_orig = dwi_name + ORIG;
  sysCommand << "3dresample -rmode Cu -dxyz " 
    << voxSize << " " << voxSize << " " << voxSize 
    << " -prefix " << dwi_isovox_name.c_str() 
    << " -inset " << dwi_name_orig.c_str() << endl;
cout << ">> resample DWI:\n"<< sysCommand.str();
  if( system( sysCommand.str().c_str() ) )
  {
    cout << "** Something went wrong with 3dresample" << endl; return;
  }

               // extract b0 image from resampled dwi dataset
  sysCommand.clear(); sysCommand.str("");
  string dwi_isovox_name_orig0 = dwi_isovox_name + "+orig[0]";
  sysCommand << "3dcalc -a '" << dwi_isovox_name_orig0.c_str() 
    << "' -expr a -prefix " << b0_isovox_name.c_str() << endl;
cout <<">> extract b0:\n"<< sysCommand.str();
  if( system( sysCommand.str().c_str() ) )
  {
    cout << "** Something went wrong with 3dcalc" << endl; return;
  }

               // generate dti dataset ===============
  sysCommand.clear(); sysCommand.str("");
               // make a temporary file to hold the gradient info
  string tensorfile = DST_DATA_DIR; tensorfile += "tensorinfo";
  ofstream fout;
  fout.open( tensorfile.c_str() );
  if( !fout )
  {
    cout << "** Cannot creat temporary file: tensorinfo" << endl; return;
  } 
  int nvert = current_dif_state->img->dgrad->nvert;
  for( int i = 0; i < nvert; ++ i )
    fout << current_dif_state->img->GX[i] << " " 
         << current_dif_state->img->GY[i] << " "
	 << current_dif_state->img->GZ[i] << endl;
  fout.close();
               // the command
  string dwi_isovox_name_orig = dwi_isovox_name + ORIG; 
  sysCommand << "3dDWItoDT -automask -eigs -prefix " 
    << dti_isovox_name.c_str()
    << " " << tensorfile.c_str() << " " << dwi_isovox_name_orig.c_str() 
    << endl;
cout <<">> generate DTI:\n"<< sysCommand.str();
  if( system( sysCommand.str().c_str() ) )
  {
    cout << "** Something went wrong with 3dDWItoDT" << endl; return;
  }

               // extract necessary bricks from dti dataset
  sysCommand.clear(); sysCommand.str("");
  string dti_bricks_name = dti_isovox_name + "[0,1,2,3,4,5,9,10,11,18,19]";
  sysCommand << "3dcalc -a '" << dti_bricks_name.c_str() 
    << "' -expr a -prefix " << dti_dst_name.c_str() << endl;
cout <<">> extract essential DTI bricks:\n"<< sysCommand.str();    
  if( system( sysCommand.str().c_str() ) )
  {
    cout << "** Something went wrong with 3dcalc" << endl; return;
  }
cout <<">> DST Resample: done" <<endl; 

	       // load the resampled datasets
  b0_isovox_dset = THD_open_dataset( 
    const_cast<char*>( b0_isovox_name.c_str() ) );
  dti_isovox_dset = THD_open_dataset( 
    const_cast<char*>( dti_dst_name.c_str() ) );
  DSET_load( b0_isovox_dset );
  DSET_load( dti_isovox_dset ); 
cout <<">> DST load resampled datasets: done" <<endl; 
  return;
}
               // GFA threshold for 4th-DT
void DST_dt4_gfa_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
  state.dst_dt4_GFA = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
    pow(10, UIState::DST_THRESHOLD_DECIMAL_POINTS);
  return;
}
               // Distance Ratio threshold for 4th-DT
void DST_dt4_distRatio_CB(Widget w, XtPointer client_data, XtPointer 
  call_data)
{
  state.dst_dt4_distRatio = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
    pow(10, UIState::DST_THRESHOLD_DECIMAL_POINTS);
  return;
}
               // transition angle threshold for 4th-DT
void DST_dt4_transAngle_CB( Widget w, XtPointer client_data, XtPointer 
  call_data )
{
  state.dst_dt4_transAngle = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position;
//    /pow(10, UIState::DST_THRESHOLD_DECIMAL_POINTS);
  return;
}
               // integration time for 4th-DT
void DST_dt4_integTime_CB( Widget w, XtPointer client_data, XtPointer 
  call_data)
{
  state.dst_dt4_integTime = 
    reinterpret_cast<XmSpinBoxCallbackStruct*>(call_data)->position/
    pow(10, UIState::DST_THRESHOLD_DECIMAL_POINTS_TIME);
  return;
}

void DST_dt4_compute_CB( Widget w, XtPointer client_data, XtPointer 
  call_data )
{
  char *prog_name = "DST_dt4_compute_CB";

  if( dt4_dset == NULL ) 
  {
    (void) MCW_popup_message( w, "\n** No 4th-order DT dataset chosen! **\n",
      MCW_USER_KILL | MCW_TIMER_KILL ) ;
    PLUTO_beep(); return;
  }

  if( seeds_dset == NULL ) 
  {
    (void) MCW_popup_message( w, "\n** No seeds dataset chosen! **\n",
      MCW_USER_KILL | MCW_TIMER_KILL ) ;
    PLUTO_beep(); return;
  }
               // 2nd-order DT
  THD_3dim_dataset *dti_dset = func_dset; 
               // Retrieve dimensions from 2nd-order DT
  int nvox = DSET_NVOX(dti_dset);
  int dims[3];
  float voxSize[3];
  dims[0] = DSET_NX(dti_dset);
  dims[1] = DSET_NY(dti_dset);
  dims[2] = DSET_NZ(dti_dset);
  voxSize[0] = DSET_DX(dti_dset);
  voxSize[1] = DSET_DY(dti_dset);
  voxSize[2] = DSET_DZ(dti_dset);
               // retrieve dimensions from 4th-order DT
  int dt4_dims[3];
  dt4_dims[0] = DSET_NX( dt4_dset );
  dt4_dims[1] = DSET_NY( dt4_dset );
  dt4_dims[2] = DSET_NZ( dt4_dset );
               // Check if the dimensions of 2nd-DT and 4th-DT match.
	       // Also need to check with seeds dataset. Not done yet.
  for( int i = 0; i < 3; ++ i )
  if( dims[i] != dt4_dims[i] )
  {
    (void) MCW_popup_message( w, "\n** Dataset dimensions not matched! **\n",
      MCW_USER_KILL | MCW_TIMER_KILL ) ;
    PLUTO_beep(); return;
  }
                   // retrieve 2nd-order tensor components from dti_dset
//  int tensorOffset = 0;
  int tensorOffset = 16; // retrieve 2nd-order tensor from dt4th_dset
                   // pointer to the initial address for each of the six 
		   // tensor components
  float *tensor[6]; 
  for( int i = 0; i < 6; ++ i )
//    tensor[i] = (float *)DSET_ARRAY( dti_dset, tensorOffset+i );
    tensor[i] = (float *)DSET_ARRAY( dt4_dset, tensorOffset+i );

               // retrieve tensor components from dt4_dset
  int tensor4thOffset = 0;
  float *tensor4th[15];
  for( int i = 0; i < 15; ++ i )
    tensor4th[i] = (float *)DSET_ARRAY( dt4_dset, tensor4thOffset+i );
               // retrieve GFA from dt4_dset
  float *gfa;	
  int gfaOffset = 15;
  gfa = (float *)DSET_ARRAY( dt4_dset, gfaOffset );
//  gfa = (float *)DSET_ARRAY( dti_dset, 18 );

                   // retrieve seeds points
  int **seedsXYZ, nnzero;
  seedsXYZ = DST_maskXYZ( &nnzero, seeds_dset, nvox );
  if( nnzero == 0 )
  {
    fprintf( stderr, "*** Error: there are no seeds from %s!\n"
      "Returning from %s\n", DSET_FILECODE(seeds_dset),prog_name);
    return;
  }  
                   // retrieve tracking thresholds     
  float threshold[4];
  threshold[0] = state.dst_dt4_GFA;
  threshold[1] = state.dst_dt4_distRatio;
  threshold[2] = state.dst_dt4_transAngle;
  threshold[3] = state.dst_dt4_integTime;

                   // do fiber tracking with starting seeds from drawing area
printf(">> start DST compute with 4th-order DT on %d seeds\n", nnzero );
printf(">> DST DT-4th thresholds: GFA=%.2f dist-ratio=%.2f transAngle=%.0f \
integ-time=%.4f\n",
  threshold[0],threshold[1],threshold[2], threshold[3] );

                   // fiber tracking starts here
  Args_Table_ dstArgs = diffsimFT_DT4_interface( nvox, dims, voxSize, 
    tensor, tensor4th, gfa, threshold, nnzero, seedsXYZ, seeds_dset_prefix );
  if( NULL == dstArgs ) return;

                   // done with seeds
  for( int i = 0; i < 3; ++ i )
    free( seedsXYZ[i] );
  free( seedsXYZ );  

printf(">> DST DT4 compute: done --> '%s' generated\n", 
  dstArgs->tractFileName );
  free( dstArgs );
  return;
}

void DST_help_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
  (void)new_MCW_textwin( help_row, 
    "+++++++++++++++++++++  DST Fiber Tract Mapping  +++++++++++++++++++++\n"
    "\n"
    "This subpanel is used to map white matter fiber tracts by the\n"
    "technique of diffusion simulation-based fiber tractography (DST).\n"
    "\n"
    "Steps to generate fiber tracts:\n"
    "\n"
    " 1. If there is no seeds dataset available, go to AFNI's plug-ins\n" 
    "    window and choose 'Draw Dataset' to create one. The dataset used\n"
    "    to be drawn on should be in either float or short type. The seeds\n"
    "    dataset is loaded in to specify starting region for DST tracking.\n"
    "    Otherwise, go to step 2.\n"
    " 2. Click 'Choose Seeds'. Select a seeds dataset for fiber\n"
    "    tract mapping from the drop-down menu. Click 'Set'.\n"
    " 3. Click 'Choose Target Zone'. Select a target-zone dataset\n"
    "    from the drop-down menu. Click 'Set'. This step is optional.\n"
    " 4. Specify fiber tracking thresholds.\n"
    "    4.1 FA: fractional anisotropy index.\n"
    "    4.2 Dist Ratio: distance ratio.\n"
    "        It is a measure of distance from the current seed to a\n"
    "        node on its diffusion front compared to the longest\n"
    "        distance between the seed and its front.\n"
    "    4.3 Curv: angle for curvature constraint (0~90 degree).\n"
    "        It is used to restrain the angle between the reconstructed\n" 
    "        trajectory and the current direction of tracking.\n"
    "        If the angle is 0 degree, the two directions are aligned.\n"
    "    4.4 Coher: angle for local coherence constraint (0~90 degree).\n"
    "        It is used to judge the coherence of fiber directions\n"
    "        along the reconstructed trajectory passing through the\n"
    "        current seed.\n"
    "    4.5 Integ Time: integraton time for each diffusion simulation.\n"
    "        It is the time, at which a computed solution for the\n"
    "        diffusion equation is desired.\n" 
    "    4.6 b0 image intensity: specify the lower bound and upper bound\n"
    "        on b0 image to restrict the tracking in white matter area.\n"
    "        The two thresholds are optional.\n" 
    " 5. Click 'Compute'. Wait for completion. The generated tract\n" 
    "    dataset will be named after the seeds dataset plus '_ft.vtk'.\n"
    "    For example, if the file name of the seeds dataset is\n" 
    "    'ftm_seeds', the corresponding tract dataset will be named as\n"
    "    'ftm_seeds_ft.vtk'.\n" 
    " 6. It is recommended to do DST fiber tracking on datasets with\n"
    "    isotropic voxels. It can be done by toggling 'Isotropic Voxel',\n"
    "    clicking 'Resample', then following steps 1-5. In this case,\n"
    "    the seeds dataset generated by plug-in 'Draw Dataset' must be\n"
    "    in short type.\n"
    "\n"
    "Steps to view fiber tracts and the statistics:\n"
    "\n"
    " 7. If there is no tract dataset available, go to previous steps 1-5.\n" 
    " 8. Click 'Choose Tract'. Select a fiber tract dataset from the\n"
    "    drop-down menu. Click 'Set'.\n"
    " 9. Click 'View' to show fiber tracts in the visualizer.\n"
    "10. Click 'Clear' to erase fiber tracts in the visualizer.\n"
    "11. Click 'Stats' to view fiber tract statistics if step 8 is done.\n"
    "12. View fiber tracts in streamtube:\n"
    "    toggle 'Streamtube', choose 'Radius', then click 'View'.\n"
    , TEXT_READONLY );
  return;
}

void DST_controlPanel_CB( Widget w, XtPointer client_data, XtPointer call_data )
{
  MCW_DC *dc = im3d->dc;      // display context
  Widget toplevel=NULL;
  XmString xstr;

  if( dst_shell != NULL )
  {
    XtMapWidget( dst_shell );
    PLUTO_cursorize( dst_shell );
    return;
  }  

  dst_shell = XtVaAppCreateShell( "AFNI", "AFNI", 
    topLevelShellWidgetClass, dc->display,
    XmNtitle, "DST Fiber Tract Mapping",
    XmNiconName, "DST Control Panel",
    XmNdeleteResponse, XmUNMAP, //XmDESTROY,//XmDO_NOTHING,
    XmNallowShellResize, True,
    XmNmappedWhenManaged, False,
    XmNinitialResourcesPersistent, False, NULL);
  DC_yokify( dst_shell, dc );  

  if( MCW_isitmwm(dst_shell) )      // remove some MWM functions 
    XtVaSetValues( dst_shell, XmNmwmFunctions ,
    MWM_FUNC_MOVE | MWM_FUNC_CLOSE | MWM_FUNC_MINIMIZE, NULL ) ;

  Widget top_rowcol = XtVaCreateWidget( "AFNI",
    xmRowColumnWidgetClass, dst_shell,
    XmNorientation  , XmHORIZONTAL ,
    XmNpacking      , XmPACK_TIGHT ,
    XmNadjustLast   , False ,
    XmNadjustMargin , False ,
    XmNtraversalOn  , False ,
    XmNmarginWidth  , 0 ,
    XmNmarginHeight , 0 ,
    XmNinitialResourcesPersistent , False , NULL );

  Widget frame = XtVaCreateWidget( "AFNI" , 
    xmFrameWidgetClass , top_rowcol ,
    XmNshadowType , XmSHADOW_ETCHED_IN ,
    XmNshadowThickness , 5 ,
    XmNtraversalOn , False ,
    XmNinitialResourcesPersistent , False , NULL ) ;

  Widget dstCol = XtVaCreateWidget( "AFNI" , 
    xmRowColumnWidgetClass , frame ,
    XmNorientation , XmVERTICAL ,
    XmNpacking     , XmPACK_TIGHT ,
    XmNadjustLast  , False ,
    XmNadjustMargin, False ,
    XmNtraversalOn , False ,
    XmNinitialResourcesPersistent , False ,
    XmNframeChildType, XmFRAME_WORKAREA_CHILD, NULL );

  help_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dstCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "DST Fiber Tract Mapping      ", 
    XmFONTLIST_DEFAULT_TAG );
  Widget dstLabel = XtVaCreateManagedWidget( "AFNI", 
    xmLabelWidgetClass, help_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL ); 
               // help button
  (void) MCW_action_area( help_row, DST_actor, 1 );
  Widget dst_help_pb = (Widget)DST_actor[0].data;
               // DST resample frame
  Widget dst_resampleFrame = XtVaCreateManagedWidget( "AFNI",
    xmFrameWidgetClass, dstCol, NULL );
  Widget dst_resampleCol = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dst_resampleFrame,
    XmNorientation, XmVERTICAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False,
    XmNframeChildType, XmFRAME_WORKAREA_CHILD, NULL );
  Widget resample_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dst_resampleCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Iso Voxel", XmFONTLIST_DEFAULT_TAG );
  Widget dst_isotropicVoxel_button = XtVaCreateManagedWidget( "AFNI",
    xmToggleButtonWidgetClass, resample_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_isotropicVoxel_button, XmNvalueChangedCallback,
    DST_isotropicVoxelToggle_CB, (XtPointer*)toplevel );

  Widget dst_voxelSize_textbox = XtVaCreateManagedWidget( "AFNI", 
    xmSpinBoxWidgetClass, resample_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_voxelSize_textbox, XmNvalueChangedCallback,
    DST_voxelSize_changed_CB, (XtPointer*)toplevel );

  Widget dst_voxelSize_text = XtVaCreateManagedWidget( "AFNI", 
    xmTextWidgetClass, dst_voxelSize_textbox,
    XmNcolumns, 3,
    XmNeditable, False,
    XmNspinBoxChildType, XmNUMERIC,
    XmNminimumValue, state.DST_VOXEL_SIZE_MIN,
    XmNmaximumValue, state.DST_VOXEL_SIZE_MAX,
    XmNposition, state.DST_VOXEL_SIZE_DEFAULT,
    XmNdecimalPoints, state.DST_VOXEL_SIZE_DECIMAL_POINTS,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Size" , XmFONTLIST_DEFAULT_TAG );
  Widget voxelSizeLabel = XtVaCreateManagedWidget( "AFNI", 
    xmLabelWidgetClass, resample_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );

  xstr = XmStringCreateLtoR( "Resample", XmFONTLIST_DEFAULT_TAG );
  Widget dst_resample_button = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, resample_row,
    XmNpacking, XmPACK_TIGHT,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_resample_button, XmNactivateCallback, 
    DST_resample_CB, (XtPointer *)toplevel );
               // DST compute frame
  Widget dst_computeFrame = XtVaCreateManagedWidget( "AFNI", 
    xmFrameWidgetClass, dstCol, NULL );  
  Widget dst_computeCol = XtVaCreateManagedWidget( "AFNI", 
    xmRowColumnWidgetClass, dst_computeFrame, 
    XmNorientation, XmVERTICAL,
    XmNpacking, XmPACK_TIGHT, 
    XmNtraversalOn, False, 
    XmNinitialResourcesPersistent, False, 
    XmNframeChildType, XmFRAME_WORKAREA_CHILD, NULL );
                   // choose seeds and target zone
  Widget seeds_target_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dst_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );

  xstr = XmStringCreateLtoR( "Choose Seeds", XmFONTLIST_DEFAULT_TAG ) ;
  dst_seeds_pb = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, seeds_target_row,
    XmNpacking, XmPACK_TIGHT,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_seeds_pb, XmNactivateCallback, DST_choose_CB,
    (XtPointer *)toplevel );

  xstr = XmStringCreateLtoR( "Choose Target Zone", XmFONTLIST_DEFAULT_TAG );
  dst_ftTarget_pb = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, seeds_target_row,
    XmNpacking, XmPACK_TIGHT,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_ftTarget_pb, XmNactivateCallback, DST_choose_CB,
    (XtPointer *)toplevel );
                   // DST thresholds=============================
		   // 1st row of thresholds
  Widget fa_dist_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dst_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
                   // FA
  Widget dst_fa_textbox = XtVaCreateManagedWidget( "AFNI",
    xmSpinBoxWidgetClass, fa_dist_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_fa_textbox, XmNvalueChangedCallback,
    DST_fa_CB, (XtPointer *)toplevel );
  Widget dst_fa_text = XtVaCreateManagedWidget( "AFNI",
    xmTextWidgetClass, dst_fa_textbox,
    XmNcolumns, 4,
    XmNeditable, False,
    XmNminimumValue, state.DST_THRESHOLD_MIN,
    XmNmaximumValue, state.DST_THRESHOLD_MAX,
    XmNposition, state.DST_THRESHOLD_DEFAULT_FA,
    XmNdecimalPoints, state.DST_THRESHOLD_DECIMAL_POINTS,
    XmNincrementValue, state.DST_THRESHOLD_INCR,
    XmNspinBoxChildType, XmNUMERIC,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "FA  ", XmFONTLIST_DEFAULT_TAG );
  Widget dst_fa_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, fa_dist_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
                   // distance ratio
  Widget dst_distRatio_textbox = XtVaCreateManagedWidget( "AFNI",
    xmSpinBoxWidgetClass, fa_dist_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_distRatio_textbox, XmNvalueChangedCallback,
    DST_distRatio_CB, (XtPointer *)toplevel );
  Widget dst_distRatio_text = XtVaCreateManagedWidget( "AFNI",
    xmTextWidgetClass, dst_distRatio_textbox,
    XmNcolumns, 4,
    XmNeditable, False,
    XmNminimumValue, state.DST_THRESHOLD_MIN,
    XmNmaximumValue, state.DST_THRESHOLD_MAX,
    XmNposition, state.DST_THRESHOLD_DEFAULT,
    XmNdecimalPoints, state.DST_THRESHOLD_DECIMAL_POINTS,
    XmNincrementValue, state.DST_THRESHOLD_INCR,
    XmNspinBoxChildType, XmNUMERIC,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Dist Ratio", XmFONTLIST_DEFAULT_TAG );
  Widget dst_distRatio_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, fa_dist_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
                   // 2nd row of thresholds
  Widget curv_coherence_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dst_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
                   // curvature constraint
  Widget dst_curv_textbox = XtVaCreateManagedWidget( "AFNI",
    xmSpinBoxWidgetClass, curv_coherence_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_curv_textbox, XmNvalueChangedCallback,
    DST_curv_CB, (XtPointer *)toplevel );
  Widget dst_curv_text = XtVaCreateManagedWidget( "AFNI",
    xmTextWidgetClass, dst_curv_textbox,
    XmNcolumns, 2,
    XmNeditable, False,
    XmNminimumValue, state.DST_THRESHOLD_MIN,
    XmNmaximumValue, state.DST_THRESHOLD_MAX_ANGLE,
    XmNposition, state.DST_THRESHOLD_DEFAULT_ANGLE,
    XmNincrementValue, state.DST_THRESHOLD_INCR_ANGLE,
    XmNspinBoxChildType, XmNUMERIC,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Curv Angle", XmFONTLIST_DEFAULT_TAG );
  Widget dst_curv_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, curv_coherence_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
                   // local coherence
  Widget dst_coher_textbox = XtVaCreateManagedWidget( "AFNI",
    xmSpinBoxWidgetClass, curv_coherence_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_coher_textbox, XmNvalueChangedCallback,
    DST_coher_CB, (XtPointer *)toplevel );
  Widget dst_coher_text = XtVaCreateManagedWidget( "AFNI",
    xmTextWidgetClass, dst_coher_textbox,
    XmNcolumns, 2,
    XmNeditable, False,
    XmNminimumValue, state.DST_THRESHOLD_MIN,
    XmNmaximumValue, state.DST_THRESHOLD_MAX_ANGLE,
    XmNposition, state.DST_THRESHOLD_DEFAULT_ANGLE,
    XmNincrementValue, state.DST_THRESHOLD_INCR_ANGLE,
    XmNspinBoxChildType, XmNUMERIC,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Coher Angle", XmFONTLIST_DEFAULT_TAG );
  Widget dst_coher_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, curv_coherence_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
                   // 3rd row of thresholds
  Widget dwi_b0_lo_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dst_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "B0 Lower" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget dst_b0_lo_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, dwi_b0_lo_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  state.dst_b0_slider[0] = XtVaCreateManagedWidget("AFNI", 
    xmScaleWidgetClass, dwi_b0_lo_row,
    XmNorientation, XmHORIZONTAL,
    XmNscaleWidth, 200,
    XmNscaleMultiple, 1,  // single step 
    XmNshowArrows, XmEACH_SIDE,
    XmNshowValue, XmNEAR_BORDER, NULL);
  XtAddCallback( state.dst_b0_slider[0], XmNvalueChangedCallback, 
    DST_b0_changed_CB, (XtPointer *)toplevel );

  Widget dwi_b0_hi_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dst_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "B0 Upper" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget dst_b0_hi_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, dwi_b0_hi_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  state.dst_b0_slider[1] = XtVaCreateManagedWidget("AFNI", 
    xmScaleWidgetClass, dwi_b0_hi_row,
    XmNorientation, XmHORIZONTAL,
    XmNscaleWidth, 200,
    XmNscaleMultiple, 1,  // single step 
    XmNshowArrows, XmEACH_SIDE,
    XmNshowValue, XmNEAR_BORDER, NULL);
  XtAddCallback( state.dst_b0_slider[1], XmNvalueChangedCallback, 
    DST_b0_changed_CB, (XtPointer *)toplevel );
                   // 4th row of thresholds
  integTime_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dst_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
                   // time for each diffusion integration
  Widget dst_integTime_textbox = XtVaCreateManagedWidget( "AFNI",
    xmSpinBoxWidgetClass, integTime_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_integTime_textbox, XmNvalueChangedCallback,
    DST_integTime_CB, (XtPointer *)toplevel );
  Widget dst_integTime_text = XtVaCreateManagedWidget( "AFNI",
    xmTextWidgetClass, dst_integTime_textbox,
    XmNcolumns, 6,
    XmNeditable, False,
    XmNminimumValue, state.DST_THRESHOLD_MIN_TIME,
    XmNmaximumValue, state.DST_THRESHOLD_MAX_TIME,
    XmNposition, state.DST_THRESHOLD_DEFAULT_TIME,
    XmNdecimalPoints, state.DST_THRESHOLD_DECIMAL_POINTS_TIME,
    XmNincrementValue, state.DST_THRESHOLD_INCR_TIME,
    XmNspinBoxChildType, XmNUMERIC,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Integ Time  ", XmFONTLIST_DEFAULT_TAG );
  Widget dst_integTime_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, integTime_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
 
  xstr = XmStringCreateLtoR( "Compute", XmFONTLIST_DEFAULT_TAG );
  Widget dst_compute_button = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, integTime_row,
    XmNpacking, XmPACK_TIGHT,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_compute_button, XmNactivateCallback, 
    DST_compute_CB, (XtPointer *)toplevel );
                   // DST view frame
  Widget dst_viewFrame = XtVaCreateManagedWidget( "AFNI", 
    xmFrameWidgetClass, dstCol, NULL );  
  Widget dst_viewCol = XtVaCreateManagedWidget( "AFNI", 
    xmRowColumnWidgetClass, dst_viewFrame, 
    XmNorientation, XmVERTICAL,
    XmNpacking, XmPACK_TIGHT, 
    XmNtraversalOn, False, 
    XmNinitialResourcesPersistent, False, 
    XmNframeChildType, 
    XmFRAME_WORKAREA_CHILD, NULL );
		 
  Widget view_clear_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dst_viewCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );

  xstr = XmStringCreateLtoR( "Choose Tract", XmFONTLIST_DEFAULT_TAG );
  dst_tract_pb = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, view_clear_row,
    XmNpacking, XmPACK_TIGHT,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_tract_pb, XmNactivateCallback, DST_choose_CB, 
    (XtPointer *)toplevel );
  
  xstr = XmStringCreateLtoR( "View", XmFONTLIST_DEFAULT_TAG );
  Widget dst_view_button = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, view_clear_row,
    XmNpacking, XmPACK_TIGHT,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_view_button, XmNactivateCallback, 
    DST_view_cb, (XtPointer *)toplevel );
 
  xstr = XmStringCreateLtoR( "Clear", XmFONTLIST_DEFAULT_TAG );
  Widget dst_clear_button = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, view_clear_row,
    XmNpacking, XmPACK_TIGHT,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_clear_button, XmNactivateCallback, 
    DST_clear_cb, (XtPointer *)toplevel );
               // button for showing tract stats
  (void) MCW_action_area( view_clear_row, DST_actor_stats, 1 );
  Widget dst_stats_pb = (Widget)DST_actor_stats[0].data;
               // streamtube view
  Widget view_tube_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dst_viewCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Streamtube", XmFONTLIST_DEFAULT_TAG );
  Widget dst_tube_button = XtVaCreateManagedWidget( "AFNI",
    xmToggleButtonWidgetClass, view_tube_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_tube_button, XmNvalueChangedCallback,
    DST_tubeToggle_CB, (XtPointer*)toplevel );
  
  Widget dst_tubeRadius_textbox = XtVaCreateManagedWidget( "AFNI", 
    xmSpinBoxWidgetClass, view_tube_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dst_tubeRadius_textbox, XmNvalueChangedCallback,
    DST_tubeRadius_changed_CB, (XtPointer*)toplevel );

  Widget dst_tubeRadius_text = XtVaCreateManagedWidget( "AFNI", 
    xmTextWidgetClass, dst_tubeRadius_textbox,
    XmNcolumns, 3,
    XmNeditable, False,
    XmNspinBoxChildType, XmNUMERIC,
    XmNminimumValue, state.MIN_TUBE_RADIUS,
    XmNmaximumValue, state.MAX_TUBE_RADIUS,
    XmNposition, state.DEFAULT_TUBE_RADIUS,
    XmNdecimalPoints, state.RADIUS_DECIMAL_POINTS,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Radius" , XmFONTLIST_DEFAULT_TAG );
  Widget tubeLabel = XtVaCreateManagedWidget( "AFNI", 
    xmLabelWidgetClass, view_tube_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
               // colorbar for fibers
  xstr = XmStringCreateLtoR( "Show Colorbar" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget dst_colorbar_button = XtVaCreateManagedWidget( "AFNI",
    xmToggleButtonWidgetClass, dst_viewCol,
    XmNlabelString, xstr,
    XmNset, False, NULL );
  XtAddCallback( dst_colorbar_button, XmNvalueChangedCallback,
    DST_colorbarToggle_CB, (XtPointer *)toplevel );
    
                   // update for dst_b0 slider
  int dst_b0_max = (int)dwi_dset->stats->bstat[0].max;
  int dst_b0_min = (int)dwi_dset->stats->bstat[0].min;
  for( int i = 0; i < 2; ++ i )
  {
    state.dst_b0_bound[i] = 0;
    sprintf( state.dst_b0_sliderText[i], "%d", state.dst_b0_bound[i] );
    XtVaSetValues( state.dst_b0_slider[i],
      XmNminimum, dst_b0_min,
      XmNmaximum, dst_b0_max,
      XmNvalue, state.dst_b0_bound[i], NULL );
  } 
               // control pane for 4th-order diffusion tensor
  Widget dt4_frame = XtVaCreateWidget( "AFNI" , 
    xmFrameWidgetClass , top_rowcol ,
    XmNshadowType , XmSHADOW_ETCHED_IN ,
    XmNshadowThickness , 5 ,
    XmNtraversalOn , False ,
    XmNinitialResourcesPersistent , False , NULL ) ;

  Widget dt4_col = XtVaCreateWidget( "AFNI" , 
    xmRowColumnWidgetClass , dt4_frame ,
    XmNorientation , XmVERTICAL ,
    XmNpacking     , XmPACK_TIGHT ,
    XmNadjustLast  , False ,
    XmNadjustMargin, False ,
    XmNtraversalOn , False ,
    XmNinitialResourcesPersistent , False ,
    XmNframeChildType, XmFRAME_WORKAREA_CHILD, NULL );

  dt4_help_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dt4_col,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "DST by 4th-Order Diffusion Tensor", 
    XmFONTLIST_DEFAULT_TAG );
  Widget dt4_label = XtVaCreateManagedWidget( "AFNI", 
    xmLabelWidgetClass, dt4_help_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL ); 
               // help button
  (void) MCW_action_area( dt4_help_row, DST_actor, 1 );
  Widget dt4_help_pb = (Widget)DST_actor[0].data;
               // DST_DT4 compute frame
  Widget dt4_computeFrame = XtVaCreateManagedWidget( "AFNI", 
    xmFrameWidgetClass, dt4_col, NULL );  
  Widget dt4_computeCol = XtVaCreateManagedWidget( "AFNI", 
    xmRowColumnWidgetClass, dt4_computeFrame, 
    XmNorientation, XmVERTICAL,
    XmNpacking, XmPACK_TIGHT, 
    XmNtraversalOn, False, 
    XmNinitialResourcesPersistent, False, 
    XmNframeChildType, XmFRAME_WORKAREA_CHILD, NULL );
               // choose 4th-order tensor
  Widget dt4_dset_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dt4_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );

  xstr = XmStringCreateLtoR( "Choose 4th-Order DT Dataset", 
    XmFONTLIST_DEFAULT_TAG );
  dt4_dset_pb = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, dt4_dset_row,
    XmNpacking, XmPACK_TIGHT,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dt4_dset_pb, XmNactivateCallback, DST_choose_CB,
    (XtPointer *)toplevel );
                   // choose seeds dataset
  Widget dt4_seeds_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dt4_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );

  xstr = XmStringCreateLtoR( "Choose Seeds Dataset", XmFONTLIST_DEFAULT_TAG );
  dt4_seeds_pb = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, dt4_seeds_row,
    XmNpacking, XmPACK_TIGHT,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dt4_seeds_pb, XmNactivateCallback, DST_choose_CB,
    (XtPointer *)toplevel );
               // GFA and Dist Ratio
  Widget dt4_gfa_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dt4_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
               // GFA threshold
  Widget dt4_gfa_textbox = XtVaCreateManagedWidget( "AFNI",
    xmSpinBoxWidgetClass, dt4_gfa_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dt4_gfa_textbox, XmNvalueChangedCallback,
    DST_dt4_gfa_CB, (XtPointer *)toplevel );
  Widget dt4_gfa_text = XtVaCreateManagedWidget( "AFNI",
    xmTextWidgetClass, dt4_gfa_textbox,
    XmNcolumns, 4,
    XmNeditable, False,
    XmNminimumValue, state.DST_THRESHOLD_MIN,
    XmNmaximumValue, state.DST_THRESHOLD_MAX,
    XmNposition, state.DST_THRESHOLD_DEFAULT_FA,
    XmNdecimalPoints, state.DST_THRESHOLD_DECIMAL_POINTS,
    XmNincrementValue, state.DST_THRESHOLD_INCR,
    XmNspinBoxChildType, XmNUMERIC,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "GFA  ", XmFONTLIST_DEFAULT_TAG );
  Widget dt4_gfa_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, dt4_gfa_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
               // threshold of distance ratio for 4th-order DT
  Widget dt4_distRatio_textbox = XtVaCreateManagedWidget( "AFNI",
    xmSpinBoxWidgetClass, dt4_gfa_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dt4_distRatio_textbox, XmNvalueChangedCallback,
    DST_dt4_distRatio_CB, (XtPointer *)toplevel );
  Widget dt4_distRatio_text = XtVaCreateManagedWidget( "AFNI",
    xmTextWidgetClass, dt4_distRatio_textbox,
    XmNcolumns, 4,
    XmNeditable, False,
    XmNminimumValue, state.DST_THRESHOLD_MIN,
    XmNmaximumValue, state.DST_THRESHOLD_MAX,
    XmNposition, state.DST_THRESHOLD_DEFAULT,
    XmNdecimalPoints, state.DST_THRESHOLD_DECIMAL_POINTS,
    XmNincrementValue, state.DST_THRESHOLD_INCR,
    XmNspinBoxChildType, XmNUMERIC,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Dist Ratio", XmFONTLIST_DEFAULT_TAG );
  Widget dt4_distRatio_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, dt4_gfa_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
               // threshold for transition angle between vectors
  Widget dt4_angle_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dt4_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  Widget dt4_transAngle_textbox = XtVaCreateManagedWidget( "AFNI",
    xmSpinBoxWidgetClass, dt4_angle_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dt4_transAngle_textbox, XmNvalueChangedCallback,
    DST_dt4_transAngle_CB, (XtPointer *)toplevel );
  Widget dt4_transAngle_text = XtVaCreateManagedWidget( "AFNI",
    xmTextWidgetClass, dt4_transAngle_textbox,
    XmNcolumns, 2,
    XmNeditable, False,
    XmNminimumValue, state.DST_THRESHOLD_MIN,
    XmNmaximumValue, state.DST_THRESHOLD_MAX_ANGLE,
    XmNposition, state.DST_THRESHOLD_DEFAULT_ANGLE,
    XmNincrementValue, state.DST_THRESHOLD_INCR_ANGLE,
    XmNspinBoxChildType, XmNUMERIC,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Transition Angle", XmFONTLIST_DEFAULT_TAG );
  Widget dt4_transAngle_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, dt4_angle_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
               // threshold for integration time threshold
  Widget dt4_integTime_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, dt4_computeCol,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
               // time for each diffusion integration
  Widget dt4_integTime_textbox = XtVaCreateManagedWidget( "AFNI",
    xmSpinBoxWidgetClass, dt4_integTime_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dt4_integTime_textbox, XmNvalueChangedCallback,
    DST_dt4_integTime_CB, (XtPointer *)toplevel );
  Widget dt4_integTime_text = XtVaCreateManagedWidget( "AFNI",
    xmTextWidgetClass, dt4_integTime_textbox,
    XmNcolumns, 6,
    XmNeditable, False,
    XmNminimumValue, state.DST_THRESHOLD_MIN_TIME,
    XmNmaximumValue, state.DST_THRESHOLD_MAX_TIME,
    XmNposition, state.DST_THRESHOLD_DEFAULT_TIME,
    XmNdecimalPoints, state.DST_THRESHOLD_DECIMAL_POINTS_TIME,
    XmNincrementValue, state.DST_THRESHOLD_INCR_TIME,
    XmNspinBoxChildType, XmNUMERIC,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Integ Time  ", XmFONTLIST_DEFAULT_TAG );
  Widget dt4_integTime_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, dt4_integTime_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
               // 4th-DT compute button
  xstr = XmStringCreateLtoR( "Compute", XmFONTLIST_DEFAULT_TAG );
  Widget dt4_compute_button = XtVaCreateManagedWidget( "AFNI",
    xmPushButtonWidgetClass, dt4_integTime_row,
    XmNpacking, XmPACK_TIGHT,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( dt4_compute_button, XmNactivateCallback, 
    DST_dt4_compute_CB, (XtPointer *)toplevel );

  XtManageChild( dt4_col);
  XtManageChild( dt4_frame );
  XtManageChild( dstCol);
  XtManageChild( frame );
  XtManageChild( top_rowcol );
  XtRealizeWidget( dst_shell );
               // pop the widget up
  XtMapWidget( dst_shell );
  PLUTO_cursorize( dst_shell );
  return;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


void streamline_controlPanel_CB( Widget w, XtPointer client_data, 
  XtPointer call_data )
{
  MCW_DC *dc = im3d->dc;      // display context
  Widget toplevel = NULL;
  XmString xstr;

  if( streamline_shell != NULL )
  {
    XtMapWidget( streamline_shell );
    PLUTO_cursorize( streamline_shell );
    return;
  }  

  streamline_shell = XtVaAppCreateShell( "AFNI", "AFNI", 
    topLevelShellWidgetClass, dc->display,
    XmNtitle, "Streamline Fiber Tracking",
    XmNiconName, "Streamline Control Panel",
    XmNdeleteResponse, XmUNMAP, //XmDESTROY,//XmDO_NOTHING,
    XmNallowShellResize, True,
    XmNmappedWhenManaged, False,
    XmNinitialResourcesPersistent, False, NULL);
  DC_yokify( streamline_shell, dc );  

  if( MCW_isitmwm(streamline_shell) )      // remove some MWM functions 
    XtVaSetValues( streamline_shell, XmNmwmFunctions ,
    MWM_FUNC_MOVE | MWM_FUNC_CLOSE | MWM_FUNC_MINIMIZE, NULL ) ;

  Widget top_rowcol = XtVaCreateWidget( "AFNI",
    xmRowColumnWidgetClass, streamline_shell,
    XmNorientation  , XmHORIZONTAL ,
    XmNpacking      , XmPACK_TIGHT ,
    XmNadjustLast   , False ,
    XmNadjustMargin , False ,
    XmNtraversalOn  , False ,
    XmNmarginWidth  , 0 ,
    XmNmarginHeight , 0 ,
    XmNinitialResourcesPersistent , False , NULL );

  Widget frame = XtVaCreateWidget( "AFNI", 
    xmFrameWidgetClass, top_rowcol,
    XmNshadowType, XmSHADOW_ETCHED_IN ,
    XmNshadowThickness, 5,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent , False , NULL );

  Widget streamCol = XtVaCreateWidget( "AFNI", 
    xmRowColumnWidgetClass, frame,
    XmNorientation , XmVERTICAL,
    XmNpacking     , XmPACK_TIGHT,
    XmNadjustLast  , False ,
    XmNadjustMargin, False ,
    XmNtraversalOn , False ,
    XmNinitialResourcesPersistent , False ,
    XmNframeChildType, XmFRAME_WORKAREA_CHILD, NULL );

  xstr = XmStringCreateLtoR( "Streamline Fiber Tracking", 
    XmFONTLIST_DEFAULT_TAG ) ;
  Widget streamLabel = XtVaCreateManagedWidget( "AFNI", 
     xmLabelWidgetClass, streamCol,
     XmNlabelString, xstr,
     XmNtraversalOn, False,
     XmNinitialResourcesPersistent, False, NULL );

  xstr = XmStringCreateLtoR( "Enable" , XmFONTLIST_DEFAULT_TAG );
  stream_button = XtVaCreateManagedWidget( "AFNI", 
    xmPushButtonWidgetClass, streamCol,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( stream_button, XmNactivateCallback, stream_cb,
    (XtPointer *)toplevel);

  Widget fa_step_frame = XtVaCreateManagedWidget( "AFNI", 
    xmFrameWidgetClass, streamCol, NULL );
  Widget fa_step_col = XtVaCreateManagedWidget( "AFNI", 
    xmRowColumnWidgetClass, fa_step_frame,
    XmNorientation, XmVERTICAL,
    XmNpacking, XmPACK_TIGHT ,
    XmNtraversalOn , False ,
    XmNinitialResourcesPersistent, False, NULL );
               // fa threshold
  Widget fa_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, fa_step_col,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL);
  Widget fa_textbox = XtVaCreateManagedWidget( "AFNI", 
    xmSpinBoxWidgetClass, fa_row,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( fa_textbox, XmNvalueChangedCallback, 
    streamline_fa_changed_cb, (XtPointer *)toplevel );
  Widget fa_text = XtVaCreateManagedWidget( "AFNI", 
    xmTextWidgetClass, fa_textbox,
    XmNcolumns, 4,
    XmNeditable, False,
    XmNminimumValue, state.DST_THRESHOLD_MIN,
    XmNmaximumValue, state.DST_THRESHOLD_MAX,
    XmNposition, state.DST_THRESHOLD_DEFAULT_FA,
    XmNdecimalPoints, state.DST_THRESHOLD_DECIMAL_POINTS,
    XmNincrementValue, state.DST_THRESHOLD_INCR,
    XmNspinBoxChildType, XmNUMERIC,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "FA threshold" , XmFONTLIST_DEFAULT_TAG );
  Widget fa_textlabel = XtVaCreateManagedWidget( "AFNI", 
    xmLabelWidgetClass, fa_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
               // integration step
  Widget stepLengthRow = XtVaCreateManagedWidget("AFNI", 
    xmRowColumnWidgetClass, fa_step_col,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False, NULL);
  Widget stepLength = XtVaCreateManagedWidget("AFNI", 
    xmSpinBoxWidgetClass, stepLengthRow,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False, NULL);
  XtAddCallback(stepLength,XmNvalueChangedCallback, 
		istep_changed_cb,(XtPointer *)toplevel);
  Widget stepLengthText = XtVaCreateManagedWidget("AFNI", 
    xmTextWidgetClass, stepLength,
			     XmNcolumns, 4,
			     XmNminimumValue, state.MIN_STEPLENGTH,
			     XmNmaximumValue, state.MAX_STEPLENGTH,
			     XmNposition, state.DEFAULT_STEPLENGTH,
			     XmNdecimalPoints, state.STEPLENGTH_DECIMAL_POINTS,
			     XmNspinBoxChildType, XmNUMERIC,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False, NULL);
  xstr = XmStringCreateLtoR( "Integ. step (mm)" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget stepLengthLabel = XtVaCreateManagedWidget("AFNI", 
    xmLabelWidgetClass, stepLengthRow,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False, NULL);
               // streamtube
  Widget tubeRow = XtVaCreateManagedWidget( "AFNI", 
    xmRowColumnWidgetClass, fa_step_col,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_TIGHT,
    XmNtraversalOn, False, 
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Streamtube" , XmFONTLIST_DEFAULT_TAG );
  Widget tubeButton = XtVaCreateManagedWidget( "AFNI", 
    xmToggleButtonWidgetClass, tubeRow,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( tubeButton, XmNvalueChangedCallback, tube_toggle_cb, 
    (XtPointer *)toplevel );
  Widget tubeRadius = XtVaCreateManagedWidget( "AFNI", 
    xmSpinBoxWidgetClass, tubeRow,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( tubeRadius, XmNvalueChangedCallback, radius_changed_cb,
    (XtPointer *)toplevel );
  Widget tubeRadiusText = XtVaCreateManagedWidget( "AFNI", 
    xmTextWidgetClass, tubeRadius,
    XmNcolumns, 3,
    XmNspinBoxChildType, XmNUMERIC,
    XmNminimumValue, state.MIN_TUBE_RADIUS,
    XmNmaximumValue, state.MAX_TUBE_RADIUS,
    XmNposition, state.DEFAULT_TUBE_RADIUS,
    XmNdecimalPoints, state.RADIUS_DECIMAL_POINTS,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Radius", XmFONTLIST_DEFAULT_TAG ) ;
  Widget tubeLabel = XtVaCreateManagedWidget( "AFNI", 
    xmLabelWidgetClass, tubeRow,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
#ifdef EXPERIMENTAL
  xstr = XmStringCreateLtoR( "Color by Curvature", XmFONTLIST_DEFAULT_TAG );
  Widget curvatureButton = XtVaCreateManagedWidget( "AFNI", 
    xmToggleButtonWidgetClass, streamCol,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( curvatureButton, XmNvalueChangedCallback, cbc_toggle_cb,
    (XtPointer *)toplevel );
#endif
               // probe frame
  Widget probeFrame = XtVaCreateManagedWidget( "AFNI", 
    xmFrameWidgetClass, streamCol, NULL );

  Widget probeCol = XtVaCreateManagedWidget( "AFNI", 
    xmRowColumnWidgetClass, probeFrame,
			     XmNorientation, XmVERTICAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent, False, NULL);

  xstr = XmStringCreateLtoR( "Probe Type" , XmFONTLIST_DEFAULT_TAG );
  Widget probeLabel = XtVaCreateManagedWidget("AFNI", 
    xmLabelWidgetClass, probeCol,
			     XmNlabelString, xstr,
			     XmNtraversalOn, False,
			     XmNinitialResourcesPersistent, False, NULL);

  Widget probeType = XtVaCreateManagedWidget("AFNI",
    xmRowColumnWidgetClass, probeCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_TIGHT,
			     XmNradioBehavior, True,
			     XmNradioAlwaysOne, True, NULL);

  xstr = XmStringCreateLtoR( "Point" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget pointToggle = XtVaCreateManagedWidget("AFNI",
    xmToggleButtonWidgetClass, probeType,
			     XmNlabelString, xstr,
			     /* XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     XmNindicatorType, XmONE_OF_MANY, */
			     XmNset, True, NULL ) ;
  XtAddCallback(pointToggle,XmNvalueChangedCallback, 
		pointprobe_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR( "Line" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget lineToggle = XtVaCreateManagedWidget("AFNI" ,
    xmToggleButtonWidgetClass, probeType ,
			     XmNlabelString , xstr, NULL ) ;
  XtAddCallback(lineToggle,XmNvalueChangedCallback, 
		lineprobe_cb,(XtPointer *)toplevel);

  xstr = XmStringCreateLtoR( "Plane" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget planeToggle = XtVaCreateManagedWidget("AFNI" , 
    xmToggleButtonWidgetClass, probeType,
			     XmNlabelString , xstr, NULL ) ;
  XtAddCallback(planeToggle,XmNvalueChangedCallback, 
		planeprobe_cb,(XtPointer *)toplevel);

  Widget resRow = XtVaCreateManagedWidget("AFNI", 
    xmRowColumnWidgetClass, probeCol,
			     XmNorientation, XmHORIZONTAL,
			     XmNpacking, XmPACK_TIGHT ,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False, NULL);
     
  Widget probeRes = XtVaCreateManagedWidget("AFNI", 
    xmSpinBoxWidgetClass, resRow,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False ,
			     NULL);
  XtAddCallback(probeRes,XmNvalueChangedCallback, 
		proberes_changed_cb,(XtPointer *)toplevel);

  Widget probeResText = XtVaCreateManagedWidget("AFNI", 
    xmTextWidgetClass, probeRes,
    XmNcolumns, 3,
    XmNspinBoxChildType, XmNUMERIC,
    XmNmaximumValue, state.MAX_PROBE_RES,
    XmNposition, state.DEFAULT_PROBE_RES,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL);

  xstr = XmStringCreateLtoR( "Plane Resolution" , XmFONTLIST_DEFAULT_TAG );
  Widget probeResLabel = XtVaCreateManagedWidget("AFNI", 
    xmLabelWidgetClass, resRow,
			     XmNlabelString, xstr,
			     XmNtraversalOn , False ,
			     XmNinitialResourcesPersistent , False, NULL);

  XtManageChild( streamCol);
  XtManageChild( frame );
  XtManageChild( top_rowcol );
  XtRealizeWidget( streamline_shell );
               // pop the widget up
  XtMapWidget( streamline_shell );
  PLUTO_cursorize( streamline_shell );
  return;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

void isoSurface_controlPanel_CB( Widget w, XtPointer client_data, 
  XtPointer call_data )
{
  MCW_DC *dc = im3d->dc;      // display context
  Widget toplevel = NULL;
  XmString xstr;

  if( isoSurface_shell != NULL )
  {
    XtMapWidget( isoSurface_shell );
    PLUTO_cursorize( isoSurface_shell );
    return;
  }  

  isoSurface_shell = XtVaAppCreateShell( "AFNI", "AFNI", 
    topLevelShellWidgetClass, dc->display,
    XmNtitle, "IsoSurface Rendering",
    XmNiconName, "IsoSurface Rendering Control Panel",
    XmNdeleteResponse, XmUNMAP, //XmDESTROY,//XmDO_NOTHING,
    XmNallowShellResize, True,
    XmNmappedWhenManaged, False,
    XmNinitialResourcesPersistent, False, NULL);
  DC_yokify( isoSurface_shell, dc );  

  if( MCW_isitmwm(isoSurface_shell) )      // remove some MWM functions 
    XtVaSetValues( isoSurface_shell, XmNmwmFunctions ,
    MWM_FUNC_MOVE | MWM_FUNC_CLOSE | MWM_FUNC_MINIMIZE, NULL ) ;

  Widget top_rowcol = XtVaCreateWidget( "AFNI",
    xmRowColumnWidgetClass, isoSurface_shell,
    XmNorientation  , XmHORIZONTAL ,
    XmNpacking      , XmPACK_TIGHT ,
    XmNadjustLast   , False ,
    XmNadjustMargin , False ,
    XmNtraversalOn  , False ,
    XmNmarginWidth  , 0 ,
    XmNmarginHeight , 0 ,
    XmNinitialResourcesPersistent , False , NULL );

  Widget frame = XtVaCreateWidget( "AFNI", 
    xmFrameWidgetClass, top_rowcol,
    XmNshadowType, XmSHADOW_ETCHED_IN ,
    XmNshadowThickness, 5,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent , False , NULL );

  Widget contourCol = XtVaCreateWidget( "AFNI", 
    xmRowColumnWidgetClass, frame,
    XmNorientation , XmVERTICAL,
    XmNpacking     , XmPACK_TIGHT,
    XmNadjustLast  , False ,
    XmNadjustMargin, False ,
    XmNtraversalOn , False ,
    XmNinitialResourcesPersistent , False ,
    XmNframeChildType, XmFRAME_WORKAREA_CHILD, NULL );

  xstr = XmStringCreateLtoR( "IsoSurface Rendering", 
    XmFONTLIST_DEFAULT_TAG ) ;
  Widget contourLabel = XtVaCreateManagedWidget( "AFNI", 
    xmLabelWidgetClass, contourCol,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );

  xstr = XmStringCreateLtoR( "Enable" , XmFONTLIST_DEFAULT_TAG );
  isoSurface_button = XtVaCreateManagedWidget( "AFNI", 
    xmPushButtonWidgetClass, contourCol,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  XtAddCallback( isoSurface_button, XmNactivateCallback, isoSurface_CB,
    (XtPointer *)toplevel);

  Widget isosurf_frame = XtVaCreateManagedWidget( "AFNI", 
    xmFrameWidgetClass, contourCol, NULL );
  Widget isosurf_col = XtVaCreateManagedWidget( "AFNI", 
    xmRowColumnWidgetClass, isosurf_frame,
    XmNorientation, XmVERTICAL,
    XmNpacking, XmPACK_TIGHT ,
    XmNtraversalOn , False ,
    XmNinitialResourcesPersistent, False, NULL );

               // isosurface value slider
  Widget isoValue_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, isosurf_col,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_COLUMN,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Iso-surface" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget isoValue_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, isoValue_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  state.isoSurface_value_slider = XtVaCreateManagedWidget("AFNI", 
    xmScaleWidgetClass, isoValue_row,
    XmNorientation, XmHORIZONTAL,
    XmNscaleWidth, 200,
//    XmNscaleMultiple, 1,  // single step 
    XmNdecimalPoints, UIState::ISOSURF_VALUE_DECIMAL_PTS,
    XmNshowArrows, XmEACH_SIDE,
    XmNshowValue, XmNEAR_BORDER, NULL);
  XtAddCallback( state.isoSurface_value_slider, XmNvalueChangedCallback, 
    isoSurface_value_changed_CB, (XtPointer *)toplevel );
               // update
  state.isosurf_value_max = anat_dset_range[1];	       
  state.isosurf_value_min = anat_dset_range[0];    
  int isovalue_max = (int)(state.isosurf_value_max *
    pow(10, UIState::ISOSURF_VALUE_DECIMAL_PTS));
  int isovalue_min = (int)(state.isosurf_value_min *
    pow(10, UIState::ISOSURF_VALUE_DECIMAL_PTS));
  sprintf( state.isoSurface_value_sliderText, "%f", 
    state.isoSurface_value );
  XtVaSetValues( state.isoSurface_value_slider,
    XmNminimum, isovalue_min,
    XmNmaximum, isovalue_max,
    XmNvalue, state.isoSurface_value, NULL );

               // isosurface opacity slider
  Widget opacity_row = XtVaCreateManagedWidget( "AFNI",
    xmRowColumnWidgetClass, isosurf_col,
    XmNorientation, XmHORIZONTAL,
    XmNpacking, XmPACK_COLUMN,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  xstr = XmStringCreateLtoR( "Opacity" , XmFONTLIST_DEFAULT_TAG ) ;
  Widget opacity_textlabel = XtVaCreateManagedWidget( "AFNI",
    xmLabelWidgetClass, opacity_row,
    XmNlabelString, xstr,
    XmNtraversalOn, False,
    XmNinitialResourcesPersistent, False, NULL );
  state.isoSurface_opacity_slider = XtVaCreateManagedWidget("AFNI", 
    xmScaleWidgetClass, opacity_row,
    XmNorientation, XmHORIZONTAL,
    XmNscaleWidth, 200,
//    XmNscaleMultiple, 1,  // single step 
    XmNdecimalPoints, UIState::ISOSURF_OPACITY_DECIMAL_PTS,
    XmNshowArrows, XmEACH_SIDE,
    XmNshowValue, XmNEAR_BORDER, NULL);
  XtAddCallback( state.isoSurface_opacity_slider, XmNvalueChangedCallback, 
    isoSurface_opacity_changed_CB, (XtPointer *)toplevel );
               // update 
  int isoopacity_max = (int)pow(10,UIState::ISOSURF_OPACITY_DECIMAL_PTS);       
  sprintf( state.isoSurface_opacity_sliderText, "%f", 
    state.isoSurface_opacity );
  XtVaSetValues( state.isoSurface_opacity_slider,
    XmNminimum, 0,
    XmNmaximum, isoopacity_max,
    XmNvalue, state.isoSurface_opacity, NULL );

  XtManageChild( contourCol);
  XtManageChild( frame );
  XtManageChild( top_rowcol );
  XtRealizeWidget( isoSurface_shell );
               // pop the widget up
  XtMapWidget( isoSurface_shell );
  PLUTO_cursorize( isoSurface_shell );
  return;

}

void isoSurface_value_changed_CB( Widget w, XtPointer client_data, XtPointer 
  call_data )
{
   state.isoSurface_value = 
      reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value/
      pow(10,UIState::ISOSURF_VALUE_DECIMAL_PTS);

   sprintf( state.isoSurface_value_sliderText, "%f", 
     state.isoSurface_value );

   if( DO_ISOSURFACE ) compute_isoSurface( w, client_data, call_data );
}

void isoSurface_opacity_changed_CB( Widget w, XtPointer client_data, XtPointer 
  call_data )
{
   state.isoSurface_opacity = 
      reinterpret_cast<XmScrollBarCallbackStruct*>(call_data)->value/
      pow(10,UIState::ISOSURF_OPACITY_DECIMAL_PTS);

   sprintf( state.isoSurface_opacity_sliderText, "%f", 
     state.isoSurface_opacity );

   if( DO_ISOSURFACE ) compute_isoSurface( w, client_data, call_data );
}

